/* indicator.c generated by valac 0.56.17, the Vala compiler
 * generated from indicator.vala, do not modify */

/*
 * This file is part of Haguichi, a graphical frontend for Hamachi.
 * Copyright (C) 2007-2024 Stephen Brandt <stephen@stephenbrandt.com>
 *
 * Haguichi is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published
 * by the Free Software Foundation, either version 3 of the License,
 * or (at your option) any later version.
 *
 * SPDX-License-Identifier: GPL-3.0-or-later
 */

#include <glib-object.h>
#include <gio/gio.h>
#include <glib.h>
#include <stdlib.h>
#include <string.h>
#include <adwaita.h>
#include <gtk/gtk.h>
#include <glib/gi18n-lib.h>
#include <gobject/gvaluecollector.h>

#define CONFIG_APP_ID "com.github.ztefn.haguichi"
#define CONFIG_APP_NAME "Haguichi"
#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define HAGUICHI_TYPE_INDICATOR (haguichi_indicator_get_type ())
#define HAGUICHI_INDICATOR(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), HAGUICHI_TYPE_INDICATOR, HaguichiIndicator))
#define HAGUICHI_INDICATOR_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), HAGUICHI_TYPE_INDICATOR, HaguichiIndicatorClass))
#define HAGUICHI_IS_INDICATOR(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), HAGUICHI_TYPE_INDICATOR))
#define HAGUICHI_IS_INDICATOR_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), HAGUICHI_TYPE_INDICATOR))
#define HAGUICHI_INDICATOR_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), HAGUICHI_TYPE_INDICATOR, HaguichiIndicatorClass))

typedef struct _HaguichiIndicator HaguichiIndicator;
typedef struct _HaguichiIndicatorClass HaguichiIndicatorClass;
typedef struct _HaguichiIndicatorPrivate HaguichiIndicatorPrivate;

#define TYPE_STATUS_NOTIFIER_ITEM (status_notifier_item_get_type ())
#define STATUS_NOTIFIER_ITEM(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_STATUS_NOTIFIER_ITEM, StatusNotifierItem))
#define STATUS_NOTIFIER_ITEM_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_STATUS_NOTIFIER_ITEM, StatusNotifierItemClass))
#define IS_STATUS_NOTIFIER_ITEM(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_STATUS_NOTIFIER_ITEM))
#define IS_STATUS_NOTIFIER_ITEM_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_STATUS_NOTIFIER_ITEM))
#define STATUS_NOTIFIER_ITEM_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_STATUS_NOTIFIER_ITEM, StatusNotifierItemClass))

typedef struct _StatusNotifierItem StatusNotifierItem;
typedef struct _StatusNotifierItemClass StatusNotifierItemClass;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))

#define HAGUICHI_TYPE_WINDOW (haguichi_window_get_type ())
#define HAGUICHI_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), HAGUICHI_TYPE_WINDOW, HaguichiWindow))
#define HAGUICHI_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), HAGUICHI_TYPE_WINDOW, HaguichiWindowClass))
#define HAGUICHI_IS_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), HAGUICHI_TYPE_WINDOW))
#define HAGUICHI_IS_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), HAGUICHI_TYPE_WINDOW))
#define HAGUICHI_WINDOW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), HAGUICHI_TYPE_WINDOW, HaguichiWindowClass))

typedef struct _HaguichiWindow HaguichiWindow;
typedef struct _HaguichiWindowClass HaguichiWindowClass;

#define TYPE_DBUS_STATUS_NOTIFIER_ICON_DATA (dbus_status_notifier_icon_data_get_type ())
typedef struct _DBusStatusNotifierIconData DBusStatusNotifierIconData;

#define TYPE_DBUS_STATUS_NOTIFIER_ITEM_TOOL_TIP (dbus_status_notifier_item_tool_tip_get_type ())
typedef struct _DBusStatusNotifierItemToolTip DBusStatusNotifierItemToolTip;
#define _g_variant_unref0(var) ((var == NULL) ? NULL : (var = (g_variant_unref (var), NULL)))
typedef struct _HaguichiParamSpecIndicator HaguichiParamSpecIndicator;

struct _HaguichiIndicator {
	GTypeInstance parent_instance;
	volatile int ref_count;
	HaguichiIndicatorPrivate * priv;
	StatusNotifierItem* item;
};

struct _HaguichiIndicatorClass {
	GTypeClass parent_class;
	void (*finalize) (HaguichiIndicator *self);
};

struct _HaguichiIndicatorPrivate {
	GMenu* menu;
	gint icon_num;
	gchar* icon_postfix;
};

struct _DBusStatusNotifierIconData {
	gint width;
	gint height;
	guint8* data;
	gint data_length1;
};

struct _DBusStatusNotifierItemToolTip {
	gchar* icon_name;
	DBusStatusNotifierIconData* icon;
	gint icon_length1;
	gchar* title;
	gchar* body;
};

struct _HaguichiParamSpecIndicator {
	GParamSpec parent_instance;
};

static gint HaguichiIndicator_private_offset;
static gpointer haguichi_indicator_parent_class = NULL;
VALA_EXTERN gchar* haguichi_current_desktop;
VALA_EXTERN HaguichiWindow* haguichi_win;

VALA_EXTERN gpointer haguichi_indicator_ref (gpointer instance);
VALA_EXTERN void haguichi_indicator_unref (gpointer instance);
VALA_EXTERN GParamSpec* haguichi_param_spec_indicator (const gchar* name,
                                           const gchar* nick,
                                           const gchar* blurb,
                                           GType object_type,
                                           GParamFlags flags);
VALA_EXTERN void haguichi_value_set_indicator (GValue* value,
                                   gpointer v_object);
VALA_EXTERN void haguichi_value_take_indicator (GValue* value,
                                    gpointer v_object);
VALA_EXTERN gpointer haguichi_value_get_indicator (const GValue* value);
VALA_EXTERN GType haguichi_indicator_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (HaguichiIndicator, haguichi_indicator_unref)
VALA_EXTERN GType status_notifier_item_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (StatusNotifierItem, g_object_unref)
VALA_EXTERN HaguichiIndicator* haguichi_indicator_new (void);
VALA_EXTERN HaguichiIndicator* haguichi_indicator_construct (GType object_type);
VALA_EXTERN StatusNotifierItem* status_notifier_item_new (void);
VALA_EXTERN StatusNotifierItem* status_notifier_item_construct (GType object_type);
VALA_EXTERN void status_notifier_item_set_id (StatusNotifierItem* self,
                                  const gchar* value);
VALA_EXTERN void status_notifier_item_set_category (StatusNotifierItem* self,
                                        const gchar* value);
VALA_EXTERN void status_notifier_item_set_title (StatusNotifierItem* self,
                                     const gchar* value);
VALA_EXTERN void status_notifier_item_set_icon_name (StatusNotifierItem* self,
                                         const gchar* value);
VALA_EXTERN void status_notifier_item_set_status (StatusNotifierItem* self,
                                      const gchar* value);
VALA_EXTERN void status_notifier_item_set_is_menu (StatusNotifierItem* self,
                                       gboolean value);
static void __lambda63_ (HaguichiIndicator* self,
                  gint delta,
                  const gchar* orientation);
VALA_EXTERN GType haguichi_window_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (HaguichiWindow, g_object_unref)
static void ___lambda63__status_notifier_item_scroll (StatusNotifierItem* _sender,
                                               gint delta,
                                               const gchar* orientation,
                                               gpointer self);
static void __lambda64_ (HaguichiIndicator* self);
VALA_EXTERN gboolean status_notifier_item_get_host_registered (StatusNotifierItem* self);
VALA_EXTERN void status_notifier_item_register (StatusNotifierItem* self);
static void ___lambda64__g_object_notify (GObject* _sender,
                                   GParamSpec* pspec,
                                   gpointer self);
VALA_EXTERN void status_notifier_item_init (StatusNotifierItem* self);
VALA_EXTERN void haguichi_indicator_update_status (HaguichiIndicator* self,
                                       const gchar* mode,
                                       gboolean modal,
                                       gboolean visible);
static void haguichi_indicator_set_icon (HaguichiIndicator* self,
                                  const gchar* mode);
VALA_EXTERN GType dbus_status_notifier_icon_data_get_type (void) G_GNUC_CONST ;
VALA_EXTERN DBusStatusNotifierIconData* dbus_status_notifier_icon_data_dup (const DBusStatusNotifierIconData* self);
VALA_EXTERN void dbus_status_notifier_icon_data_free (DBusStatusNotifierIconData* self);
VALA_EXTERN void dbus_status_notifier_icon_data_copy (const DBusStatusNotifierIconData* self,
                                          DBusStatusNotifierIconData* dest);
VALA_EXTERN void dbus_status_notifier_icon_data_destroy (DBusStatusNotifierIconData* self);
G_DEFINE_AUTO_CLEANUP_CLEAR_FUNC (DBusStatusNotifierIconData, dbus_status_notifier_icon_data_destroy)
VALA_EXTERN GType dbus_status_notifier_item_tool_tip_get_type (void) G_GNUC_CONST ;
VALA_EXTERN DBusStatusNotifierItemToolTip* dbus_status_notifier_item_tool_tip_dup (const DBusStatusNotifierItemToolTip* self);
VALA_EXTERN void dbus_status_notifier_item_tool_tip_free (DBusStatusNotifierItemToolTip* self);
VALA_EXTERN void dbus_status_notifier_item_tool_tip_copy (const DBusStatusNotifierItemToolTip* self,
                                              DBusStatusNotifierItemToolTip* dest);
VALA_EXTERN void dbus_status_notifier_item_tool_tip_destroy (DBusStatusNotifierItemToolTip* self);
G_DEFINE_AUTO_CLEANUP_CLEAR_FUNC (DBusStatusNotifierItemToolTip, dbus_status_notifier_item_tool_tip_destroy)
static void _vala_DBusStatusNotifierIconData_array_free (DBusStatusNotifierIconData * array,
                                                  gssize array_length);
VALA_EXTERN void status_notifier_item_set_tool_tip (StatusNotifierItem* self,
                                        DBusStatusNotifierItemToolTip* value);
static GVariant* _variant_new3 (const gchar* value);
static GVariant* _variant_new4 (gint value);
static GVariant* _variant_new5 (gboolean value);
static GVariant* _variant_new6 (const gchar* value);
static GVariant* _variant_new7 (gboolean value);
static void haguichi_indicator_set_menu_item_icon_name (HaguichiIndicator* self,
                                                 GMenuItem* menu_item,
                                                 const gchar* icon_name);
static GVariant* _variant_new8 (gboolean value);
static GVariant* _variant_new9 (gboolean value);
static GVariant* _variant_new10 (gboolean value);
VALA_EXTERN void status_notifier_item_set_menu_model (StatusNotifierItem* self,
                                          GMenuModel* value);
static GVariant* _variant_new11 (const gchar* value);
static const gchar* haguichi_indicator_get_icon_name (HaguichiIndicator* self);
static gboolean haguichi_indicator_switch_icon (HaguichiIndicator* self);
static gboolean _haguichi_indicator_switch_icon_gsource_func (gpointer self);
static void haguichi_indicator_set_icon_name (HaguichiIndicator* self,
                                       const gchar* value);
VALA_EXTERN gchar* haguichi_window_get_mode (HaguichiWindow* self);
VALA_EXTERN gboolean haguichi_indicator_get_active (HaguichiIndicator* self);
VALA_EXTERN const gchar* status_notifier_item_get_status (StatusNotifierItem* self);
VALA_EXTERN void haguichi_indicator_set_active (HaguichiIndicator* self,
                                    gboolean value);
VALA_EXTERN const gchar* status_notifier_item_get_icon_name (StatusNotifierItem* self);
static void haguichi_indicator_finalize (HaguichiIndicator * obj);
static GType haguichi_indicator_get_type_once (void);

static inline gpointer
haguichi_indicator_get_instance_private (HaguichiIndicator* self)
{
	return G_STRUCT_MEMBER_P (self, HaguichiIndicator_private_offset);
}

static gboolean
string_contains (const gchar* self,
                 const gchar* needle)
{
	gchar* _tmp0_;
	gboolean result;
#line 1584 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1584 "glib-2.0.vapi"
	g_return_val_if_fail (needle != NULL, FALSE);
#line 1585 "glib-2.0.vapi"
	_tmp0_ = strstr ((gchar*) self, (gchar*) needle);
#line 1585 "glib-2.0.vapi"
	result = _tmp0_ != NULL;
#line 1585 "glib-2.0.vapi"
	return result;
#line 252 "indicator.c"
}

static void
__lambda63_ (HaguichiIndicator* self,
             gint delta,
             const gchar* orientation)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
	gboolean _tmp2_;
#line 40 "../src/indicator.vala"
	g_return_if_fail (orientation != NULL);
#line 41 "../src/indicator.vala"
	g_debug ("indicator.vala:41: scroll delta %d, orientation %s", delta, orientation);
#line 42 "../src/indicator.vala"
	_tmp0_ = g_utf8_strdown (orientation, (gssize) -1);
#line 42 "../src/indicator.vala"
	_tmp1_ = _tmp0_;
#line 42 "../src/indicator.vala"
	_tmp2_ = g_strcmp0 (_tmp1_, "vertical") != 0;
#line 42 "../src/indicator.vala"
	_g_free0 (_tmp1_);
#line 42 "../src/indicator.vala"
	if (_tmp2_) {
#line 42 "../src/indicator.vala"
		return;
#line 279 "indicator.c"
	}
#line 45 "../src/indicator.vala"
	if (delta < 0) {
#line 283 "indicator.c"
		HaguichiWindow* _tmp3_;
#line 46 "../src/indicator.vala"
		_tmp3_ = haguichi_win;
#line 46 "../src/indicator.vala"
		gtk_window_present ((GtkWindow*) _tmp3_);
#line 289 "indicator.c"
	} else {
#line 47 "../src/indicator.vala"
		if (delta > 0) {
#line 293 "indicator.c"
			HaguichiWindow* _tmp4_;
#line 48 "../src/indicator.vala"
			_tmp4_ = haguichi_win;
#line 48 "../src/indicator.vala"
			gtk_widget_hide ((GtkWidget*) _tmp4_);
#line 299 "indicator.c"
		}
	}
}

static void
___lambda63__status_notifier_item_scroll (StatusNotifierItem* _sender,
                                          gint delta,
                                          const gchar* orientation,
                                          gpointer self)
{
#line 40 "../src/indicator.vala"
	__lambda63_ ((HaguichiIndicator*) self, delta, orientation);
#line 312 "indicator.c"
}

static void
__lambda64_ (HaguichiIndicator* self)
{
	StatusNotifierItem* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
#line 52 "../src/indicator.vala"
	_tmp0_ = self->item;
#line 52 "../src/indicator.vala"
	_tmp1_ = status_notifier_item_get_host_registered (_tmp0_);
#line 52 "../src/indicator.vala"
	_tmp2_ = _tmp1_;
#line 52 "../src/indicator.vala"
	if (_tmp2_) {
#line 329 "indicator.c"
		StatusNotifierItem* _tmp3_;
#line 53 "../src/indicator.vala"
		_tmp3_ = self->item;
#line 53 "../src/indicator.vala"
		status_notifier_item_register (_tmp3_);
#line 335 "indicator.c"
	}
}

static void
___lambda64__g_object_notify (GObject* _sender,
                              GParamSpec* pspec,
                              gpointer self)
{
#line 51 "../src/indicator.vala"
	__lambda64_ ((HaguichiIndicator*) self);
#line 346 "indicator.c"
}

HaguichiIndicator*
haguichi_indicator_construct (GType object_type)
{
	HaguichiIndicator* self = NULL;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_ = FALSE;
	const gchar* _tmp3_;
	gchar* _tmp8_;
	gchar* _tmp9_;
	gchar* _tmp10_;
	const gchar* _tmp11_;
	gchar* _tmp12_;
	gchar* _tmp13_;
	StatusNotifierItem* _tmp14_ = NULL;
	StatusNotifierItem* _tmp15_;
	StatusNotifierItem* _tmp16_;
	StatusNotifierItem* _tmp17_;
#line 23 "../src/indicator.vala"
	self = (HaguichiIndicator*) g_type_create_instance (object_type);
#line 25 "../src/indicator.vala"
	_tmp3_ = haguichi_current_desktop;
#line 25 "../src/indicator.vala"
	if (string_contains (_tmp3_, "GNOME")) {
#line 25 "../src/indicator.vala"
		_tmp2_ = TRUE;
#line 375 "indicator.c"
	} else {
		const gchar* _tmp4_;
#line 26 "../src/indicator.vala"
		_tmp4_ = haguichi_current_desktop;
#line 26 "../src/indicator.vala"
		_tmp2_ = g_strcmp0 (_tmp4_, "MATE") == 0;
#line 382 "indicator.c"
	}
#line 25 "../src/indicator.vala"
	if (_tmp2_) {
#line 25 "../src/indicator.vala"
		_tmp1_ = TRUE;
#line 388 "indicator.c"
	} else {
		const gchar* _tmp5_;
#line 27 "../src/indicator.vala"
		_tmp5_ = haguichi_current_desktop;
#line 27 "../src/indicator.vala"
		_tmp1_ = g_strcmp0 (_tmp5_, "Pantheon") == 0;
#line 395 "indicator.c"
	}
#line 25 "../src/indicator.vala"
	if (_tmp1_) {
#line 25 "../src/indicator.vala"
		_tmp0_ = TRUE;
#line 401 "indicator.c"
	} else {
		const gchar* _tmp6_;
#line 28 "../src/indicator.vala"
		_tmp6_ = haguichi_current_desktop;
#line 28 "../src/indicator.vala"
		_tmp0_ = g_strcmp0 (_tmp6_, "X-Cinnamon") == 0;
#line 408 "indicator.c"
	}
#line 25 "../src/indicator.vala"
	if (_tmp0_) {
#line 412 "indicator.c"
		gchar* _tmp7_;
#line 29 "../src/indicator.vala"
		_tmp7_ = g_strdup ("-symbolic");
#line 29 "../src/indicator.vala"
		_g_free0 (self->priv->icon_postfix);
#line 29 "../src/indicator.vala"
		self->priv->icon_postfix = _tmp7_;
#line 420 "indicator.c"
	}
#line 32 "../src/indicator.vala"
	_tmp8_ = g_strdup (CONFIG_APP_ID ".indicator");
#line 32 "../src/indicator.vala"
	_tmp9_ = g_strdup ("ApplicationStatus");
#line 32 "../src/indicator.vala"
	_tmp10_ = g_strdup (CONFIG_APP_NAME);
#line 32 "../src/indicator.vala"
	_tmp11_ = self->priv->icon_postfix;
#line 32 "../src/indicator.vala"
	_tmp12_ = g_strconcat (CONFIG_APP_ID "-disconnected", _tmp11_, NULL);
#line 32 "../src/indicator.vala"
	_tmp13_ = g_strdup ("Active");
#line 32 "../src/indicator.vala"
	_tmp14_ = status_notifier_item_new ();
#line 32 "../src/indicator.vala"
	status_notifier_item_set_id (_tmp14_, _tmp8_);
#line 32 "../src/indicator.vala"
	_g_free0 (_tmp8_);
#line 32 "../src/indicator.vala"
	status_notifier_item_set_category (_tmp14_, _tmp9_);
#line 32 "../src/indicator.vala"
	_g_free0 (_tmp9_);
#line 32 "../src/indicator.vala"
	status_notifier_item_set_title (_tmp14_, _tmp10_);
#line 32 "../src/indicator.vala"
	_g_free0 (_tmp10_);
#line 32 "../src/indicator.vala"
	status_notifier_item_set_icon_name (_tmp14_, _tmp12_);
#line 32 "../src/indicator.vala"
	_g_free0 (_tmp12_);
#line 32 "../src/indicator.vala"
	status_notifier_item_set_status (_tmp14_, _tmp13_);
#line 32 "../src/indicator.vala"
	_g_free0 (_tmp13_);
#line 32 "../src/indicator.vala"
	status_notifier_item_set_is_menu (_tmp14_, TRUE);
#line 32 "../src/indicator.vala"
	_g_object_unref0 (self->item);
#line 32 "../src/indicator.vala"
	self->item = _tmp14_;
#line 40 "../src/indicator.vala"
	_tmp15_ = self->item;
#line 40 "../src/indicator.vala"
	g_signal_connect (_tmp15_, "scroll", (GCallback) ___lambda63__status_notifier_item_scroll, self);
#line 51 "../src/indicator.vala"
	_tmp16_ = self->item;
#line 51 "../src/indicator.vala"
	g_signal_connect ((GObject*) _tmp16_, "notify::host-registered", (GCallback) ___lambda64__g_object_notify, self);
#line 57 "../src/indicator.vala"
	_tmp17_ = self->item;
#line 57 "../src/indicator.vala"
	status_notifier_item_init (_tmp17_);
#line 23 "../src/indicator.vala"
	return self;
#line 476 "indicator.c"
}

HaguichiIndicator*
haguichi_indicator_new (void)
{
#line 23 "../src/indicator.vala"
	return haguichi_indicator_construct (HAGUICHI_TYPE_INDICATOR);
#line 484 "indicator.c"
}

static void
_vala_DBusStatusNotifierIconData_array_free (DBusStatusNotifierIconData * array,
                                             gssize array_length)
{
#line 85 "../src/indicator.vala"
	if (array != NULL) {
#line 493 "indicator.c"
		gssize i;
#line 85 "../src/indicator.vala"
		for (i = 0; i < array_length; i = i + 1) {
#line 85 "../src/indicator.vala"
			dbus_status_notifier_icon_data_destroy (&array[i]);
#line 499 "indicator.c"
		}
	}
#line 85 "../src/indicator.vala"
	g_free (array);
#line 504 "indicator.c"
}

static GVariant*
_variant_new3 (const gchar* value)
{
#line 93 "../src/indicator.vala"
	return g_variant_ref_sink (g_variant_new_string (value));
#line 512 "indicator.c"
}

static GVariant*
_variant_new4 (gint value)
{
#line 94 "../src/indicator.vala"
	return g_variant_ref_sink (g_variant_new_int32 (value));
#line 520 "indicator.c"
}

static GVariant*
_variant_new5 (gboolean value)
{
#line 95 "../src/indicator.vala"
	return g_variant_ref_sink (g_variant_new_boolean (value));
#line 528 "indicator.c"
}

static GVariant*
_variant_new6 (const gchar* value)
{
#line 99 "../src/indicator.vala"
	return g_variant_ref_sink (g_variant_new_string (value));
#line 536 "indicator.c"
}

static GVariant*
_variant_new7 (gboolean value)
{
#line 105 "../src/indicator.vala"
	return g_variant_ref_sink (g_variant_new_boolean (value));
#line 544 "indicator.c"
}

static GVariant*
_variant_new8 (gboolean value)
{
#line 112 "../src/indicator.vala"
	return g_variant_ref_sink (g_variant_new_boolean (value));
#line 552 "indicator.c"
}

static GVariant*
_variant_new9 (gboolean value)
{
#line 117 "../src/indicator.vala"
	return g_variant_ref_sink (g_variant_new_boolean (value));
#line 560 "indicator.c"
}

static GVariant*
_variant_new10 (gboolean value)
{
#line 124 "../src/indicator.vala"
	return g_variant_ref_sink (g_variant_new_boolean (value));
#line 568 "indicator.c"
}

void
haguichi_indicator_update_status (HaguichiIndicator* self,
                                  const gchar* mode,
                                  gboolean modal,
                                  gboolean visible)
{
	const gchar* _tmp0_ = NULL;
	gchar* status_text = NULL;
	gchar* _tmp2_;
	StatusNotifierItem* _tmp3_;
	DBusStatusNotifierIconData* _tmp4_;
	DBusStatusNotifierIconData* _tmp5_;
	gint _tmp5__length1;
	const gchar* _tmp6_;
	DBusStatusNotifierItemToolTip _tmp7_ = {0};
	GMenu* _tmp8_;
	GMenuItem* show = NULL;
	GMenuItem* _tmp9_;
	GMenuItem* _tmp10_;
	GVariant* _tmp11_;
	GMenuItem* _tmp12_;
	GVariant* _tmp13_;
	GMenuItem* _tmp14_;
	GVariant* _tmp15_;
	GMenu* _tmp16_;
	GMenuItem* _tmp17_;
	GMenuItem* separator = NULL;
	GMenuItem* _tmp18_;
	GMenuItem* _tmp19_;
	GVariant* _tmp20_;
	GMenu* _tmp21_;
	GMenuItem* _tmp22_;
	gchar* _tmp23_;
	gchar* _tmp24_;
	gboolean _tmp25_;
	GMenuItem* quit = NULL;
	GMenuItem* _tmp64_;
	GMenu* _tmp65_;
	StatusNotifierItem* _tmp66_;
	GMenu* _tmp67_;
#line 81 "../src/indicator.vala"
	g_return_if_fail (self != NULL);
#line 81 "../src/indicator.vala"
	g_return_if_fail (mode != NULL);
#line 82 "../src/indicator.vala"
	haguichi_indicator_set_icon (self, mode);
#line 84 "../src/indicator.vala"
	if (g_strcmp0 (mode, "Connected") == 0) {
#line 84 "../src/indicator.vala"
		_tmp0_ = _ ("Connected");
#line 621 "indicator.c"
	} else {
		const gchar* _tmp1_ = NULL;
#line 84 "../src/indicator.vala"
		if (g_strcmp0 (mode, "Connecting") == 0) {
#line 84 "../src/indicator.vala"
			_tmp1_ = _ ("Connecting");
#line 628 "indicator.c"
		} else {
#line 84 "../src/indicator.vala"
			_tmp1_ = _ ("Disconnected");
#line 632 "indicator.c"
		}
#line 84 "../src/indicator.vala"
		_tmp0_ = _tmp1_;
#line 636 "indicator.c"
	}
#line 84 "../src/indicator.vala"
	_tmp2_ = g_strdup (_tmp0_);
#line 84 "../src/indicator.vala"
	status_text = _tmp2_;
#line 85 "../src/indicator.vala"
	_tmp3_ = self->item;
#line 85 "../src/indicator.vala"
	_tmp4_ = g_new0 (DBusStatusNotifierIconData, 0);
#line 85 "../src/indicator.vala"
	_tmp5_ = _tmp4_;
#line 85 "../src/indicator.vala"
	_tmp5__length1 = 0;
#line 85 "../src/indicator.vala"
	_tmp6_ = status_text;
#line 85 "../src/indicator.vala"
	_g_free0 (_tmp7_.icon_name);
#line 85 "../src/indicator.vala"
	_tmp7_.icon_name = CONFIG_APP_ID;
#line 85 "../src/indicator.vala"
	_tmp7_.icon = (_vala_DBusStatusNotifierIconData_array_free (_tmp7_.icon, _tmp7_.icon_length1), NULL);
#line 85 "../src/indicator.vala"
	_tmp7_.icon = _tmp5_;
#line 85 "../src/indicator.vala"
	_tmp7_.icon_length1 = 0;
#line 85 "../src/indicator.vala"
	_g_free0 (_tmp7_.title);
#line 85 "../src/indicator.vala"
	_tmp7_.title = CONFIG_APP_NAME;
#line 85 "../src/indicator.vala"
	_g_free0 (_tmp7_.body);
#line 85 "../src/indicator.vala"
	_tmp7_.body = _tmp6_;
#line 85 "../src/indicator.vala"
	status_notifier_item_set_tool_tip (_tmp3_, &_tmp7_);
#line 85 "../src/indicator.vala"
	_tmp5_ = (_vala_DBusStatusNotifierIconData_array_free (_tmp5_, _tmp5__length1), NULL);
#line 90 "../src/indicator.vala"
	_tmp8_ = g_menu_new ();
#line 90 "../src/indicator.vala"
	_g_object_unref0 (self->priv->menu);
#line 90 "../src/indicator.vala"
	self->priv->menu = _tmp8_;
#line 92 "../src/indicator.vala"
	_tmp9_ = g_menu_item_new (_ ("_Show Haguichi"), "app.toggle-window");
#line 92 "../src/indicator.vala"
	show = _tmp9_;
#line 93 "../src/indicator.vala"
	_tmp10_ = show;
#line 93 "../src/indicator.vala"
	_tmp11_ = _variant_new3 ("checkmark");
#line 93 "../src/indicator.vala"
	g_menu_item_set_attribute_value (_tmp10_, "toggle-type", _tmp11_);
#line 93 "../src/indicator.vala"
	_g_variant_unref0 (_tmp11_);
#line 94 "../src/indicator.vala"
	_tmp12_ = show;
#line 94 "../src/indicator.vala"
	_tmp13_ = _variant_new4 ((gint) visible);
#line 94 "../src/indicator.vala"
	g_menu_item_set_attribute_value (_tmp12_, "toggle-state", _tmp13_);
#line 94 "../src/indicator.vala"
	_g_variant_unref0 (_tmp13_);
#line 95 "../src/indicator.vala"
	_tmp14_ = show;
#line 95 "../src/indicator.vala"
	_tmp15_ = _variant_new5 (!modal);
#line 95 "../src/indicator.vala"
	g_menu_item_set_attribute_value (_tmp14_, "enabled", _tmp15_);
#line 95 "../src/indicator.vala"
	_g_variant_unref0 (_tmp15_);
#line 96 "../src/indicator.vala"
	_tmp16_ = self->priv->menu;
#line 96 "../src/indicator.vala"
	_tmp17_ = show;
#line 96 "../src/indicator.vala"
	g_menu_append_item (_tmp16_, _tmp17_);
#line 98 "../src/indicator.vala"
	_tmp18_ = g_menu_item_new (NULL, NULL);
#line 98 "../src/indicator.vala"
	separator = _tmp18_;
#line 99 "../src/indicator.vala"
	_tmp19_ = separator;
#line 99 "../src/indicator.vala"
	_tmp20_ = _variant_new6 ("separator");
#line 99 "../src/indicator.vala"
	g_menu_item_set_attribute_value (_tmp19_, "type", _tmp20_);
#line 99 "../src/indicator.vala"
	_g_variant_unref0 (_tmp20_);
#line 100 "../src/indicator.vala"
	_tmp21_ = self->priv->menu;
#line 100 "../src/indicator.vala"
	_tmp22_ = separator;
#line 100 "../src/indicator.vala"
	g_menu_append_item (_tmp21_, _tmp22_);
#line 102 "../src/indicator.vala"
	_tmp23_ = g_utf8_strdown (mode, (gssize) -1);
#line 102 "../src/indicator.vala"
	_tmp24_ = _tmp23_;
#line 102 "../src/indicator.vala"
	_tmp25_ = string_contains (_tmp24_, "connect");
#line 102 "../src/indicator.vala"
	_g_free0 (_tmp24_);
#line 102 "../src/indicator.vala"
	if (_tmp25_) {
#line 742 "indicator.c"
		const gchar* _tmp26_ = NULL;
		const gchar* _tmp27_ = NULL;
		GMenuItem* connect = NULL;
		GMenuItem* _tmp28_;
		gboolean _tmp29_ = FALSE;
		GMenuItem* _tmp30_;
		GVariant* _tmp31_;
		const gchar* _tmp32_ = NULL;
		GMenuItem* _tmp33_;
		gchar* _tmp34_;
		gchar* _tmp35_;
		GMenu* _tmp36_;
		GMenuItem* _tmp37_;
		GMenu* _tmp38_;
		GMenuItem* _tmp39_;
		GMenuItem* join = NULL;
		GMenuItem* _tmp40_;
		gboolean _tmp41_ = FALSE;
		GMenuItem* _tmp42_;
		GVariant* _tmp43_;
		GMenuItem* _tmp44_;
		GMenu* _tmp45_;
		GMenuItem* _tmp46_;
		GMenuItem* create = NULL;
		GMenuItem* _tmp47_;
		gboolean _tmp48_ = FALSE;
		GMenuItem* _tmp49_;
		GVariant* _tmp50_;
		GMenuItem* _tmp51_;
		GMenu* _tmp52_;
		GMenuItem* _tmp53_;
		GMenu* _tmp54_;
		GMenuItem* _tmp55_;
		GMenuItem* info = NULL;
		GMenuItem* _tmp56_;
		GMenuItem* _tmp57_;
		GVariant* _tmp58_;
		GMenuItem* _tmp59_;
		GMenu* _tmp60_;
		GMenuItem* _tmp61_;
		GMenu* _tmp62_;
		GMenuItem* _tmp63_;
#line 103 "../src/indicator.vala"
		if (g_strcmp0 (mode, "Connected") == 0) {
#line 103 "../src/indicator.vala"
			_tmp26_ = _ ("_Disconnect");
#line 789 "indicator.c"
		} else {
#line 103 "../src/indicator.vala"
			_tmp26_ = _ ("C_onnect");
#line 793 "indicator.c"
		}
#line 104 "../src/indicator.vala"
		if (g_strcmp0 (mode, "Connected") == 0) {
#line 104 "../src/indicator.vala"
			_tmp27_ = "app.disconnect";
#line 799 "indicator.c"
		} else {
#line 104 "../src/indicator.vala"
			_tmp27_ = "app.connect";
#line 803 "indicator.c"
		}
#line 103 "../src/indicator.vala"
		_tmp28_ = g_menu_item_new (_tmp26_, _tmp27_);
#line 103 "../src/indicator.vala"
		connect = _tmp28_;
#line 105 "../src/indicator.vala"
		if (!modal) {
#line 105 "../src/indicator.vala"
			_tmp29_ = g_strcmp0 (mode, "Connecting") != 0;
#line 813 "indicator.c"
		} else {
#line 105 "../src/indicator.vala"
			_tmp29_ = FALSE;
#line 817 "indicator.c"
		}
#line 105 "../src/indicator.vala"
		_tmp30_ = connect;
#line 105 "../src/indicator.vala"
		_tmp31_ = _variant_new7 (_tmp29_);
#line 105 "../src/indicator.vala"
		g_menu_item_set_attribute_value (_tmp30_, "enabled", _tmp31_);
#line 105 "../src/indicator.vala"
		_g_variant_unref0 (_tmp31_);
#line 106 "../src/indicator.vala"
		if (g_strcmp0 (mode, "Connected") == 0) {
#line 106 "../src/indicator.vala"
			_tmp32_ = "disconnect";
#line 831 "indicator.c"
		} else {
#line 106 "../src/indicator.vala"
			_tmp32_ = "connect";
#line 835 "indicator.c"
		}
#line 106 "../src/indicator.vala"
		_tmp33_ = connect;
#line 106 "../src/indicator.vala"
		_tmp34_ = g_strconcat ("network-", _tmp32_, NULL);
#line 106 "../src/indicator.vala"
		_tmp35_ = _tmp34_;
#line 106 "../src/indicator.vala"
		haguichi_indicator_set_menu_item_icon_name (self, _tmp33_, _tmp35_);
#line 106 "../src/indicator.vala"
		_g_free0 (_tmp35_);
#line 107 "../src/indicator.vala"
		_tmp36_ = self->priv->menu;
#line 107 "../src/indicator.vala"
		_tmp37_ = connect;
#line 107 "../src/indicator.vala"
		g_menu_append_item (_tmp36_, _tmp37_);
#line 109 "../src/indicator.vala"
		_tmp38_ = self->priv->menu;
#line 109 "../src/indicator.vala"
		_tmp39_ = separator;
#line 109 "../src/indicator.vala"
		g_menu_append_item (_tmp38_, _tmp39_);
#line 111 "../src/indicator.vala"
		_tmp40_ = g_menu_item_new (_ ("_Join Network…"), "app.join-network");
#line 111 "../src/indicator.vala"
		join = _tmp40_;
#line 112 "../src/indicator.vala"
		if (!modal) {
#line 112 "../src/indicator.vala"
			_tmp41_ = g_strcmp0 (mode, "Connected") == 0;
#line 867 "indicator.c"
		} else {
#line 112 "../src/indicator.vala"
			_tmp41_ = FALSE;
#line 871 "indicator.c"
		}
#line 112 "../src/indicator.vala"
		_tmp42_ = join;
#line 112 "../src/indicator.vala"
		_tmp43_ = _variant_new8 (_tmp41_);
#line 112 "../src/indicator.vala"
		g_menu_item_set_attribute_value (_tmp42_, "enabled", _tmp43_);
#line 112 "../src/indicator.vala"
		_g_variant_unref0 (_tmp43_);
#line 113 "../src/indicator.vala"
		_tmp44_ = join;
#line 113 "../src/indicator.vala"
		haguichi_indicator_set_menu_item_icon_name (self, _tmp44_, "list-add");
#line 114 "../src/indicator.vala"
		_tmp45_ = self->priv->menu;
#line 114 "../src/indicator.vala"
		_tmp46_ = join;
#line 114 "../src/indicator.vala"
		g_menu_append_item (_tmp45_, _tmp46_);
#line 116 "../src/indicator.vala"
		_tmp47_ = g_menu_item_new (_ ("_Create Network…"), "app.create-network");
#line 116 "../src/indicator.vala"
		create = _tmp47_;
#line 117 "../src/indicator.vala"
		if (!modal) {
#line 117 "../src/indicator.vala"
			_tmp48_ = g_strcmp0 (mode, "Connected") == 0;
#line 899 "indicator.c"
		} else {
#line 117 "../src/indicator.vala"
			_tmp48_ = FALSE;
#line 903 "indicator.c"
		}
#line 117 "../src/indicator.vala"
		_tmp49_ = create;
#line 117 "../src/indicator.vala"
		_tmp50_ = _variant_new9 (_tmp48_);
#line 117 "../src/indicator.vala"
		g_menu_item_set_attribute_value (_tmp49_, "enabled", _tmp50_);
#line 117 "../src/indicator.vala"
		_g_variant_unref0 (_tmp50_);
#line 118 "../src/indicator.vala"
		_tmp51_ = create;
#line 118 "../src/indicator.vala"
		haguichi_indicator_set_menu_item_icon_name (self, _tmp51_, "list-add");
#line 119 "../src/indicator.vala"
		_tmp52_ = self->priv->menu;
#line 119 "../src/indicator.vala"
		_tmp53_ = create;
#line 119 "../src/indicator.vala"
		g_menu_append_item (_tmp52_, _tmp53_);
#line 121 "../src/indicator.vala"
		_tmp54_ = self->priv->menu;
#line 121 "../src/indicator.vala"
		_tmp55_ = separator;
#line 121 "../src/indicator.vala"
		g_menu_append_item (_tmp54_, _tmp55_);
#line 123 "../src/indicator.vala"
		_tmp56_ = g_menu_item_new (_ ("_Information"), "app.info");
#line 123 "../src/indicator.vala"
		info = _tmp56_;
#line 124 "../src/indicator.vala"
		_tmp57_ = info;
#line 124 "../src/indicator.vala"
		_tmp58_ = _variant_new10 (!modal);
#line 124 "../src/indicator.vala"
		g_menu_item_set_attribute_value (_tmp57_, "enabled", _tmp58_);
#line 124 "../src/indicator.vala"
		_g_variant_unref0 (_tmp58_);
#line 125 "../src/indicator.vala"
		_tmp59_ = info;
#line 125 "../src/indicator.vala"
		haguichi_indicator_set_menu_item_icon_name (self, _tmp59_, "documentinfo");
#line 126 "../src/indicator.vala"
		_tmp60_ = self->priv->menu;
#line 126 "../src/indicator.vala"
		_tmp61_ = info;
#line 126 "../src/indicator.vala"
		g_menu_append_item (_tmp60_, _tmp61_);
#line 128 "../src/indicator.vala"
		_tmp62_ = self->priv->menu;
#line 128 "../src/indicator.vala"
		_tmp63_ = separator;
#line 128 "../src/indicator.vala"
		g_menu_append_item (_tmp62_, _tmp63_);
#line 102 "../src/indicator.vala"
		_g_object_unref0 (info);
#line 102 "../src/indicator.vala"
		_g_object_unref0 (create);
#line 102 "../src/indicator.vala"
		_g_object_unref0 (join);
#line 102 "../src/indicator.vala"
		_g_object_unref0 (connect);
#line 965 "indicator.c"
	}
#line 131 "../src/indicator.vala"
	_tmp64_ = g_menu_item_new (_ ("_Quit"), "app.quit");
#line 131 "../src/indicator.vala"
	quit = _tmp64_;
#line 132 "../src/indicator.vala"
	haguichi_indicator_set_menu_item_icon_name (self, quit, "application-exit");
#line 133 "../src/indicator.vala"
	_tmp65_ = self->priv->menu;
#line 133 "../src/indicator.vala"
	g_menu_append_item (_tmp65_, quit);
#line 135 "../src/indicator.vala"
	_tmp66_ = self->item;
#line 135 "../src/indicator.vala"
	_tmp67_ = self->priv->menu;
#line 135 "../src/indicator.vala"
	status_notifier_item_set_menu_model (_tmp66_, (GMenuModel*) _tmp67_);
#line 81 "../src/indicator.vala"
	_g_object_unref0 (quit);
#line 81 "../src/indicator.vala"
	_g_object_unref0 (separator);
#line 81 "../src/indicator.vala"
	_g_object_unref0 (show);
#line 81 "../src/indicator.vala"
	_g_free0 (status_text);
#line 991 "indicator.c"
}

static GVariant*
_variant_new11 (const gchar* value)
{
#line 141 "../src/indicator.vala"
	return g_variant_ref_sink (g_variant_new_string (value));
#line 999 "indicator.c"
}

static void
haguichi_indicator_set_menu_item_icon_name (HaguichiIndicator* self,
                                            GMenuItem* menu_item,
                                            const gchar* icon_name)
{
	const gchar* _tmp0_;
#line 138 "../src/indicator.vala"
	g_return_if_fail (self != NULL);
#line 138 "../src/indicator.vala"
	g_return_if_fail (menu_item != NULL);
#line 138 "../src/indicator.vala"
	g_return_if_fail (icon_name != NULL);
#line 140 "../src/indicator.vala"
	_tmp0_ = haguichi_current_desktop;
#line 140 "../src/indicator.vala"
	if (g_strcmp0 (_tmp0_, "KDE") == 0) {
#line 1018 "indicator.c"
		GVariant* _tmp1_;
#line 141 "../src/indicator.vala"
		_tmp1_ = _variant_new11 (icon_name);
#line 141 "../src/indicator.vala"
		g_menu_item_set_attribute_value (menu_item, "icon-name", _tmp1_);
#line 141 "../src/indicator.vala"
		_g_variant_unref0 (_tmp1_);
#line 1026 "indicator.c"
	}
}

static gboolean
_haguichi_indicator_switch_icon_gsource_func (gpointer self)
{
	gboolean result;
	result = haguichi_indicator_switch_icon ((HaguichiIndicator*) self);
#line 155 "../src/indicator.vala"
	return result;
#line 1037 "indicator.c"
}

static void
haguichi_indicator_set_icon (HaguichiIndicator* self,
                             const gchar* mode)
{
	gboolean _tmp0_ = FALSE;
	const gchar* _tmp3_;
	GQuark _tmp5_ = 0U;
#line 153 "../src/indicator.vala"
	static GQuark _tmp4_label0 = 0;
#line 153 "../src/indicator.vala"
	static GQuark _tmp4_label1 = 0;
#line 145 "../src/indicator.vala"
	g_return_if_fail (self != NULL);
#line 145 "../src/indicator.vala"
	g_return_if_fail (mode != NULL);
#line 147 "../src/indicator.vala"
	if (g_strcmp0 (mode, "Connecting") == 0) {
#line 1057 "indicator.c"
		const gchar* _tmp1_;
		const gchar* _tmp2_;
#line 147 "../src/indicator.vala"
		_tmp1_ = haguichi_indicator_get_icon_name (self);
#line 147 "../src/indicator.vala"
		_tmp2_ = _tmp1_;
#line 147 "../src/indicator.vala"
		_tmp0_ = string_contains (_tmp2_, "-connecting-");
#line 1066 "indicator.c"
	} else {
#line 147 "../src/indicator.vala"
		_tmp0_ = FALSE;
#line 1070 "indicator.c"
	}
#line 147 "../src/indicator.vala"
	if (_tmp0_) {
#line 148 "../src/indicator.vala"
		return;
#line 1076 "indicator.c"
	}
#line 151 "../src/indicator.vala"
	self->priv->icon_num = 0;
#line 153 "../src/indicator.vala"
	_tmp3_ = mode;
#line 153 "../src/indicator.vala"
	_tmp5_ = (NULL == _tmp3_) ? 0 : g_quark_from_string (_tmp3_);
#line 153 "../src/indicator.vala"
	if (_tmp5_ == ((0 != _tmp4_label0) ? _tmp4_label0 : (_tmp4_label0 = g_quark_from_static_string ("Connecting")))) {
#line 153 "../src/indicator.vala"
		switch (0) {
#line 1088 "indicator.c"
			default:
			{
#line 155 "../src/indicator.vala"
				g_timeout_add_full (G_PRIORITY_DEFAULT, (guint) 400, _haguichi_indicator_switch_icon_gsource_func, haguichi_indicator_ref (self), haguichi_indicator_unref);
#line 156 "../src/indicator.vala"
				break;
#line 1095 "indicator.c"
			}
		}
	} else if (_tmp5_ == ((0 != _tmp4_label1) ? _tmp4_label1 : (_tmp4_label1 = g_quark_from_static_string ("Connected")))) {
#line 153 "../src/indicator.vala"
		switch (0) {
#line 1101 "indicator.c"
			default:
			{
#line 158 "../src/indicator.vala"
				haguichi_indicator_set_icon_name (self, "connected");
#line 159 "../src/indicator.vala"
				break;
#line 1108 "indicator.c"
			}
		}
	} else {
#line 153 "../src/indicator.vala"
		switch (0) {
#line 1114 "indicator.c"
			default:
			{
#line 161 "../src/indicator.vala"
				haguichi_indicator_set_icon_name (self, "disconnected");
#line 162 "../src/indicator.vala"
				break;
#line 1121 "indicator.c"
			}
		}
	}
}

static gboolean
haguichi_indicator_switch_icon (HaguichiIndicator* self)
{
	HaguichiWindow* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gboolean _tmp3_;
	gboolean result;
#line 166 "../src/indicator.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 168 "../src/indicator.vala"
	_tmp0_ = haguichi_win;
#line 168 "../src/indicator.vala"
	_tmp1_ = haguichi_window_get_mode (_tmp0_);
#line 168 "../src/indicator.vala"
	_tmp2_ = _tmp1_;
#line 168 "../src/indicator.vala"
	_tmp3_ = g_strcmp0 (_tmp2_, "Connecting") != 0;
#line 168 "../src/indicator.vala"
	_g_free0 (_tmp2_);
#line 168 "../src/indicator.vala"
	if (_tmp3_) {
#line 169 "../src/indicator.vala"
		result = FALSE;
#line 169 "../src/indicator.vala"
		return result;
#line 1153 "indicator.c"
	}
#line 172 "../src/indicator.vala"
	switch (self->priv->icon_num) {
#line 172 "../src/indicator.vala"
		case 0:
#line 1159 "indicator.c"
		{
#line 174 "../src/indicator.vala"
			haguichi_indicator_set_icon_name (self, "connecting-1");
#line 175 "../src/indicator.vala"
			self->priv->icon_num = 1;
#line 176 "../src/indicator.vala"
			break;
#line 1167 "indicator.c"
		}
#line 172 "../src/indicator.vala"
		case 1:
#line 1171 "indicator.c"
		{
#line 178 "../src/indicator.vala"
			haguichi_indicator_set_icon_name (self, "connecting-2");
#line 179 "../src/indicator.vala"
			self->priv->icon_num = 2;
#line 180 "../src/indicator.vala"
			break;
#line 1179 "indicator.c"
		}
		default:
		{
#line 182 "../src/indicator.vala"
			haguichi_indicator_set_icon_name (self, "connecting-3");
#line 183 "../src/indicator.vala"
			self->priv->icon_num = 0;
#line 184 "../src/indicator.vala"
			break;
#line 1189 "indicator.c"
		}
	}
#line 187 "../src/indicator.vala"
	result = TRUE;
#line 187 "../src/indicator.vala"
	return result;
#line 1196 "indicator.c"
}

gboolean
haguichi_indicator_get_active (HaguichiIndicator* self)
{
	gboolean result;
	StatusNotifierItem* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
#line 61 "../src/indicator.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 62 "../src/indicator.vala"
	_tmp0_ = self->item;
#line 62 "../src/indicator.vala"
	_tmp1_ = status_notifier_item_get_status (_tmp0_);
#line 62 "../src/indicator.vala"
	_tmp2_ = _tmp1_;
#line 62 "../src/indicator.vala"
	result = g_strcmp0 (_tmp2_, "Active") == 0;
#line 62 "../src/indicator.vala"
	return result;
#line 1218 "indicator.c"
}

void
haguichi_indicator_set_active (HaguichiIndicator* self,
                               gboolean value)
{
	const gchar* _tmp1_ = NULL;
	StatusNotifierItem* _tmp2_;
#line 64 "../src/indicator.vala"
	g_return_if_fail (self != NULL);
#line 65 "../src/indicator.vala"
	if (value) {
#line 1231 "indicator.c"
		StatusNotifierItem* _tmp0_;
#line 66 "../src/indicator.vala"
		_tmp0_ = self->item;
#line 66 "../src/indicator.vala"
		status_notifier_item_register (_tmp0_);
#line 1237 "indicator.c"
	}
#line 68 "../src/indicator.vala"
	if (value == TRUE) {
#line 68 "../src/indicator.vala"
		_tmp1_ = "Active";
#line 1243 "indicator.c"
	} else {
#line 68 "../src/indicator.vala"
		_tmp1_ = "Passive";
#line 1247 "indicator.c"
	}
#line 68 "../src/indicator.vala"
	_tmp2_ = self->item;
#line 68 "../src/indicator.vala"
	status_notifier_item_set_status (_tmp2_, _tmp1_);
#line 1253 "indicator.c"
}

static const gchar*
haguichi_indicator_get_icon_name (HaguichiIndicator* self)
{
	const gchar* result;
	StatusNotifierItem* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
#line 73 "../src/indicator.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 74 "../src/indicator.vala"
	_tmp0_ = self->item;
#line 74 "../src/indicator.vala"
	_tmp1_ = status_notifier_item_get_icon_name (_tmp0_);
#line 74 "../src/indicator.vala"
	_tmp2_ = _tmp1_;
#line 74 "../src/indicator.vala"
	result = _tmp2_;
#line 74 "../src/indicator.vala"
	return result;
#line 1275 "indicator.c"
}

static void
haguichi_indicator_set_icon_name (HaguichiIndicator* self,
                                  const gchar* value)
{
	StatusNotifierItem* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	const gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
#line 76 "../src/indicator.vala"
	g_return_if_fail (self != NULL);
#line 77 "../src/indicator.vala"
	_tmp0_ = self->item;
#line 77 "../src/indicator.vala"
	_tmp1_ = g_strconcat (CONFIG_APP_ID "-", value, NULL);
#line 77 "../src/indicator.vala"
	_tmp2_ = _tmp1_;
#line 77 "../src/indicator.vala"
	_tmp3_ = self->priv->icon_postfix;
#line 77 "../src/indicator.vala"
	_tmp4_ = g_strconcat (_tmp2_, _tmp3_, NULL);
#line 77 "../src/indicator.vala"
	_tmp5_ = _tmp4_;
#line 77 "../src/indicator.vala"
	status_notifier_item_set_icon_name (_tmp0_, _tmp5_);
#line 77 "../src/indicator.vala"
	_g_free0 (_tmp5_);
#line 77 "../src/indicator.vala"
	_g_free0 (_tmp2_);
#line 1308 "indicator.c"
}

static void
haguichi_value_indicator_init (GValue* value)
{
#line 16 "../src/indicator.vala"
	value->data[0].v_pointer = NULL;
#line 1316 "indicator.c"
}

static void
haguichi_value_indicator_free_value (GValue* value)
{
#line 16 "../src/indicator.vala"
	if (value->data[0].v_pointer) {
#line 16 "../src/indicator.vala"
		haguichi_indicator_unref (value->data[0].v_pointer);
#line 1326 "indicator.c"
	}
}

static void
haguichi_value_indicator_copy_value (const GValue* src_value,
                                     GValue* dest_value)
{
#line 16 "../src/indicator.vala"
	if (src_value->data[0].v_pointer) {
#line 16 "../src/indicator.vala"
		dest_value->data[0].v_pointer = haguichi_indicator_ref (src_value->data[0].v_pointer);
#line 1338 "indicator.c"
	} else {
#line 16 "../src/indicator.vala"
		dest_value->data[0].v_pointer = NULL;
#line 1342 "indicator.c"
	}
}

static gpointer
haguichi_value_indicator_peek_pointer (const GValue* value)
{
#line 16 "../src/indicator.vala"
	return value->data[0].v_pointer;
#line 1351 "indicator.c"
}

static gchar*
haguichi_value_indicator_collect_value (GValue* value,
                                        guint n_collect_values,
                                        GTypeCValue* collect_values,
                                        guint collect_flags)
{
#line 16 "../src/indicator.vala"
	if (collect_values[0].v_pointer) {
#line 1362 "indicator.c"
		HaguichiIndicator * object;
		object = collect_values[0].v_pointer;
#line 16 "../src/indicator.vala"
		if (object->parent_instance.g_class == NULL) {
#line 16 "../src/indicator.vala"
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 1369 "indicator.c"
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
#line 16 "../src/indicator.vala"
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 1373 "indicator.c"
		}
#line 16 "../src/indicator.vala"
		value->data[0].v_pointer = haguichi_indicator_ref (object);
#line 1377 "indicator.c"
	} else {
#line 16 "../src/indicator.vala"
		value->data[0].v_pointer = NULL;
#line 1381 "indicator.c"
	}
#line 16 "../src/indicator.vala"
	return NULL;
#line 1385 "indicator.c"
}

static gchar*
haguichi_value_indicator_lcopy_value (const GValue* value,
                                      guint n_collect_values,
                                      GTypeCValue* collect_values,
                                      guint collect_flags)
{
	HaguichiIndicator ** object_p;
	object_p = collect_values[0].v_pointer;
#line 16 "../src/indicator.vala"
	if (!object_p) {
#line 16 "../src/indicator.vala"
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
#line 1400 "indicator.c"
	}
#line 16 "../src/indicator.vala"
	if (!value->data[0].v_pointer) {
#line 16 "../src/indicator.vala"
		*object_p = NULL;
#line 1406 "indicator.c"
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
#line 16 "../src/indicator.vala"
		*object_p = value->data[0].v_pointer;
#line 1410 "indicator.c"
	} else {
#line 16 "../src/indicator.vala"
		*object_p = haguichi_indicator_ref (value->data[0].v_pointer);
#line 1414 "indicator.c"
	}
#line 16 "../src/indicator.vala"
	return NULL;
#line 1418 "indicator.c"
}

GParamSpec*
haguichi_param_spec_indicator (const gchar* name,
                               const gchar* nick,
                               const gchar* blurb,
                               GType object_type,
                               GParamFlags flags)
{
	HaguichiParamSpecIndicator* spec;
#line 16 "../src/indicator.vala"
	g_return_val_if_fail (g_type_is_a (object_type, HAGUICHI_TYPE_INDICATOR), NULL);
#line 16 "../src/indicator.vala"
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
#line 16 "../src/indicator.vala"
	G_PARAM_SPEC (spec)->value_type = object_type;
#line 16 "../src/indicator.vala"
	return G_PARAM_SPEC (spec);
#line 1437 "indicator.c"
}

gpointer
haguichi_value_get_indicator (const GValue* value)
{
#line 16 "../src/indicator.vala"
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, HAGUICHI_TYPE_INDICATOR), NULL);
#line 16 "../src/indicator.vala"
	return value->data[0].v_pointer;
#line 1447 "indicator.c"
}

void
haguichi_value_set_indicator (GValue* value,
                              gpointer v_object)
{
	HaguichiIndicator * old;
#line 16 "../src/indicator.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, HAGUICHI_TYPE_INDICATOR));
#line 16 "../src/indicator.vala"
	old = value->data[0].v_pointer;
#line 16 "../src/indicator.vala"
	if (v_object) {
#line 16 "../src/indicator.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, HAGUICHI_TYPE_INDICATOR));
#line 16 "../src/indicator.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 16 "../src/indicator.vala"
		value->data[0].v_pointer = v_object;
#line 16 "../src/indicator.vala"
		haguichi_indicator_ref (value->data[0].v_pointer);
#line 1469 "indicator.c"
	} else {
#line 16 "../src/indicator.vala"
		value->data[0].v_pointer = NULL;
#line 1473 "indicator.c"
	}
#line 16 "../src/indicator.vala"
	if (old) {
#line 16 "../src/indicator.vala"
		haguichi_indicator_unref (old);
#line 1479 "indicator.c"
	}
}

void
haguichi_value_take_indicator (GValue* value,
                               gpointer v_object)
{
	HaguichiIndicator * old;
#line 16 "../src/indicator.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, HAGUICHI_TYPE_INDICATOR));
#line 16 "../src/indicator.vala"
	old = value->data[0].v_pointer;
#line 16 "../src/indicator.vala"
	if (v_object) {
#line 16 "../src/indicator.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, HAGUICHI_TYPE_INDICATOR));
#line 16 "../src/indicator.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 16 "../src/indicator.vala"
		value->data[0].v_pointer = v_object;
#line 1500 "indicator.c"
	} else {
#line 16 "../src/indicator.vala"
		value->data[0].v_pointer = NULL;
#line 1504 "indicator.c"
	}
#line 16 "../src/indicator.vala"
	if (old) {
#line 16 "../src/indicator.vala"
		haguichi_indicator_unref (old);
#line 1510 "indicator.c"
	}
}

static void
haguichi_indicator_class_init (HaguichiIndicatorClass * klass,
                               gpointer klass_data)
{
#line 16 "../src/indicator.vala"
	haguichi_indicator_parent_class = g_type_class_peek_parent (klass);
#line 16 "../src/indicator.vala"
	((HaguichiIndicatorClass *) klass)->finalize = haguichi_indicator_finalize;
#line 16 "../src/indicator.vala"
	g_type_class_adjust_private_offset (klass, &HaguichiIndicator_private_offset);
#line 1524 "indicator.c"
}

static void
haguichi_indicator_instance_init (HaguichiIndicator * self,
                                  gpointer klass)
{
#line 16 "../src/indicator.vala"
	self->priv = haguichi_indicator_get_instance_private (self);
#line 16 "../src/indicator.vala"
	self->ref_count = 1;
#line 1535 "indicator.c"
}

static void
haguichi_indicator_finalize (HaguichiIndicator * obj)
{
	HaguichiIndicator * self;
#line 16 "../src/indicator.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, HAGUICHI_TYPE_INDICATOR, HaguichiIndicator);
#line 16 "../src/indicator.vala"
	g_signal_handlers_destroy (self);
#line 17 "../src/indicator.vala"
	_g_object_unref0 (self->priv->menu);
#line 19 "../src/indicator.vala"
	_g_free0 (self->priv->icon_postfix);
#line 21 "../src/indicator.vala"
	_g_object_unref0 (self->item);
#line 1552 "indicator.c"
}

static GType
haguichi_indicator_get_type_once (void)
{
	static const GTypeValueTable g_define_type_value_table = { haguichi_value_indicator_init, haguichi_value_indicator_free_value, haguichi_value_indicator_copy_value, haguichi_value_indicator_peek_pointer, "p", haguichi_value_indicator_collect_value, "p", haguichi_value_indicator_lcopy_value };
	static const GTypeInfo g_define_type_info = { sizeof (HaguichiIndicatorClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) haguichi_indicator_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (HaguichiIndicator), 0, (GInstanceInitFunc) haguichi_indicator_instance_init, &g_define_type_value_table };
	static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
	GType haguichi_indicator_type_id;
	haguichi_indicator_type_id = g_type_register_fundamental (g_type_fundamental_next (), "HaguichiIndicator", &g_define_type_info, &g_define_type_fundamental_info, 0);
	HaguichiIndicator_private_offset = g_type_add_instance_private (haguichi_indicator_type_id, sizeof (HaguichiIndicatorPrivate));
	return haguichi_indicator_type_id;
}

GType
haguichi_indicator_get_type (void)
{
	static volatile gsize haguichi_indicator_type_id__once = 0;
	if (g_once_init_enter (&haguichi_indicator_type_id__once)) {
		GType haguichi_indicator_type_id;
		haguichi_indicator_type_id = haguichi_indicator_get_type_once ();
		g_once_init_leave (&haguichi_indicator_type_id__once, haguichi_indicator_type_id);
	}
	return haguichi_indicator_type_id__once;
}

gpointer
haguichi_indicator_ref (gpointer instance)
{
	HaguichiIndicator * self;
	self = instance;
#line 16 "../src/indicator.vala"
	g_atomic_int_inc (&self->ref_count);
#line 16 "../src/indicator.vala"
	return instance;
#line 1588 "indicator.c"
}

void
haguichi_indicator_unref (gpointer instance)
{
	HaguichiIndicator * self;
	self = instance;
#line 16 "../src/indicator.vala"
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
#line 16 "../src/indicator.vala"
		HAGUICHI_INDICATOR_GET_CLASS (self)->finalize (self);
#line 16 "../src/indicator.vala"
		g_type_free_instance ((GTypeInstance *) self);
#line 1602 "indicator.c"
	}
}

