/* inhibitor.c generated by valac 0.56.17, the Vala compiler
 * generated from inhibitor.vala, do not modify */

/*
 * This file is part of Haguichi, a graphical frontend for Hamachi.
 * Copyright (C) 2007-2024 Stephen Brandt <stephen@stephenbrandt.com>
 *
 * Haguichi is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published
 * by the Free Software Foundation, either version 3 of the License,
 * or (at your option) any later version.
 *
 * SPDX-License-Identifier: GPL-3.0-or-later
 */

#include <glib-object.h>
#include <gio/gio.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <gio/gunixinputstream.h>
#include <gio/gunixfdlist.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define HAGUICHI_TYPE_LOGIND_MANAGER (haguichi_logind_manager_get_type ())
#define HAGUICHI_LOGIND_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), HAGUICHI_TYPE_LOGIND_MANAGER, HaguichiLogindManager))
#define HAGUICHI_IS_LOGIND_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), HAGUICHI_TYPE_LOGIND_MANAGER))
#define HAGUICHI_LOGIND_MANAGER_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), HAGUICHI_TYPE_LOGIND_MANAGER, HaguichiLogindManagerIface))

typedef struct _HaguichiLogindManager HaguichiLogindManager;
typedef struct _HaguichiLogindManagerIface HaguichiLogindManagerIface;

#define HAGUICHI_TYPE_LOGIND_MANAGER_PROXY (haguichi_logind_manager_proxy_get_type ())
enum  {
	HAGUICHI_LOGIND_MANAGER_PREPARE_FOR_SLEEP_SIGNAL,
	HAGUICHI_LOGIND_MANAGER_NUM_SIGNALS
};
static guint haguichi_logind_manager_signals[HAGUICHI_LOGIND_MANAGER_NUM_SIGNALS] = {0};
typedef GDBusProxy HaguichiLogindManagerProxy;
typedef GDBusProxyClass HaguichiLogindManagerProxyClass;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))

#define HAGUICHI_TYPE_INHIBITOR (haguichi_inhibitor_get_type ())
#define HAGUICHI_INHIBITOR(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), HAGUICHI_TYPE_INHIBITOR, HaguichiInhibitor))
#define HAGUICHI_INHIBITOR_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), HAGUICHI_TYPE_INHIBITOR, HaguichiInhibitorClass))
#define HAGUICHI_IS_INHIBITOR(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), HAGUICHI_TYPE_INHIBITOR))
#define HAGUICHI_IS_INHIBITOR_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), HAGUICHI_TYPE_INHIBITOR))
#define HAGUICHI_INHIBITOR_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), HAGUICHI_TYPE_INHIBITOR, HaguichiInhibitorClass))

typedef struct _HaguichiInhibitor HaguichiInhibitor;
typedef struct _HaguichiInhibitorClass HaguichiInhibitorClass;
typedef struct _HaguichiInhibitorPrivate HaguichiInhibitorPrivate;
enum  {
	HAGUICHI_INHIBITOR_0_PROPERTY,
	HAGUICHI_INHIBITOR_NUM_PROPERTIES
};
static GParamSpec* haguichi_inhibitor_properties[HAGUICHI_INHIBITOR_NUM_PROPERTIES];
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))

struct _HaguichiLogindManagerIface {
	GTypeInterface parent_iface;
	GUnixInputStream* (*inhibit) (HaguichiLogindManager* self, const gchar* what, const gchar* who, const gchar* why, const gchar* mode, GError** error);
};

struct _HaguichiInhibitor {
	GObject parent_instance;
	HaguichiInhibitorPrivate * priv;
};

struct _HaguichiInhibitorClass {
	GObjectClass parent_class;
};

struct _HaguichiInhibitorPrivate {
	HaguichiLogindManager* manager;
	GUnixInputStream* lock_file;
};

static gint HaguichiInhibitor_private_offset;
static gpointer haguichi_inhibitor_parent_class = NULL;
VALA_EXTERN gboolean haguichi_controller_restore;
VALA_EXTERN gint haguichi_controller_last_status;
VALA_EXTERN gint haguichi_controller_restore_countdown;

VALA_EXTERN GType haguichi_logind_manager_proxy_get_type (void) G_GNUC_CONST ;
VALA_EXTERN guint haguichi_logind_manager_register_object (void* object,
                                               GDBusConnection* connection,
                                               const gchar* path,
                                               GError** error);
VALA_EXTERN GType haguichi_logind_manager_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (HaguichiLogindManager, g_object_unref)
VALA_EXTERN GUnixInputStream* haguichi_logind_manager_inhibit (HaguichiLogindManager* self,
                                                   const gchar* what,
                                                   const gchar* who,
                                                   const gchar* why,
                                                   const gchar* mode,
                                                   GError** error);
static GType haguichi_logind_manager_get_type_once (void);
static void haguichi_logind_manager_proxy_g_signal (GDBusProxy* proxy,
                                             const gchar* sender_name,
                                             const gchar* signal_name,
                                             GVariant* parameters);
static void _dbus_handle_haguichi_logind_manager_prepare_for_sleep (HaguichiLogindManager* self,
                                                             GVariant* parameters);
static GUnixInputStream* haguichi_logind_manager_proxy_inhibit (HaguichiLogindManager* self,
                                                         const gchar* what,
                                                         const gchar* who,
                                                         const gchar* why,
                                                         const gchar* mode,
                                                         GError** error);
static void haguichi_logind_manager_proxy_haguichi_logind_manager_interface_init (HaguichiLogindManagerIface* iface);
static void _dbus_haguichi_logind_manager_inhibit (HaguichiLogindManager* self,
                                            GVariant* _parameters_,
                                            GDBusMethodInvocation* invocation);
static void haguichi_logind_manager_dbus_interface_method_call (GDBusConnection* connection,
                                                         const gchar* sender,
                                                         const gchar* object_path,
                                                         const gchar* interface_name,
                                                         const gchar* method_name,
                                                         GVariant* parameters,
                                                         GDBusMethodInvocation* invocation,
                                                         gpointer user_data);
static GVariant* haguichi_logind_manager_dbus_interface_get_property (GDBusConnection* connection,
                                                               const gchar* sender,
                                                               const gchar* object_path,
                                                               const gchar* interface_name,
                                                               const gchar* property_name,
                                                               GError** error,
                                                               gpointer user_data);
static gboolean haguichi_logind_manager_dbus_interface_set_property (GDBusConnection* connection,
                                                              const gchar* sender,
                                                              const gchar* object_path,
                                                              const gchar* interface_name,
                                                              const gchar* property_name,
                                                              GVariant* value,
                                                              GError** error,
                                                              gpointer user_data);
static void _dbus_haguichi_logind_manager_prepare_for_sleep (GObject* _sender,
                                                      gboolean before,
                                                      gpointer* _data);
static void _haguichi_logind_manager_unregister_object (gpointer user_data);
VALA_EXTERN GType haguichi_inhibitor_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (HaguichiInhibitor, g_object_unref)
VALA_EXTERN HaguichiInhibitor* haguichi_inhibitor_new (void);
VALA_EXTERN HaguichiInhibitor* haguichi_inhibitor_construct (GType object_type);
static void __lambda138_ (HaguichiInhibitor* self,
                   gboolean before);
VALA_EXTERN void haguichi_controller_connection_stopped (void);
VALA_EXTERN gchar* haguichi_hamachi_logout (void);
VALA_EXTERN void haguichi_inhibitor_release (HaguichiInhibitor* self);
VALA_EXTERN void haguichi_controller_wait_for_internet_cycle (void);
VALA_EXTERN void haguichi_inhibitor_acquire (HaguichiInhibitor* self);
static void ___lambda138__haguichi_logind_manager_prepare_for_sleep (HaguichiLogindManager* _sender,
                                                              gboolean before,
                                                              gpointer self);
static void haguichi_inhibitor_finalize (GObject * obj);
static GType haguichi_inhibitor_get_type_once (void);

static const GDBusArgInfo _haguichi_logind_manager_dbus_arg_info_inhibit_what = {-1, "what", "s", NULL};
static const GDBusArgInfo _haguichi_logind_manager_dbus_arg_info_inhibit_who = {-1, "who", "s", NULL};
static const GDBusArgInfo _haguichi_logind_manager_dbus_arg_info_inhibit_why = {-1, "why", "s", NULL};
static const GDBusArgInfo _haguichi_logind_manager_dbus_arg_info_inhibit_mode = {-1, "mode", "s", NULL};
static const GDBusArgInfo _haguichi_logind_manager_dbus_arg_info_inhibit_result = {-1, "result", "h", NULL};
static const GDBusArgInfo * const _haguichi_logind_manager_dbus_arg_info_inhibit_in[] = {&_haguichi_logind_manager_dbus_arg_info_inhibit_what, &_haguichi_logind_manager_dbus_arg_info_inhibit_who, &_haguichi_logind_manager_dbus_arg_info_inhibit_why, &_haguichi_logind_manager_dbus_arg_info_inhibit_mode, NULL};
static const GDBusArgInfo * const _haguichi_logind_manager_dbus_arg_info_inhibit_out[] = {&_haguichi_logind_manager_dbus_arg_info_inhibit_result, NULL};
static const GDBusMethodInfo _haguichi_logind_manager_dbus_method_info_inhibit = {-1, "Inhibit", (GDBusArgInfo **) (&_haguichi_logind_manager_dbus_arg_info_inhibit_in), (GDBusArgInfo **) (&_haguichi_logind_manager_dbus_arg_info_inhibit_out), NULL};
static const GDBusMethodInfo * const _haguichi_logind_manager_dbus_method_info[] = {&_haguichi_logind_manager_dbus_method_info_inhibit, NULL};
static const GDBusArgInfo _haguichi_logind_manager_dbus_arg_info_prepare_for_sleep_before = {-1, "before", "b", NULL};
static const GDBusArgInfo * const _haguichi_logind_manager_dbus_arg_info_prepare_for_sleep[] = {&_haguichi_logind_manager_dbus_arg_info_prepare_for_sleep_before, NULL};
static const GDBusSignalInfo _haguichi_logind_manager_dbus_signal_info_prepare_for_sleep = {-1, "PrepareForSleep", (GDBusArgInfo **) (&_haguichi_logind_manager_dbus_arg_info_prepare_for_sleep), NULL};
static const GDBusSignalInfo * const _haguichi_logind_manager_dbus_signal_info[] = {&_haguichi_logind_manager_dbus_signal_info_prepare_for_sleep, NULL};
static const GDBusPropertyInfo * const _haguichi_logind_manager_dbus_property_info[] = {NULL};
static const GDBusInterfaceInfo _haguichi_logind_manager_dbus_interface_info = {-1, "org.freedesktop.login1.Manager", (GDBusMethodInfo **) (&_haguichi_logind_manager_dbus_method_info), (GDBusSignalInfo **) (&_haguichi_logind_manager_dbus_signal_info), (GDBusPropertyInfo **) (&_haguichi_logind_manager_dbus_property_info), NULL};
static const GDBusInterfaceVTable _haguichi_logind_manager_dbus_interface_vtable = {haguichi_logind_manager_dbus_interface_method_call, haguichi_logind_manager_dbus_interface_get_property, haguichi_logind_manager_dbus_interface_set_property};

GUnixInputStream*
haguichi_logind_manager_inhibit (HaguichiLogindManager* self,
                                 const gchar* what,
                                 const gchar* who,
                                 const gchar* why,
                                 const gchar* mode,
                                 GError** error)
{
	HaguichiLogindManagerIface* _iface_;
#line 17 "../src/inhibitor.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 17 "../src/inhibitor.vala"
	_iface_ = HAGUICHI_LOGIND_MANAGER_GET_INTERFACE (self);
#line 17 "../src/inhibitor.vala"
	if (_iface_->inhibit) {
#line 17 "../src/inhibitor.vala"
		return _iface_->inhibit (self, what, who, why, mode, error);
#line 212 "inhibitor.c"
	}
#line 17 "../src/inhibitor.vala"
	return NULL;
#line 216 "inhibitor.c"
}

static void
haguichi_logind_manager_default_init (HaguichiLogindManagerIface * iface,
                                      gpointer iface_data)
{
#line 15 "../src/inhibitor.vala"
	haguichi_logind_manager_signals[HAGUICHI_LOGIND_MANAGER_PREPARE_FOR_SLEEP_SIGNAL] = g_signal_new ("prepare-for-sleep", HAGUICHI_TYPE_LOGIND_MANAGER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__BOOLEAN, G_TYPE_NONE, 1, G_TYPE_BOOLEAN);
#line 225 "inhibitor.c"
}

static GType
haguichi_logind_manager_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (HaguichiLogindManagerIface), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) haguichi_logind_manager_default_init, (GClassFinalizeFunc) NULL, NULL, 0, 0, (GInstanceInitFunc) NULL, NULL };
	GType haguichi_logind_manager_type_id;
	haguichi_logind_manager_type_id = g_type_register_static (G_TYPE_INTERFACE, "HaguichiLogindManager", &g_define_type_info, 0);
	g_type_interface_add_prerequisite (haguichi_logind_manager_type_id, g_dbus_proxy_get_type ());
	g_type_set_qdata (haguichi_logind_manager_type_id, g_quark_from_static_string ("vala-dbus-proxy-type"), (void*) haguichi_logind_manager_proxy_get_type);
	g_type_set_qdata (haguichi_logind_manager_type_id, g_quark_from_static_string ("vala-dbus-interface-name"), "org.freedesktop.login1.Manager");
	g_type_set_qdata (haguichi_logind_manager_type_id, g_quark_from_static_string ("vala-dbus-interface-info"), (void*) (&_haguichi_logind_manager_dbus_interface_info));
	g_type_set_qdata (haguichi_logind_manager_type_id, g_quark_from_static_string ("vala-dbus-register-object"), (void*) haguichi_logind_manager_register_object);
	return haguichi_logind_manager_type_id;
}

GType
haguichi_logind_manager_get_type (void)
{
	static volatile gsize haguichi_logind_manager_type_id__once = 0;
	if (g_once_init_enter (&haguichi_logind_manager_type_id__once)) {
		GType haguichi_logind_manager_type_id;
		haguichi_logind_manager_type_id = haguichi_logind_manager_get_type_once ();
		g_once_init_leave (&haguichi_logind_manager_type_id__once, haguichi_logind_manager_type_id);
	}
	return haguichi_logind_manager_type_id__once;
}

G_DEFINE_TYPE_EXTENDED (HaguichiLogindManagerProxy, haguichi_logind_manager_proxy, G_TYPE_DBUS_PROXY, 0, G_IMPLEMENT_INTERFACE (HAGUICHI_TYPE_LOGIND_MANAGER, haguichi_logind_manager_proxy_haguichi_logind_manager_interface_init) )
static void
haguichi_logind_manager_proxy_class_init (HaguichiLogindManagerProxyClass* klass)
{
	G_DBUS_PROXY_CLASS (klass)->g_signal = haguichi_logind_manager_proxy_g_signal;
}

static void
_dbus_handle_haguichi_logind_manager_prepare_for_sleep (HaguichiLogindManager* self,
                                                        GVariant* parameters)
{
	GVariantIter _arguments_iter;
	gboolean before = FALSE;
	GVariant* _tmp0_;
	g_variant_iter_init (&_arguments_iter, parameters);
	_tmp0_ = g_variant_iter_next_value (&_arguments_iter);
	before = g_variant_get_boolean (_tmp0_);
	g_variant_unref (_tmp0_);
	g_signal_emit_by_name (self, "prepare-for-sleep", before);
}

static void
haguichi_logind_manager_proxy_g_signal (GDBusProxy* proxy,
                                        const gchar* sender_name,
                                        const gchar* signal_name,
                                        GVariant* parameters)
{
	if (strcmp (signal_name, "PrepareForSleep") == 0) {
		_dbus_handle_haguichi_logind_manager_prepare_for_sleep ((HaguichiLogindManager*) proxy, parameters);
	}
}

static void
haguichi_logind_manager_proxy_init (HaguichiLogindManagerProxy* self)
{
	g_dbus_proxy_set_interface_info (G_DBUS_PROXY (self), (GDBusInterfaceInfo *) (&_haguichi_logind_manager_dbus_interface_info));
}

static GUnixInputStream*
haguichi_logind_manager_proxy_inhibit (HaguichiLogindManager* self,
                                       const gchar* what,
                                       const gchar* who,
                                       const gchar* why,
                                       const gchar* mode,
                                       GError** error)
{
	GUnixFDList* _fd_list;
	GDBusMessage *_message;
	GVariant *_arguments;
	GVariantBuilder _arguments_builder;
	GDBusMessage *_reply_message;
	gint _fd_index = 0;
	gint _fd;
	GVariant *_reply;
	GVariantIter _reply_iter;
	GUnixInputStream* _result = NULL;
	_message = g_dbus_message_new_method_call (g_dbus_proxy_get_name ((GDBusProxy *) self), g_dbus_proxy_get_object_path ((GDBusProxy *) self), "org.freedesktop.login1.Manager", "Inhibit");
	g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
	_fd_list = g_unix_fd_list_new ();
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_string (what));
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_string (who));
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_string (why));
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_string (mode));
	_arguments = g_variant_builder_end (&_arguments_builder);
	g_dbus_message_set_body (_message, _arguments);
	g_dbus_message_set_unix_fd_list (_message, _fd_list);
	g_object_unref (_fd_list);
	_reply_message = g_dbus_connection_send_message_with_reply_sync (g_dbus_proxy_get_connection ((GDBusProxy *) self), _message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, g_dbus_proxy_get_default_timeout ((GDBusProxy *) self), NULL, NULL, error);
	g_object_unref (_message);
	if (!_reply_message) {
		return NULL;
	}
	if (g_dbus_message_to_gerror (_reply_message, error)) {
		g_object_unref (_reply_message);
		return NULL;
	}
	_reply = g_dbus_message_get_body (_reply_message);
	g_variant_iter_init (&_reply_iter, _reply);
	_fd_list = g_dbus_message_get_unix_fd_list (_reply_message);
	if (_fd_list) {
		g_variant_iter_next (&_reply_iter, "h", &_fd_index);
		_fd = g_unix_fd_list_get (_fd_list, _fd_index, error);
		if (_fd >= 0) {
			_result = (GUnixInputStream *) g_unix_input_stream_new (_fd, TRUE);
		}
	} else {
		g_set_error_literal (error, G_IO_ERROR, G_IO_ERROR_FAILED, "FD List is NULL");
	}
	if (error && (*error)) {
		g_object_unref (_reply_message);
		return NULL;
	}
	g_object_unref (_reply_message);
	return _result;
}

static void
haguichi_logind_manager_proxy_haguichi_logind_manager_interface_init (HaguichiLogindManagerIface* iface)
{
	iface->inhibit = haguichi_logind_manager_proxy_inhibit;
}

static void
_dbus_haguichi_logind_manager_inhibit (HaguichiLogindManager* self,
                                       GVariant* _parameters_,
                                       GDBusMethodInvocation* invocation)
{
	GUnixFDList* _fd_list;
	GError* error = NULL;
	GVariantIter _arguments_iter;
	gint _fd_index = 0;
	gint _fd;
	gchar* what = NULL;
	GVariant* _tmp1_;
	gchar* who = NULL;
	GVariant* _tmp2_;
	gchar* why = NULL;
	GVariant* _tmp3_;
	gchar* mode = NULL;
	GVariant* _tmp4_;
	GDBusMessage* _reply_message = NULL;
	GVariant* _reply;
	GVariantBuilder _reply_builder;
	GUnixInputStream* result;
	g_variant_iter_init (&_arguments_iter, _parameters_);
	_tmp1_ = g_variant_iter_next_value (&_arguments_iter);
	what = g_variant_dup_string (_tmp1_, NULL);
	g_variant_unref (_tmp1_);
	_tmp2_ = g_variant_iter_next_value (&_arguments_iter);
	who = g_variant_dup_string (_tmp2_, NULL);
	g_variant_unref (_tmp2_);
	_tmp3_ = g_variant_iter_next_value (&_arguments_iter);
	why = g_variant_dup_string (_tmp3_, NULL);
	g_variant_unref (_tmp3_);
	_tmp4_ = g_variant_iter_next_value (&_arguments_iter);
	mode = g_variant_dup_string (_tmp4_, NULL);
	g_variant_unref (_tmp4_);
	result = haguichi_logind_manager_inhibit (self, what, who, why, mode, &error);
	if (error) {
		g_dbus_method_invocation_take_error (invocation, error);
		goto _error;
	}
	_reply_message = g_dbus_message_new_method_reply (g_dbus_method_invocation_get_message (invocation));
	g_variant_builder_init (&_reply_builder, G_VARIANT_TYPE_TUPLE);
	_fd_list = g_unix_fd_list_new ();
	g_variant_builder_add (&_reply_builder, "h", g_unix_fd_list_append (_fd_list, g_unix_input_stream_get_fd (result), NULL));
	_g_object_unref0 (result);
	_reply = g_variant_builder_end (&_reply_builder);
	g_dbus_message_set_body (_reply_message, _reply);
	g_dbus_message_set_unix_fd_list (_reply_message, _fd_list);
	g_object_unref (_fd_list);
	g_dbus_connection_send_message (g_dbus_method_invocation_get_connection (invocation), _reply_message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, NULL, NULL);
	g_object_unref (invocation);
	g_object_unref (_reply_message);
	_error:
	_g_free0 (what);
	_g_free0 (who);
	_g_free0 (why);
	_g_free0 (mode);
	;
}

static void
haguichi_logind_manager_dbus_interface_method_call (GDBusConnection* connection,
                                                    const gchar* sender,
                                                    const gchar* object_path,
                                                    const gchar* interface_name,
                                                    const gchar* method_name,
                                                    GVariant* parameters,
                                                    GDBusMethodInvocation* invocation,
                                                    gpointer user_data)
{
	gpointer* data;
	gpointer object;
	data = user_data;
	object = data[0];
	if (strcmp (method_name, "Inhibit") == 0) {
		_dbus_haguichi_logind_manager_inhibit (object, parameters, invocation);
	} else {
		g_object_unref (invocation);
	}
}

static GVariant*
haguichi_logind_manager_dbus_interface_get_property (GDBusConnection* connection,
                                                     const gchar* sender,
                                                     const gchar* object_path,
                                                     const gchar* interface_name,
                                                     const gchar* property_name,
                                                     GError** error,
                                                     gpointer user_data)
{
	gpointer* data;
	gpointer object;
	data = user_data;
	object = data[0];
	return NULL;
}

static gboolean
haguichi_logind_manager_dbus_interface_set_property (GDBusConnection* connection,
                                                     const gchar* sender,
                                                     const gchar* object_path,
                                                     const gchar* interface_name,
                                                     const gchar* property_name,
                                                     GVariant* value,
                                                     GError** error,
                                                     gpointer user_data)
{
	gpointer* data;
	gpointer object;
	data = user_data;
	object = data[0];
	return FALSE;
}

static void
_dbus_haguichi_logind_manager_prepare_for_sleep (GObject* _sender,
                                                 gboolean before,
                                                 gpointer* _data)
{
	GDBusConnection * _connection;
	const gchar * _path;
	GVariant *_arguments;
	GVariantBuilder _arguments_builder;
	_connection = _data[1];
	_path = _data[2];
	g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_boolean (before));
	_arguments = g_variant_builder_end (&_arguments_builder);
	g_dbus_connection_emit_signal (_connection, NULL, _path, "org.freedesktop.login1.Manager", "PrepareForSleep", _arguments, NULL);
}

guint
haguichi_logind_manager_register_object (gpointer object,
                                         GDBusConnection* connection,
                                         const gchar* path,
                                         GError** error)
{
	guint result;
	gpointer *data;
	data = g_new (gpointer, 3);
	data[0] = g_object_ref (object);
	data[1] = g_object_ref (connection);
	data[2] = g_strdup (path);
	result = g_dbus_connection_register_object (connection, path, (GDBusInterfaceInfo *) (&_haguichi_logind_manager_dbus_interface_info), &_haguichi_logind_manager_dbus_interface_vtable, data, _haguichi_logind_manager_unregister_object, error);
	if (!result) {
		return 0;
	}
	g_signal_connect (object, "prepare-for-sleep", (GCallback) _dbus_haguichi_logind_manager_prepare_for_sleep, data);
	return result;
}

static void
_haguichi_logind_manager_unregister_object (gpointer user_data)
{
	gpointer* data;
	data = user_data;
	g_signal_handlers_disconnect_by_func (data[0], _dbus_haguichi_logind_manager_prepare_for_sleep, data);
	g_object_unref (data[0]);
	g_object_unref (data[1]);
	g_free (data[2]);
	g_free (data);
}

static inline gpointer
haguichi_inhibitor_get_instance_private (HaguichiInhibitor* self)
{
	return G_STRUCT_MEMBER_P (self, HaguichiInhibitor_private_offset);
}

static void
__lambda138_ (HaguichiInhibitor* self,
              gboolean before)
{
#line 33 "../src/inhibitor.vala"
	if (before) {
#line 531 "inhibitor.c"
		gboolean _tmp0_ = FALSE;
#line 34 "../src/inhibitor.vala"
		g_debug ("inhibitor.vala:34: Preparing for sleep");
#line 37 "../src/inhibitor.vala"
		if (haguichi_controller_restore) {
#line 37 "../src/inhibitor.vala"
			_tmp0_ = TRUE;
#line 539 "inhibitor.c"
		} else {
#line 37 "../src/inhibitor.vala"
			_tmp0_ = haguichi_controller_last_status >= 6;
#line 543 "inhibitor.c"
		}
#line 37 "../src/inhibitor.vala"
		if (_tmp0_) {
#line 547 "inhibitor.c"
			gchar* _tmp1_;
			gchar* _tmp2_;
#line 38 "../src/inhibitor.vala"
			g_debug ("inhibitor.vala:38: Stopping connection");
#line 41 "../src/inhibitor.vala"
			haguichi_controller_restore_countdown = 0;
#line 42 "../src/inhibitor.vala"
			haguichi_controller_restore = FALSE;
#line 45 "../src/inhibitor.vala"
			haguichi_controller_connection_stopped ();
#line 48 "../src/inhibitor.vala"
			_tmp1_ = haguichi_hamachi_logout ();
#line 48 "../src/inhibitor.vala"
			_tmp2_ = _tmp1_;
#line 48 "../src/inhibitor.vala"
			_g_free0 (_tmp2_);
#line 51 "../src/inhibitor.vala"
			haguichi_controller_restore = TRUE;
#line 566 "inhibitor.c"
		}
#line 54 "../src/inhibitor.vala"
		haguichi_inhibitor_release (self);
#line 570 "inhibitor.c"
	} else {
#line 56 "../src/inhibitor.vala"
		g_debug ("inhibitor.vala:56: Waking up");
#line 58 "../src/inhibitor.vala"
		if (haguichi_controller_restore) {
#line 60 "../src/inhibitor.vala"
			haguichi_controller_wait_for_internet_cycle ();
#line 578 "inhibitor.c"
		}
#line 63 "../src/inhibitor.vala"
		haguichi_inhibitor_acquire (self);
#line 582 "inhibitor.c"
	}
}

static void
___lambda138__haguichi_logind_manager_prepare_for_sleep (HaguichiLogindManager* _sender,
                                                         gboolean before,
                                                         gpointer self)
{
#line 32 "../src/inhibitor.vala"
	__lambda138_ ((HaguichiInhibitor*) self, before);
#line 593 "inhibitor.c"
}

HaguichiInhibitor*
haguichi_inhibitor_construct (GType object_type)
{
	HaguichiInhibitor * self = NULL;
	HaguichiLogindManager* _tmp5_;
	GError* _inner_error0_ = NULL;
#line 24 "../src/inhibitor.vala"
	self = (HaguichiInhibitor*) g_object_new (object_type, NULL);
#line 604 "inhibitor.c"
	{
		HaguichiLogindManager* _tmp0_ = NULL;
		HaguichiLogindManager* _tmp1_;
		HaguichiLogindManager* _tmp2_;
#line 27 "../src/inhibitor.vala"
		_tmp1_ = (HaguichiLogindManager*) g_initable_new (HAGUICHI_TYPE_LOGIND_MANAGER_PROXY, NULL, &_inner_error0_, "g-flags", 0, "g-name", "org.freedesktop.login1", "g-bus-type", G_BUS_TYPE_SYSTEM, "g-object-path", "/org/freedesktop/login1", "g-interface-name", "org.freedesktop.login1.Manager", NULL);
#line 27 "../src/inhibitor.vala"
		_tmp0_ = (HaguichiLogindManager*) _tmp1_;
#line 27 "../src/inhibitor.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 27 "../src/inhibitor.vala"
			if (_inner_error0_->domain == G_IO_ERROR) {
#line 617 "inhibitor.c"
				goto __catch0_g_io_error;
			}
#line 27 "../src/inhibitor.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 27 "../src/inhibitor.vala"
			g_clear_error (&_inner_error0_);
#line 27 "../src/inhibitor.vala"
			return NULL;
#line 626 "inhibitor.c"
		}
#line 27 "../src/inhibitor.vala"
		_tmp2_ = _tmp0_;
#line 27 "../src/inhibitor.vala"
		_tmp0_ = NULL;
#line 27 "../src/inhibitor.vala"
		_g_object_unref0 (self->priv->manager);
#line 27 "../src/inhibitor.vala"
		self->priv->manager = _tmp2_;
#line 25 "../src/inhibitor.vala"
		_g_object_unref0 (_tmp0_);
#line 638 "inhibitor.c"
	}
	goto __finally0;
	__catch0_g_io_error:
	{
		GError* e = NULL;
		GError* _tmp3_;
		const gchar* _tmp4_;
#line 25 "../src/inhibitor.vala"
		e = _inner_error0_;
#line 25 "../src/inhibitor.vala"
		_inner_error0_ = NULL;
#line 29 "../src/inhibitor.vala"
		_tmp3_ = e;
#line 29 "../src/inhibitor.vala"
		_tmp4_ = _tmp3_->message;
#line 29 "../src/inhibitor.vala"
		g_critical ("inhibitor.vala:29: manager: %s", _tmp4_);
#line 25 "../src/inhibitor.vala"
		_g_error_free0 (e);
#line 658 "inhibitor.c"
	}
	__finally0:
#line 25 "../src/inhibitor.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 25 "../src/inhibitor.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 25 "../src/inhibitor.vala"
		g_clear_error (&_inner_error0_);
#line 25 "../src/inhibitor.vala"
		return NULL;
#line 669 "inhibitor.c"
	}
#line 32 "../src/inhibitor.vala"
	_tmp5_ = self->priv->manager;
#line 32 "../src/inhibitor.vala"
	g_signal_connect_object (_tmp5_, "prepare-for-sleep", (GCallback) ___lambda138__haguichi_logind_manager_prepare_for_sleep, self, 0);
#line 67 "../src/inhibitor.vala"
	haguichi_inhibitor_acquire (self);
#line 24 "../src/inhibitor.vala"
	return self;
#line 679 "inhibitor.c"
}

HaguichiInhibitor*
haguichi_inhibitor_new (void)
{
#line 24 "../src/inhibitor.vala"
	return haguichi_inhibitor_construct (HAGUICHI_TYPE_INHIBITOR);
#line 687 "inhibitor.c"
}

void
haguichi_inhibitor_release (HaguichiInhibitor* self)
{
	GUnixInputStream* _tmp0_;
	GError* _inner_error0_ = NULL;
#line 70 "../src/inhibitor.vala"
	g_return_if_fail (self != NULL);
#line 71 "../src/inhibitor.vala"
	g_debug ("inhibitor.vala:71: Releasing inhibit lock");
#line 73 "../src/inhibitor.vala"
	_tmp0_ = self->priv->lock_file;
#line 73 "../src/inhibitor.vala"
	if (_tmp0_ != NULL) {
#line 703 "inhibitor.c"
		{
			GUnixInputStream* _tmp1_;
#line 75 "../src/inhibitor.vala"
			_tmp1_ = self->priv->lock_file;
#line 75 "../src/inhibitor.vala"
			g_input_stream_close ((GInputStream*) _tmp1_, NULL, &_inner_error0_);
#line 75 "../src/inhibitor.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 75 "../src/inhibitor.vala"
				if (_inner_error0_->domain == G_IO_ERROR) {
#line 714 "inhibitor.c"
					goto __catch0_g_io_error;
				}
#line 75 "../src/inhibitor.vala"
				g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 75 "../src/inhibitor.vala"
				g_clear_error (&_inner_error0_);
#line 75 "../src/inhibitor.vala"
				return;
#line 723 "inhibitor.c"
			}
		}
		goto __finally0;
		__catch0_g_io_error:
		{
			GError* e = NULL;
			GError* _tmp2_;
			const gchar* _tmp3_;
#line 74 "../src/inhibitor.vala"
			e = _inner_error0_;
#line 74 "../src/inhibitor.vala"
			_inner_error0_ = NULL;
#line 77 "../src/inhibitor.vala"
			_tmp2_ = e;
#line 77 "../src/inhibitor.vala"
			_tmp3_ = _tmp2_->message;
#line 77 "../src/inhibitor.vala"
			g_critical ("inhibitor.vala:77: release: %s", _tmp3_);
#line 74 "../src/inhibitor.vala"
			_g_error_free0 (e);
#line 744 "inhibitor.c"
		}
		__finally0:
		{
			GError* _inner_error1_ = NULL;
#line 79 "../src/inhibitor.vala"
			_g_object_unref0 (self->priv->lock_file);
#line 79 "../src/inhibitor.vala"
			self->priv->lock_file = NULL;
#line 753 "inhibitor.c"
		}
#line 74 "../src/inhibitor.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 74 "../src/inhibitor.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 74 "../src/inhibitor.vala"
			g_clear_error (&_inner_error0_);
#line 74 "../src/inhibitor.vala"
			return;
#line 763 "inhibitor.c"
		}
	}
}

void
haguichi_inhibitor_acquire (HaguichiInhibitor* self)
{
	GError* _inner_error0_ = NULL;
#line 84 "../src/inhibitor.vala"
	g_return_if_fail (self != NULL);
#line 85 "../src/inhibitor.vala"
	g_debug ("inhibitor.vala:85: Acquiring inhibit lock");
#line 776 "inhibitor.c"
	{
		GUnixInputStream* _tmp0_ = NULL;
		HaguichiLogindManager* _tmp1_;
		GUnixInputStream* _tmp2_;
		GUnixInputStream* _tmp3_;
#line 88 "../src/inhibitor.vala"
		_tmp1_ = self->priv->manager;
#line 88 "../src/inhibitor.vala"
		_tmp2_ = haguichi_logind_manager_inhibit (_tmp1_, "sleep", "Haguichi", "Properly disconnect", "delay", &_inner_error0_);
#line 88 "../src/inhibitor.vala"
		_tmp0_ = _tmp2_;
#line 88 "../src/inhibitor.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 790 "inhibitor.c"
			goto __catch0_g_error;
		}
#line 88 "../src/inhibitor.vala"
		_tmp3_ = _tmp0_;
#line 88 "../src/inhibitor.vala"
		_tmp0_ = NULL;
#line 88 "../src/inhibitor.vala"
		_g_object_unref0 (self->priv->lock_file);
#line 88 "../src/inhibitor.vala"
		self->priv->lock_file = _tmp3_;
#line 87 "../src/inhibitor.vala"
		_g_object_unref0 (_tmp0_);
#line 803 "inhibitor.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp4_;
		const gchar* _tmp5_;
#line 87 "../src/inhibitor.vala"
		e = _inner_error0_;
#line 87 "../src/inhibitor.vala"
		_inner_error0_ = NULL;
#line 90 "../src/inhibitor.vala"
		_tmp4_ = e;
#line 90 "../src/inhibitor.vala"
		_tmp5_ = _tmp4_->message;
#line 90 "../src/inhibitor.vala"
		g_critical ("inhibitor.vala:90: acquire: %s", _tmp5_);
#line 87 "../src/inhibitor.vala"
		_g_error_free0 (e);
#line 823 "inhibitor.c"
	}
	__finally0:
#line 87 "../src/inhibitor.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 87 "../src/inhibitor.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 87 "../src/inhibitor.vala"
		g_clear_error (&_inner_error0_);
#line 87 "../src/inhibitor.vala"
		return;
#line 834 "inhibitor.c"
	}
}

static void
haguichi_inhibitor_class_init (HaguichiInhibitorClass * klass,
                               gpointer klass_data)
{
#line 20 "../src/inhibitor.vala"
	haguichi_inhibitor_parent_class = g_type_class_peek_parent (klass);
#line 20 "../src/inhibitor.vala"
	g_type_class_adjust_private_offset (klass, &HaguichiInhibitor_private_offset);
#line 20 "../src/inhibitor.vala"
	G_OBJECT_CLASS (klass)->finalize = haguichi_inhibitor_finalize;
#line 848 "inhibitor.c"
}

static void
haguichi_inhibitor_instance_init (HaguichiInhibitor * self,
                                  gpointer klass)
{
#line 20 "../src/inhibitor.vala"
	self->priv = haguichi_inhibitor_get_instance_private (self);
#line 22 "../src/inhibitor.vala"
	self->priv->lock_file = NULL;
#line 859 "inhibitor.c"
}

static void
haguichi_inhibitor_finalize (GObject * obj)
{
	HaguichiInhibitor * self;
#line 20 "../src/inhibitor.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, HAGUICHI_TYPE_INHIBITOR, HaguichiInhibitor);
#line 21 "../src/inhibitor.vala"
	_g_object_unref0 (self->priv->manager);
#line 22 "../src/inhibitor.vala"
	_g_object_unref0 (self->priv->lock_file);
#line 20 "../src/inhibitor.vala"
	G_OBJECT_CLASS (haguichi_inhibitor_parent_class)->finalize (obj);
#line 874 "inhibitor.c"
}

static GType
haguichi_inhibitor_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (HaguichiInhibitorClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) haguichi_inhibitor_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (HaguichiInhibitor), 0, (GInstanceInitFunc) haguichi_inhibitor_instance_init, NULL };
	GType haguichi_inhibitor_type_id;
	haguichi_inhibitor_type_id = g_type_register_static (G_TYPE_OBJECT, "HaguichiInhibitor", &g_define_type_info, 0);
	HaguichiInhibitor_private_offset = g_type_add_instance_private (haguichi_inhibitor_type_id, sizeof (HaguichiInhibitorPrivate));
	return haguichi_inhibitor_type_id;
}

GType
haguichi_inhibitor_get_type (void)
{
	static volatile gsize haguichi_inhibitor_type_id__once = 0;
	if (g_once_init_enter (&haguichi_inhibitor_type_id__once)) {
		GType haguichi_inhibitor_type_id;
		haguichi_inhibitor_type_id = haguichi_inhibitor_get_type_once ();
		g_once_init_leave (&haguichi_inhibitor_type_id__once, haguichi_inhibitor_type_id);
	}
	return haguichi_inhibitor_type_id__once;
}

