/* preferences.c generated by valac 0.56.17, the Vala compiler
 * generated from preferences.vala, do not modify */

/*
 * This file is part of Haguichi, a graphical frontend for Hamachi.
 * Copyright (C) 2007-2024 Stephen Brandt <stephen@stephenbrandt.com>
 *
 * Haguichi is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published
 * by the Free Software Foundation, either version 3 of the License,
 * or (at your option) any later version.
 *
 * SPDX-License-Identifier: GPL-3.0-or-later
 */

#include <adwaita.h>
#include <glib-object.h>
#include <gtk/gtk.h>
#include <gio/gio.h>
#include <glib.h>
#include <stdlib.h>
#include <string.h>
#include <glib/gi18n-lib.h>

#define HAGUICHI_HAMACHI_DATA_PATH "/var/lib/logmein-hamachi"
#define CONFIG_APP_ID "com.github.ztefn.haguichi"
#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define HAGUICHI_TYPE_PREFERENCES (haguichi_preferences_get_type ())
#define HAGUICHI_PREFERENCES(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), HAGUICHI_TYPE_PREFERENCES, HaguichiPreferences))
#define HAGUICHI_PREFERENCES_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), HAGUICHI_TYPE_PREFERENCES, HaguichiPreferencesClass))
#define HAGUICHI_IS_PREFERENCES(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), HAGUICHI_TYPE_PREFERENCES))
#define HAGUICHI_IS_PREFERENCES_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), HAGUICHI_TYPE_PREFERENCES))
#define HAGUICHI_PREFERENCES_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), HAGUICHI_TYPE_PREFERENCES, HaguichiPreferencesClass))

typedef struct _HaguichiPreferences HaguichiPreferences;
typedef struct _HaguichiPreferencesClass HaguichiPreferencesClass;
typedef struct _HaguichiPreferencesPrivate HaguichiPreferencesPrivate;

#define HAGUICHI_TYPE_COMMANDS_EDITOR (haguichi_commands_editor_get_type ())
#define HAGUICHI_COMMANDS_EDITOR(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), HAGUICHI_TYPE_COMMANDS_EDITOR, HaguichiCommandsEditor))
#define HAGUICHI_COMMANDS_EDITOR_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), HAGUICHI_TYPE_COMMANDS_EDITOR, HaguichiCommandsEditorClass))
#define HAGUICHI_IS_COMMANDS_EDITOR(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), HAGUICHI_TYPE_COMMANDS_EDITOR))
#define HAGUICHI_IS_COMMANDS_EDITOR_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), HAGUICHI_TYPE_COMMANDS_EDITOR))
#define HAGUICHI_COMMANDS_EDITOR_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), HAGUICHI_TYPE_COMMANDS_EDITOR, HaguichiCommandsEditorClass))

typedef struct _HaguichiCommandsEditor HaguichiCommandsEditor;
typedef struct _HaguichiCommandsEditorClass HaguichiCommandsEditorClass;
enum  {
	HAGUICHI_PREFERENCES_0_PROPERTY,
	HAGUICHI_PREFERENCES_NUM_PROPERTIES
};
static GParamSpec* haguichi_preferences_properties[HAGUICHI_PREFERENCES_NUM_PROPERTIES];
typedef enum  {
	HAGUICHI_PREFERENCES_UPDATE_INTERVAL_15_SECONDS = 15,
	HAGUICHI_PREFERENCES_UPDATE_INTERVAL_30_SECONDS = 30,
	HAGUICHI_PREFERENCES_UPDATE_INTERVAL_1_MINUTE = 60,
	HAGUICHI_PREFERENCES_UPDATE_INTERVAL_5_MINUTES = 300,
	HAGUICHI_PREFERENCES_UPDATE_INTERVAL_10_MINUTES = 600,
	HAGUICHI_PREFERENCES_UPDATE_INTERVAL_15_MINUTES = 900,
	HAGUICHI_PREFERENCES_UPDATE_INTERVAL_NEVER = 0
} HaguichiPreferencesUpdateInterval;

#define HAGUICHI_PREFERENCES_TYPE_UPDATE_INTERVAL (haguichi_preferences_update_interval_get_type ())
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

#define HAGUICHI_TYPE_APPLICATION (haguichi_application_get_type ())
#define HAGUICHI_APPLICATION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), HAGUICHI_TYPE_APPLICATION, HaguichiApplication))
#define HAGUICHI_APPLICATION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), HAGUICHI_TYPE_APPLICATION, HaguichiApplicationClass))
#define HAGUICHI_IS_APPLICATION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), HAGUICHI_TYPE_APPLICATION))
#define HAGUICHI_IS_APPLICATION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), HAGUICHI_TYPE_APPLICATION))
#define HAGUICHI_APPLICATION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), HAGUICHI_TYPE_APPLICATION, HaguichiApplicationClass))

typedef struct _HaguichiApplication HaguichiApplication;
typedef struct _HaguichiApplicationClass HaguichiApplicationClass;
typedef struct _Block23Data Block23Data;
#define _g_free0(var) (var = (g_free (var), NULL))

#define HAGUICHI_TYPE_WINDOW (haguichi_window_get_type ())
#define HAGUICHI_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), HAGUICHI_TYPE_WINDOW, HaguichiWindow))
#define HAGUICHI_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), HAGUICHI_TYPE_WINDOW, HaguichiWindowClass))
#define HAGUICHI_IS_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), HAGUICHI_TYPE_WINDOW))
#define HAGUICHI_IS_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), HAGUICHI_TYPE_WINDOW))
#define HAGUICHI_WINDOW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), HAGUICHI_TYPE_WINDOW, HaguichiWindowClass))

typedef struct _HaguichiWindow HaguichiWindow;
typedef struct _HaguichiWindowClass HaguichiWindowClass;
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _g_date_time_unref0(var) ((var == NULL) ? NULL : (var = (g_date_time_unref (var), NULL)))
typedef struct _Block24Data Block24Data;
#define _g_regex_unref0(var) ((var == NULL) ? NULL : (var = (g_regex_unref (var), NULL)))
typedef struct _Block25Data Block25Data;
#define _g_thread_unref0(var) ((var == NULL) ? NULL : (var = (g_thread_unref (var), NULL)))
typedef struct _Block26Data Block26Data;

#define HAGUICHI_TYPE_INDICATOR (haguichi_indicator_get_type ())
#define HAGUICHI_INDICATOR(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), HAGUICHI_TYPE_INDICATOR, HaguichiIndicator))
#define HAGUICHI_INDICATOR_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), HAGUICHI_TYPE_INDICATOR, HaguichiIndicatorClass))
#define HAGUICHI_IS_INDICATOR(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), HAGUICHI_TYPE_INDICATOR))
#define HAGUICHI_IS_INDICATOR_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), HAGUICHI_TYPE_INDICATOR))
#define HAGUICHI_INDICATOR_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), HAGUICHI_TYPE_INDICATOR, HaguichiIndicatorClass))

typedef struct _HaguichiIndicator HaguichiIndicator;
typedef struct _HaguichiIndicatorClass HaguichiIndicatorClass;
typedef struct _HaguichiIndicatorPrivate HaguichiIndicatorPrivate;

#define TYPE_STATUS_NOTIFIER_ITEM (status_notifier_item_get_type ())
#define STATUS_NOTIFIER_ITEM(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_STATUS_NOTIFIER_ITEM, StatusNotifierItem))
#define STATUS_NOTIFIER_ITEM_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_STATUS_NOTIFIER_ITEM, StatusNotifierItemClass))
#define IS_STATUS_NOTIFIER_ITEM(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_STATUS_NOTIFIER_ITEM))
#define IS_STATUS_NOTIFIER_ITEM_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_STATUS_NOTIFIER_ITEM))
#define STATUS_NOTIFIER_ITEM_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_STATUS_NOTIFIER_ITEM, StatusNotifierItemClass))

typedef struct _StatusNotifierItem StatusNotifierItem;
typedef struct _StatusNotifierItemClass StatusNotifierItemClass;
#define _gtk_expression_unref0(var) ((var == NULL) ? NULL : (var = (gtk_expression_unref (var), NULL)))

struct _HaguichiPreferences {
	AdwPreferencesDialog parent_instance;
	HaguichiPreferencesPrivate * priv;
	HaguichiCommandsEditor* commands_editor;
	GtkCheckButton* system;
	GtkCheckButton* light;
	GtkCheckButton* dark;
	AdwSwitchRow* show_indicator;
};

struct _HaguichiPreferencesClass {
	AdwPreferencesDialogClass parent_class;
};

struct _HaguichiPreferencesPrivate {
	GSettings* config;
	GSettings* behavior;
	GSettings* notifications;
	GSettings* ui;
	AdwPreferencesPage* general_page;
	AdwPreferencesPage* commands_page;
	AdwPreferencesPage* desktop_page;
	AdwActionRow* configuration;
	AdwEntryRow* nickname;
	AdwComboRow* protocol;
	AdwComboRow* update_interval;
	AdwSwitchRow* connect_on_startup;
	AdwSwitchRow* reconnect_on_connection_loss;
	AdwSwitchRow* disconnect_on_quit;
	AdwSwitchRow* notify_on_connection_loss;
	AdwSwitchRow* notify_on_member_join;
	AdwSwitchRow* notify_on_member_leave;
	AdwSwitchRow* notify_on_member_online;
	AdwSwitchRow* notify_on_member_offline;
};

struct _Block23Data {
	int _ref_count_;
	HaguichiPreferences* self;
	GtkFileDialog* dialog;
};

struct _Block24Data {
	int _ref_count_;
	HaguichiPreferences* self;
	GtkFileDialog* dialog;
};

struct _Block25Data {
	int _ref_count_;
	HaguichiPreferences* self;
	gchar* parsed_nick;
};

struct _Block26Data {
	int _ref_count_;
	HaguichiPreferences* self;
	gint i;
};

struct _HaguichiIndicator {
	GTypeInstance parent_instance;
	volatile int ref_count;
	HaguichiIndicatorPrivate * priv;
	StatusNotifierItem* item;
};

struct _HaguichiIndicatorClass {
	GTypeClass parent_class;
	void (*finalize) (HaguichiIndicator *self);
};

static gint HaguichiPreferences_private_offset;
static gpointer haguichi_preferences_parent_class = NULL;
VALA_EXTERN HaguichiApplication* haguichi_app;
VALA_EXTERN HaguichiWindow* haguichi_win;
VALA_EXTERN gint haguichi_controller_last_status;
VALA_EXTERN HaguichiIndicator* haguichi_indicator;
VALA_EXTERN gboolean haguichi_demo_mode;

VALA_EXTERN GType haguichi_preferences_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (HaguichiPreferences, g_object_unref)
VALA_EXTERN GType haguichi_commands_editor_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (HaguichiCommandsEditor, g_object_unref)
static GType haguichi_preferences_update_interval_get_type (void) G_GNUC_CONST  G_GNUC_UNUSED ;
static void haguichi_preferences_on_style_selection (HaguichiPreferences* self);
VALA_EXTERN GType haguichi_application_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (HaguichiApplication, g_object_unref)
VALA_EXTERN void haguichi_application_set_color_scheme (HaguichiApplication* self,
                                            gint scheme);
static void _haguichi_preferences_on_style_selection_g_object_notify (GObject* _sender,
                                                               GParamSpec* pspec,
                                                               gpointer self);
static void haguichi_preferences_open_config (HaguichiPreferences* self);
VALA_EXTERN void haguichi_command_open_file (const gchar* path);
static GListStore* haguichi_preferences_get_file_filters (HaguichiPreferences* self);
static void haguichi_preferences_save_config (HaguichiPreferences* self);
static Block23Data* block23_data_ref (Block23Data* _data23_);
static void block23_data_unref (void * _userdata_);
VALA_EXTERN GType haguichi_window_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (HaguichiWindow, g_object_unref)
static void __lambda68_ (Block23Data* _data23_,
                  GObject* obj,
                  GAsyncResult* res);
VALA_EXTERN void haguichi_hamachi_save_config (const gchar* path,
                                   AdwPreferencesDialog* window);
static void ___lambda68__gasync_ready_callback (GObject* source_object,
                                         GAsyncResult* res,
                                         gpointer self);
static void haguichi_preferences_restore_config (HaguichiPreferences* self);
static Block24Data* block24_data_ref (Block24Data* _data24_);
static void block24_data_unref (void * _userdata_);
static void __lambda72_ (Block24Data* _data24_,
                  GObject* obj,
                  GAsyncResult* res);
VALA_EXTERN void haguichi_hamachi_restore_config (const gchar* path,
                                      AdwPreferencesDialog* window);
static void ___lambda72__gasync_ready_callback (GObject* source_object,
                                         GAsyncResult* res,
                                         gpointer self);
static gint haguichi_preferences_get_update_interval_row_index (HaguichiPreferences* self);
static gchar* haguichi_preferences_update_interval_name (AdwEnumListItem* item);
static gchar* haguichi_preferences_get_seconds_interval_label (gint interval);
static gchar* haguichi_preferences_get_minutes_interval_label (gint interval);
VALA_EXTERN HaguichiPreferences* haguichi_preferences_new (void);
VALA_EXTERN HaguichiPreferences* haguichi_preferences_construct (GType object_type);
static GObject * haguichi_preferences_constructor (GType type,
                                            guint n_construct_properties,
                                            GObjectConstructParam * construct_properties);
VALA_EXTERN gchar* haguichi_utils_get_available_theme_icon (gchar** icon_names,
                                                gint icon_names_length1);
VALA_EXTERN gboolean haguichi_utils_path_exists (const gchar* type,
                                     const gchar* path);
VALA_EXTERN gchar* haguichi_utils_parse_nick (const gchar* nick);
static void _haguichi_preferences___lambda77_ (HaguichiPreferences* self);
static Block25Data* block25_data_ref (Block25Data* _data25_);
static void block25_data_unref (void * _userdata_);
VALA_EXTERN void haguichi_window_set_nick (HaguichiWindow* self,
                               const gchar* nick);
static void* ___lambda78_ (Block25Data* _data25_);
VALA_EXTERN gchar* haguichi_hamachi_set_nick (const gchar* nick);
static gpointer ____lambda78__gthread_func (gpointer self);
static void __haguichi_preferences___lambda77__adw_entry_row_apply (AdwEntryRow* _sender,
                                                             gpointer self);
static void _haguichi_preferences___lambda79_ (HaguichiPreferences* self,
                                        GObject* sender,
                                        GParamSpec* property);
static Block26Data* block26_data_ref (Block26Data* _data26_);
static void block26_data_unref (void * _userdata_);
static void* ___lambda80_ (Block26Data* _data26_);
VALA_EXTERN gchar* haguichi_hamachi_set_protocol (const gchar* protocol);
static gpointer ____lambda80__gthread_func (gpointer self);
static void __haguichi_preferences___lambda79__g_object_notify (GObject* _sender,
                                                         GParamSpec* pspec,
                                                         gpointer self);
static void _haguichi_preferences___lambda81_ (HaguichiPreferences* self,
                                        GObject* sender,
                                        GParamSpec* property);
static void __haguichi_preferences___lambda81__g_object_notify (GObject* _sender,
                                                         GParamSpec* pspec,
                                                         gpointer self);
VALA_EXTERN gpointer haguichi_indicator_ref (gpointer instance);
VALA_EXTERN void haguichi_indicator_unref (gpointer instance);
VALA_EXTERN GParamSpec* haguichi_param_spec_indicator (const gchar* name,
                                           const gchar* nick,
                                           const gchar* blurb,
                                           GType object_type,
                                           GParamFlags flags);
VALA_EXTERN void haguichi_value_set_indicator (GValue* value,
                                   gpointer v_object);
VALA_EXTERN void haguichi_value_take_indicator (GValue* value,
                                    gpointer v_object);
VALA_EXTERN gpointer haguichi_value_get_indicator (const GValue* value);
VALA_EXTERN GType haguichi_indicator_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (HaguichiIndicator, haguichi_indicator_unref)
VALA_EXTERN GType status_notifier_item_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (StatusNotifierItem, g_object_unref)
VALA_EXTERN gboolean status_notifier_item_get_host_registered (StatusNotifierItem* self);
static void _haguichi_preferences___lambda82_ (HaguichiPreferences* self);
static void __haguichi_preferences___lambda82__g_object_notify (GObject* _sender,
                                                         GParamSpec* pspec,
                                                         gpointer self);
static void _haguichi_preferences___lambda83_ (HaguichiPreferences* self,
                                        GObject* sender,
                                        GParamSpec* property);
VALA_EXTERN void haguichi_indicator_set_active (HaguichiIndicator* self,
                                    gboolean value);
VALA_EXTERN void haguichi_window_update_indicator_status (HaguichiWindow* self);
static void __haguichi_preferences___lambda83__g_object_notify (GObject* _sender,
                                                         GParamSpec* pspec,
                                                         gpointer self);
static void _haguichi_preferences____lambda84_ (HaguichiPreferences* self,
                                         GObject* sender,
                                         GParamSpec* property);
VALA_EXTERN void haguichi_controller_notify_connection_lost (void);
static void __haguichi_preferences____lambda84__g_object_notify (GObject* _sender,
                                                          GParamSpec* pspec,
                                                          gpointer self);
static void _haguichi_preferences____lambda85_ (HaguichiPreferences* self,
                                         GObject* sender,
                                         GParamSpec* property);
VALA_EXTERN void haguichi_controller_notify_member_joined (const gchar* nick,
                                               const gchar* network,
                                               gint more,
                                               const gchar* client_id,
                                               gchar** network_approval_ids,
                                               gint network_approval_ids_length1);
static void __haguichi_preferences____lambda85__g_object_notify (GObject* _sender,
                                                          GParamSpec* pspec,
                                                          gpointer self);
static void _haguichi_preferences____lambda86_ (HaguichiPreferences* self,
                                         GObject* sender,
                                         GParamSpec* property);
VALA_EXTERN void haguichi_controller_notify_member_left (const gchar* nick,
                                             const gchar* network,
                                             gint more);
static void __haguichi_preferences____lambda86__g_object_notify (GObject* _sender,
                                                          GParamSpec* pspec,
                                                          gpointer self);
static void _haguichi_preferences____lambda87_ (HaguichiPreferences* self,
                                         GObject* sender,
                                         GParamSpec* property);
VALA_EXTERN void haguichi_controller_notify_member_online (const gchar* nick,
                                               const gchar* network,
                                               gint more);
static void __haguichi_preferences____lambda87__g_object_notify (GObject* _sender,
                                                          GParamSpec* pspec,
                                                          gpointer self);
static void _haguichi_preferences____lambda88_ (HaguichiPreferences* self,
                                         GObject* sender,
                                         GParamSpec* property);
VALA_EXTERN void haguichi_controller_notify_member_offline (const gchar* nick,
                                                const gchar* network,
                                                gint more);
static void __haguichi_preferences____lambda88__g_object_notify (GObject* _sender,
                                                          GParamSpec* pspec,
                                                          gpointer self);
static void haguichi_preferences_finalize (GObject * obj);
static GType haguichi_preferences_get_type_once (void);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);

static inline gpointer
haguichi_preferences_get_instance_private (HaguichiPreferences* self)
{
	return G_STRUCT_MEMBER_P (self, HaguichiPreferences_private_offset);
}

static GType
haguichi_preferences_update_interval_get_type_once (void)
{
	static const GEnumValue values[] = {{HAGUICHI_PREFERENCES_UPDATE_INTERVAL_15_SECONDS, "HAGUICHI_PREFERENCES_UPDATE_INTERVAL_15_SECONDS", "15-seconds"}, {HAGUICHI_PREFERENCES_UPDATE_INTERVAL_30_SECONDS, "HAGUICHI_PREFERENCES_UPDATE_INTERVAL_30_SECONDS", "30-seconds"}, {HAGUICHI_PREFERENCES_UPDATE_INTERVAL_1_MINUTE, "HAGUICHI_PREFERENCES_UPDATE_INTERVAL_1_MINUTE", "1-minute"}, {HAGUICHI_PREFERENCES_UPDATE_INTERVAL_5_MINUTES, "HAGUICHI_PREFERENCES_UPDATE_INTERVAL_5_MINUTES", "5-minutes"}, {HAGUICHI_PREFERENCES_UPDATE_INTERVAL_10_MINUTES, "HAGUICHI_PREFERENCES_UPDATE_INTERVAL_10_MINUTES", "10-minutes"}, {HAGUICHI_PREFERENCES_UPDATE_INTERVAL_15_MINUTES, "HAGUICHI_PREFERENCES_UPDATE_INTERVAL_15_MINUTES", "15-minutes"}, {HAGUICHI_PREFERENCES_UPDATE_INTERVAL_NEVER, "HAGUICHI_PREFERENCES_UPDATE_INTERVAL_NEVER", "never"}, {0, NULL, NULL}};
	GType haguichi_preferences_update_interval_type_id;
	haguichi_preferences_update_interval_type_id = g_enum_register_static ("HaguichiPreferencesUpdateInterval", values);
	return haguichi_preferences_update_interval_type_id;
}

static GType
haguichi_preferences_update_interval_get_type (void)
{
	static volatile gsize haguichi_preferences_update_interval_type_id__once = 0;
	if (g_once_init_enter (&haguichi_preferences_update_interval_type_id__once)) {
		GType haguichi_preferences_update_interval_type_id;
		haguichi_preferences_update_interval_type_id = haguichi_preferences_update_interval_get_type_once ();
		g_once_init_leave (&haguichi_preferences_update_interval_type_id__once, haguichi_preferences_update_interval_type_id);
	}
	return haguichi_preferences_update_interval_type_id__once;
}

static void
haguichi_preferences_on_style_selection (HaguichiPreferences* self)
{
	gint scheme = 0;
	GtkCheckButton* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
	GSettings* _tmp6_;
	HaguichiApplication* _tmp7_;
#line 217 "../src/preferences.vala"
	g_return_if_fail (self != NULL);
#line 218 "../src/preferences.vala"
	scheme = 0;
#line 219 "../src/preferences.vala"
	_tmp0_ = self->light;
#line 219 "../src/preferences.vala"
	_tmp1_ = gtk_check_button_get_active (_tmp0_);
#line 219 "../src/preferences.vala"
	_tmp2_ = _tmp1_;
#line 219 "../src/preferences.vala"
	if (_tmp2_) {
#line 220 "../src/preferences.vala"
		scheme = 1;
#line 431 "preferences.c"
	} else {
		GtkCheckButton* _tmp3_;
		gboolean _tmp4_;
		gboolean _tmp5_;
#line 221 "../src/preferences.vala"
		_tmp3_ = self->dark;
#line 221 "../src/preferences.vala"
		_tmp4_ = gtk_check_button_get_active (_tmp3_);
#line 221 "../src/preferences.vala"
		_tmp5_ = _tmp4_;
#line 221 "../src/preferences.vala"
		if (_tmp5_) {
#line 222 "../src/preferences.vala"
			scheme = 2;
#line 446 "preferences.c"
		}
	}
#line 224 "../src/preferences.vala"
	_tmp6_ = self->priv->ui;
#line 224 "../src/preferences.vala"
	g_settings_set_enum (_tmp6_, "color-scheme", scheme);
#line 225 "../src/preferences.vala"
	_tmp7_ = haguichi_app;
#line 225 "../src/preferences.vala"
	haguichi_application_set_color_scheme (_tmp7_, scheme);
#line 457 "preferences.c"
}

static void
_haguichi_preferences_on_style_selection_g_object_notify (GObject* _sender,
                                                          GParamSpec* pspec,
                                                          gpointer self)
{
#line 16 "../src/preferences.vala"
	haguichi_preferences_on_style_selection ((HaguichiPreferences*) self);
#line 467 "preferences.c"
}

static void
haguichi_preferences_open_config (HaguichiPreferences* self)
{
#line 228 "../src/preferences.vala"
	g_return_if_fail (self != NULL);
#line 229 "../src/preferences.vala"
	haguichi_command_open_file (HAGUICHI_HAMACHI_DATA_PATH);
#line 477 "preferences.c"
}

static GListStore*
haguichi_preferences_get_file_filters (HaguichiPreferences* self)
{
	GtkFileFilter* tar = NULL;
	GtkFileFilter* _tmp0_;
	GListStore* filters = NULL;
	GListStore* _tmp1_;
	GListStore* result;
#line 232 "../src/preferences.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 233 "../src/preferences.vala"
	_tmp0_ = gtk_file_filter_new ();
#line 233 "../src/preferences.vala"
	tar = _tmp0_;
#line 234 "../src/preferences.vala"
	gtk_file_filter_set_name (tar, _ ("All supported archives"));
#line 235 "../src/preferences.vala"
	gtk_file_filter_add_mime_type (tar, "application/x-tar");
#line 236 "../src/preferences.vala"
	gtk_file_filter_add_mime_type (tar, "application/x-compressed-tar");
#line 237 "../src/preferences.vala"
	gtk_file_filter_add_mime_type (tar, "application/x-bzip-compressed-tar");
#line 238 "../src/preferences.vala"
	gtk_file_filter_add_mime_type (tar, "application/x-lzma-compressed-tar");
#line 239 "../src/preferences.vala"
	gtk_file_filter_add_mime_type (tar, "application/x-xz-compressed-tar");
#line 240 "../src/preferences.vala"
	gtk_file_filter_add_mime_type (tar, "application/x-zstd-compressed-tar");
#line 242 "../src/preferences.vala"
	_tmp1_ = g_list_store_new (gtk_file_filter_get_type ());
#line 242 "../src/preferences.vala"
	filters = _tmp1_;
#line 243 "../src/preferences.vala"
	g_list_store_append (filters, (GObject*) tar);
#line 245 "../src/preferences.vala"
	result = filters;
#line 245 "../src/preferences.vala"
	_g_object_unref0 (tar);
#line 245 "../src/preferences.vala"
	return result;
#line 520 "preferences.c"
}

static Block23Data*
block23_data_ref (Block23Data* _data23_)
{
#line 248 "../src/preferences.vala"
	g_atomic_int_inc (&_data23_->_ref_count_);
#line 248 "../src/preferences.vala"
	return _data23_;
#line 530 "preferences.c"
}

static void
block23_data_unref (void * _userdata_)
{
	Block23Data* _data23_;
	_data23_ = (Block23Data*) _userdata_;
#line 248 "../src/preferences.vala"
	if (g_atomic_int_dec_and_test (&_data23_->_ref_count_)) {
#line 540 "preferences.c"
		HaguichiPreferences* self;
#line 248 "../src/preferences.vala"
		self = _data23_->self;
#line 248 "../src/preferences.vala"
		_g_object_unref0 (_data23_->dialog);
#line 248 "../src/preferences.vala"
		_g_object_unref0 (self);
#line 248 "../src/preferences.vala"
		g_slice_free (Block23Data, _data23_);
#line 550 "preferences.c"
	}
}

static void
__lambda68_ (Block23Data* _data23_,
             GObject* obj,
             GAsyncResult* res)
{
	HaguichiPreferences* self;
	GError* _inner_error0_ = NULL;
#line 260 "../src/preferences.vala"
	self = _data23_->self;
#line 260 "../src/preferences.vala"
	g_return_if_fail (res != NULL);
#line 565 "preferences.c"
	{
		GFile* file = NULL;
		GFile* _tmp0_;
		gchar* path = NULL;
		gchar* _tmp1_;
		const gchar* _tmp2_;
		const gchar* _tmp3_;
#line 262 "../src/preferences.vala"
		_tmp0_ = gtk_file_dialog_save_finish (_data23_->dialog, res, &_inner_error0_);
#line 262 "../src/preferences.vala"
		file = _tmp0_;
#line 262 "../src/preferences.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 579 "preferences.c"
			goto __catch0_g_error;
		}
#line 263 "../src/preferences.vala"
		_tmp1_ = g_file_get_path (file);
#line 263 "../src/preferences.vala"
		path = _tmp1_;
#line 264 "../src/preferences.vala"
		_tmp2_ = path;
#line 264 "../src/preferences.vala"
		g_debug ("preferences.vala:264: save_config: Selected path %s: ", _tmp2_);
#line 265 "../src/preferences.vala"
		_tmp3_ = path;
#line 265 "../src/preferences.vala"
		haguichi_hamachi_save_config (_tmp3_, (AdwPreferencesDialog*) self);
#line 261 "../src/preferences.vala"
		_g_free0 (path);
#line 261 "../src/preferences.vala"
		_g_object_unref0 (file);
#line 598 "preferences.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp4_;
		const gchar* _tmp5_;
#line 261 "../src/preferences.vala"
		e = _inner_error0_;
#line 261 "../src/preferences.vala"
		_inner_error0_ = NULL;
#line 267 "../src/preferences.vala"
		_tmp4_ = e;
#line 267 "../src/preferences.vala"
		_tmp5_ = _tmp4_->message;
#line 267 "../src/preferences.vala"
		g_critical ("preferences.vala:267: save_config %s: ", _tmp5_);
#line 261 "../src/preferences.vala"
		_g_error_free0 (e);
#line 618 "preferences.c"
	}
	__finally0:
#line 261 "../src/preferences.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 261 "../src/preferences.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 261 "../src/preferences.vala"
		g_clear_error (&_inner_error0_);
#line 261 "../src/preferences.vala"
		return;
#line 629 "preferences.c"
	}
}

static void
___lambda68__gasync_ready_callback (GObject* source_object,
                                    GAsyncResult* res,
                                    gpointer self)
{
#line 260 "../src/preferences.vala"
	__lambda68_ (self, source_object, res);
#line 260 "../src/preferences.vala"
	block23_data_unref (self);
#line 642 "preferences.c"
}

static void
haguichi_preferences_save_config (HaguichiPreferences* self)
{
	Block23Data* _data23_;
	GDateTime* now = NULL;
	GDateTime* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	GListStore* _tmp7_;
	GtkFileDialog* _tmp8_ = NULL;
	GtkFileDialog* _tmp9_;
	HaguichiWindow* _tmp10_;
#line 248 "../src/preferences.vala"
	g_return_if_fail (self != NULL);
#line 248 "../src/preferences.vala"
	_data23_ = g_slice_new0 (Block23Data);
#line 248 "../src/preferences.vala"
	_data23_->_ref_count_ = 1;
#line 248 "../src/preferences.vala"
	_data23_->self = g_object_ref (self);
#line 249 "../src/preferences.vala"
	g_debug ("preferences.vala:249: config.save action activated");
#line 251 "../src/preferences.vala"
	_tmp0_ = g_date_time_new_now_local ();
#line 251 "../src/preferences.vala"
	now = _tmp0_;
#line 253 "../src/preferences.vala"
	_tmp1_ = g_strdup (_ ("Save a Backup"));
#line 253 "../src/preferences.vala"
	_tmp2_ = g_date_time_format (now, "%Y-%m-%d");
#line 253 "../src/preferences.vala"
	_tmp3_ = _tmp2_;
#line 253 "../src/preferences.vala"
	_tmp4_ = g_strconcat ("logmein-hamachi-config_", _tmp3_, NULL);
#line 253 "../src/preferences.vala"
	_tmp5_ = _tmp4_;
#line 253 "../src/preferences.vala"
	_tmp6_ = g_strconcat (_tmp5_, ".tar.gz", NULL);
#line 253 "../src/preferences.vala"
	_tmp7_ = haguichi_preferences_get_file_filters (self);
#line 253 "../src/preferences.vala"
	_tmp8_ = gtk_file_dialog_new ();
#line 253 "../src/preferences.vala"
	gtk_file_dialog_set_title (_tmp8_, _tmp1_);
#line 253 "../src/preferences.vala"
	_g_free0 (_tmp1_);
#line 253 "../src/preferences.vala"
	gtk_file_dialog_set_initial_name (_tmp8_, _tmp6_);
#line 253 "../src/preferences.vala"
	_g_free0 (_tmp6_);
#line 253 "../src/preferences.vala"
	gtk_file_dialog_set_modal (_tmp8_, TRUE);
#line 253 "../src/preferences.vala"
	gtk_file_dialog_set_filters (_tmp8_, (GListModel*) _tmp7_);
#line 253 "../src/preferences.vala"
	_g_object_unref0 (_tmp7_);
#line 253 "../src/preferences.vala"
	_tmp9_ = _tmp8_;
#line 253 "../src/preferences.vala"
	_g_free0 (_tmp5_);
#line 253 "../src/preferences.vala"
	_g_free0 (_tmp3_);
#line 253 "../src/preferences.vala"
	_data23_->dialog = _tmp9_;
#line 260 "../src/preferences.vala"
	_tmp10_ = haguichi_win;
#line 260 "../src/preferences.vala"
	gtk_file_dialog_save (_data23_->dialog, (GtkWindow*) _tmp10_, NULL, ___lambda68__gasync_ready_callback, block23_data_ref (_data23_));
#line 248 "../src/preferences.vala"
	_g_date_time_unref0 (now);
#line 248 "../src/preferences.vala"
	block23_data_unref (_data23_);
#line 248 "../src/preferences.vala"
	_data23_ = NULL;
#line 723 "preferences.c"
}

static Block24Data*
block24_data_ref (Block24Data* _data24_)
{
#line 272 "../src/preferences.vala"
	g_atomic_int_inc (&_data24_->_ref_count_);
#line 272 "../src/preferences.vala"
	return _data24_;
#line 733 "preferences.c"
}

static void
block24_data_unref (void * _userdata_)
{
	Block24Data* _data24_;
	_data24_ = (Block24Data*) _userdata_;
#line 272 "../src/preferences.vala"
	if (g_atomic_int_dec_and_test (&_data24_->_ref_count_)) {
#line 743 "preferences.c"
		HaguichiPreferences* self;
#line 272 "../src/preferences.vala"
		self = _data24_->self;
#line 272 "../src/preferences.vala"
		_g_object_unref0 (_data24_->dialog);
#line 272 "../src/preferences.vala"
		_g_object_unref0 (self);
#line 272 "../src/preferences.vala"
		g_slice_free (Block24Data, _data24_);
#line 753 "preferences.c"
	}
}

static void
__lambda72_ (Block24Data* _data24_,
             GObject* obj,
             GAsyncResult* res)
{
	HaguichiPreferences* self;
	GError* _inner_error0_ = NULL;
#line 282 "../src/preferences.vala"
	self = _data24_->self;
#line 282 "../src/preferences.vala"
	g_return_if_fail (res != NULL);
#line 768 "preferences.c"
	{
		GFile* file = NULL;
		GFile* _tmp0_;
		gchar* path = NULL;
		gchar* _tmp1_;
		const gchar* _tmp2_;
		const gchar* _tmp3_;
#line 284 "../src/preferences.vala"
		_tmp0_ = gtk_file_dialog_open_finish (_data24_->dialog, res, &_inner_error0_);
#line 284 "../src/preferences.vala"
		file = _tmp0_;
#line 284 "../src/preferences.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 782 "preferences.c"
			goto __catch0_g_error;
		}
#line 285 "../src/preferences.vala"
		_tmp1_ = g_file_get_path (file);
#line 285 "../src/preferences.vala"
		path = _tmp1_;
#line 286 "../src/preferences.vala"
		_tmp2_ = path;
#line 286 "../src/preferences.vala"
		g_debug ("preferences.vala:286: restore_config: Selected path %s: ", _tmp2_);
#line 287 "../src/preferences.vala"
		_tmp3_ = path;
#line 287 "../src/preferences.vala"
		haguichi_hamachi_restore_config (_tmp3_, (AdwPreferencesDialog*) self);
#line 283 "../src/preferences.vala"
		_g_free0 (path);
#line 283 "../src/preferences.vala"
		_g_object_unref0 (file);
#line 801 "preferences.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp4_;
		const gchar* _tmp5_;
#line 283 "../src/preferences.vala"
		e = _inner_error0_;
#line 283 "../src/preferences.vala"
		_inner_error0_ = NULL;
#line 289 "../src/preferences.vala"
		_tmp4_ = e;
#line 289 "../src/preferences.vala"
		_tmp5_ = _tmp4_->message;
#line 289 "../src/preferences.vala"
		g_critical ("preferences.vala:289: restore_config: %s", _tmp5_);
#line 283 "../src/preferences.vala"
		_g_error_free0 (e);
#line 821 "preferences.c"
	}
	__finally0:
#line 283 "../src/preferences.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 283 "../src/preferences.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 283 "../src/preferences.vala"
		g_clear_error (&_inner_error0_);
#line 283 "../src/preferences.vala"
		return;
#line 832 "preferences.c"
	}
}

static void
___lambda72__gasync_ready_callback (GObject* source_object,
                                    GAsyncResult* res,
                                    gpointer self)
{
#line 282 "../src/preferences.vala"
	__lambda72_ (self, source_object, res);
#line 282 "../src/preferences.vala"
	block24_data_unref (self);
#line 845 "preferences.c"
}

static void
haguichi_preferences_restore_config (HaguichiPreferences* self)
{
	Block24Data* _data24_;
	gchar* _tmp0_;
	gchar* _tmp1_;
	GListStore* _tmp2_;
	GtkFileDialog* _tmp3_ = NULL;
	HaguichiWindow* _tmp4_;
#line 272 "../src/preferences.vala"
	g_return_if_fail (self != NULL);
#line 272 "../src/preferences.vala"
	_data24_ = g_slice_new0 (Block24Data);
#line 272 "../src/preferences.vala"
	_data24_->_ref_count_ = 1;
#line 272 "../src/preferences.vala"
	_data24_->self = g_object_ref (self);
#line 273 "../src/preferences.vala"
	g_debug ("preferences.vala:273: config.restore action activated");
#line 275 "../src/preferences.vala"
	_tmp0_ = g_strdup (_ ("Restore from Backup"));
#line 275 "../src/preferences.vala"
	_tmp1_ = g_strdup (_ ("_Restore"));
#line 275 "../src/preferences.vala"
	_tmp2_ = haguichi_preferences_get_file_filters (self);
#line 275 "../src/preferences.vala"
	_tmp3_ = gtk_file_dialog_new ();
#line 275 "../src/preferences.vala"
	gtk_file_dialog_set_title (_tmp3_, _tmp0_);
#line 275 "../src/preferences.vala"
	_g_free0 (_tmp0_);
#line 275 "../src/preferences.vala"
	gtk_file_dialog_set_accept_label (_tmp3_, _tmp1_);
#line 275 "../src/preferences.vala"
	_g_free0 (_tmp1_);
#line 275 "../src/preferences.vala"
	gtk_file_dialog_set_modal (_tmp3_, TRUE);
#line 275 "../src/preferences.vala"
	gtk_file_dialog_set_filters (_tmp3_, (GListModel*) _tmp2_);
#line 275 "../src/preferences.vala"
	_g_object_unref0 (_tmp2_);
#line 275 "../src/preferences.vala"
	_data24_->dialog = _tmp3_;
#line 282 "../src/preferences.vala"
	_tmp4_ = haguichi_win;
#line 282 "../src/preferences.vala"
	gtk_file_dialog_open (_data24_->dialog, (GtkWindow*) _tmp4_, NULL, ___lambda72__gasync_ready_callback, block24_data_ref (_data24_));
#line 272 "../src/preferences.vala"
	block24_data_unref (_data24_);
#line 272 "../src/preferences.vala"
	_data24_ = NULL;
#line 899 "preferences.c"
}

static gint
haguichi_preferences_get_update_interval_row_index (HaguichiPreferences* self)
{
	gint interval = 0;
	GSettings* _tmp0_;
	gint result;
#line 294 "../src/preferences.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 295 "../src/preferences.vala"
	_tmp0_ = self->priv->config;
#line 295 "../src/preferences.vala"
	interval = g_settings_get_int (_tmp0_, "update-interval");
#line 297 "../src/preferences.vala"
	if (interval == 0) {
#line 298 "../src/preferences.vala"
		result = 6;
#line 298 "../src/preferences.vala"
		return result;
#line 920 "preferences.c"
	} else {
#line 299 "../src/preferences.vala"
		if (interval < 30) {
#line 300 "../src/preferences.vala"
			result = 0;
#line 300 "../src/preferences.vala"
			return result;
#line 928 "preferences.c"
		} else {
#line 301 "../src/preferences.vala"
			if (interval < 60) {
#line 302 "../src/preferences.vala"
				result = 1;
#line 302 "../src/preferences.vala"
				return result;
#line 936 "preferences.c"
			} else {
#line 303 "../src/preferences.vala"
				if (interval < 300) {
#line 304 "../src/preferences.vala"
					result = 2;
#line 304 "../src/preferences.vala"
					return result;
#line 944 "preferences.c"
				} else {
#line 305 "../src/preferences.vala"
					if (interval < 600) {
#line 306 "../src/preferences.vala"
						result = 3;
#line 306 "../src/preferences.vala"
						return result;
#line 952 "preferences.c"
					} else {
#line 307 "../src/preferences.vala"
						if (interval < 900) {
#line 308 "../src/preferences.vala"
							result = 4;
#line 308 "../src/preferences.vala"
							return result;
#line 960 "preferences.c"
						} else {
#line 310 "../src/preferences.vala"
							result = 5;
#line 310 "../src/preferences.vala"
							return result;
#line 966 "preferences.c"
						}
					}
				}
			}
		}
	}
}

static gchar*
haguichi_preferences_update_interval_name (AdwEnumListItem* item)
{
	gchar* result;
#line 314 "../src/preferences.vala"
	g_return_val_if_fail (item != NULL, NULL);
#line 315 "../src/preferences.vala"
	switch (adw_enum_list_item_get_value (item)) {
#line 315 "../src/preferences.vala"
		case HAGUICHI_PREFERENCES_UPDATE_INTERVAL_NEVER:
#line 985 "preferences.c"
		{
			gchar* _tmp0_;
#line 317 "../src/preferences.vala"
			_tmp0_ = g_strdup (_ ("Never"));
#line 317 "../src/preferences.vala"
			result = _tmp0_;
#line 317 "../src/preferences.vala"
			return result;
#line 994 "preferences.c"
		}
#line 315 "../src/preferences.vala"
		case HAGUICHI_PREFERENCES_UPDATE_INTERVAL_15_SECONDS:
#line 998 "preferences.c"
		{
			gchar* _tmp1_;
#line 319 "../src/preferences.vala"
			_tmp1_ = haguichi_preferences_get_seconds_interval_label (15);
#line 319 "../src/preferences.vala"
			result = _tmp1_;
#line 319 "../src/preferences.vala"
			return result;
#line 1007 "preferences.c"
		}
#line 315 "../src/preferences.vala"
		case HAGUICHI_PREFERENCES_UPDATE_INTERVAL_30_SECONDS:
#line 1011 "preferences.c"
		{
			gchar* _tmp2_;
#line 321 "../src/preferences.vala"
			_tmp2_ = haguichi_preferences_get_seconds_interval_label (30);
#line 321 "../src/preferences.vala"
			result = _tmp2_;
#line 321 "../src/preferences.vala"
			return result;
#line 1020 "preferences.c"
		}
#line 315 "../src/preferences.vala"
		case HAGUICHI_PREFERENCES_UPDATE_INTERVAL_1_MINUTE:
#line 1024 "preferences.c"
		{
			gchar* _tmp3_;
#line 323 "../src/preferences.vala"
			_tmp3_ = haguichi_preferences_get_minutes_interval_label (1);
#line 323 "../src/preferences.vala"
			result = _tmp3_;
#line 323 "../src/preferences.vala"
			return result;
#line 1033 "preferences.c"
		}
#line 315 "../src/preferences.vala"
		case HAGUICHI_PREFERENCES_UPDATE_INTERVAL_5_MINUTES:
#line 1037 "preferences.c"
		{
			gchar* _tmp4_;
#line 325 "../src/preferences.vala"
			_tmp4_ = haguichi_preferences_get_minutes_interval_label (5);
#line 325 "../src/preferences.vala"
			result = _tmp4_;
#line 325 "../src/preferences.vala"
			return result;
#line 1046 "preferences.c"
		}
#line 315 "../src/preferences.vala"
		case HAGUICHI_PREFERENCES_UPDATE_INTERVAL_10_MINUTES:
#line 1050 "preferences.c"
		{
			gchar* _tmp5_;
#line 327 "../src/preferences.vala"
			_tmp5_ = haguichi_preferences_get_minutes_interval_label (10);
#line 327 "../src/preferences.vala"
			result = _tmp5_;
#line 327 "../src/preferences.vala"
			return result;
#line 1059 "preferences.c"
		}
#line 315 "../src/preferences.vala"
		case HAGUICHI_PREFERENCES_UPDATE_INTERVAL_15_MINUTES:
#line 1063 "preferences.c"
		{
			gchar* _tmp6_;
#line 329 "../src/preferences.vala"
			_tmp6_ = haguichi_preferences_get_minutes_interval_label (15);
#line 329 "../src/preferences.vala"
			result = _tmp6_;
#line 329 "../src/preferences.vala"
			return result;
#line 1072 "preferences.c"
		}
		default:
		{
			gchar* _tmp7_;
#line 331 "../src/preferences.vala"
			_tmp7_ = g_strdup ("");
#line 331 "../src/preferences.vala"
			result = _tmp7_;
#line 331 "../src/preferences.vala"
			return result;
#line 1083 "preferences.c"
		}
	}
}

static gchar*
string_replace (const gchar* self,
                const gchar* old,
                const gchar* replacement)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	GError* _inner_error0_ = NULL;
	gchar* result;
#line 1588 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1588 "glib-2.0.vapi"
	g_return_val_if_fail (old != NULL, NULL);
#line 1588 "glib-2.0.vapi"
	g_return_val_if_fail (replacement != NULL, NULL);
#line 1589 "glib-2.0.vapi"
	if ((*((gchar*) self)) == '\0') {
#line 1589 "glib-2.0.vapi"
		_tmp1_ = TRUE;
#line 1107 "preferences.c"
	} else {
#line 1589 "glib-2.0.vapi"
		_tmp1_ = (*((gchar*) old)) == '\0';
#line 1111 "preferences.c"
	}
#line 1589 "glib-2.0.vapi"
	if (_tmp1_) {
#line 1589 "glib-2.0.vapi"
		_tmp0_ = TRUE;
#line 1117 "preferences.c"
	} else {
#line 1589 "glib-2.0.vapi"
		_tmp0_ = g_strcmp0 (old, replacement) == 0;
#line 1121 "preferences.c"
	}
#line 1589 "glib-2.0.vapi"
	if (_tmp0_) {
#line 1125 "preferences.c"
		gchar* _tmp2_;
#line 1590 "glib-2.0.vapi"
		_tmp2_ = g_strdup (self);
#line 1590 "glib-2.0.vapi"
		result = _tmp2_;
#line 1590 "glib-2.0.vapi"
		return result;
#line 1133 "preferences.c"
	}
	{
		GRegex* regex = NULL;
		gchar* _tmp3_;
		gchar* _tmp4_;
		GRegex* _tmp5_;
		GRegex* _tmp6_;
		gchar* _tmp7_ = NULL;
		GRegex* _tmp8_;
		gchar* _tmp9_;
		gchar* _tmp10_;
#line 1593 "glib-2.0.vapi"
		_tmp3_ = g_regex_escape_string (old, -1);
#line 1593 "glib-2.0.vapi"
		_tmp4_ = _tmp3_;
#line 1593 "glib-2.0.vapi"
		_tmp5_ = g_regex_new (_tmp4_, 0, 0, &_inner_error0_);
#line 1593 "glib-2.0.vapi"
		_tmp6_ = _tmp5_;
#line 1593 "glib-2.0.vapi"
		_g_free0 (_tmp4_);
#line 1593 "glib-2.0.vapi"
		regex = _tmp6_;
#line 1593 "glib-2.0.vapi"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1593 "glib-2.0.vapi"
			if (_inner_error0_->domain == G_REGEX_ERROR) {
#line 1161 "preferences.c"
				goto __catch0_g_regex_error;
			}
#line 1593 "glib-2.0.vapi"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1593 "glib-2.0.vapi"
			g_clear_error (&_inner_error0_);
#line 1593 "glib-2.0.vapi"
			return NULL;
#line 1170 "preferences.c"
		}
#line 1594 "glib-2.0.vapi"
		_tmp8_ = regex;
#line 1594 "glib-2.0.vapi"
		_tmp9_ = g_regex_replace_literal (_tmp8_, self, (gssize) -1, 0, replacement, 0, &_inner_error0_);
#line 1594 "glib-2.0.vapi"
		_tmp7_ = _tmp9_;
#line 1594 "glib-2.0.vapi"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1594 "glib-2.0.vapi"
			_g_regex_unref0 (regex);
#line 1594 "glib-2.0.vapi"
			if (_inner_error0_->domain == G_REGEX_ERROR) {
#line 1184 "preferences.c"
				goto __catch0_g_regex_error;
			}
#line 1594 "glib-2.0.vapi"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1594 "glib-2.0.vapi"
			g_clear_error (&_inner_error0_);
#line 1594 "glib-2.0.vapi"
			return NULL;
#line 1193 "preferences.c"
		}
#line 1594 "glib-2.0.vapi"
		_tmp10_ = _tmp7_;
#line 1594 "glib-2.0.vapi"
		_tmp7_ = NULL;
#line 1594 "glib-2.0.vapi"
		result = _tmp10_;
#line 1594 "glib-2.0.vapi"
		_g_free0 (_tmp7_);
#line 1594 "glib-2.0.vapi"
		_g_regex_unref0 (regex);
#line 1594 "glib-2.0.vapi"
		return result;
#line 1207 "preferences.c"
	}
	goto __finally0;
	__catch0_g_regex_error:
	{
#line 1592 "glib-2.0.vapi"
		g_clear_error (&_inner_error0_);
#line 1596 "glib-2.0.vapi"
		g_assert_not_reached ();
#line 1216 "preferences.c"
	}
	__finally0:
#line 1592 "glib-2.0.vapi"
	g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1592 "glib-2.0.vapi"
	g_clear_error (&_inner_error0_);
#line 1592 "glib-2.0.vapi"
	return NULL;
#line 1225 "preferences.c"
}

static gchar*
haguichi_preferences_get_seconds_interval_label (gint interval)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* result;
#line 336 "../src/preferences.vala"
	_tmp0_ = g_strdup_printf ("%i", interval);
#line 336 "../src/preferences.vala"
	_tmp1_ = _tmp0_;
#line 336 "../src/preferences.vala"
	_tmp2_ = string_replace (ngettext ("%S second", "%S seconds", (gulong) interval), "%S", _tmp1_);
#line 336 "../src/preferences.vala"
	_tmp3_ = _tmp2_;
#line 336 "../src/preferences.vala"
	_g_free0 (_tmp1_);
#line 336 "../src/preferences.vala"
	result = _tmp3_;
#line 336 "../src/preferences.vala"
	return result;
#line 1250 "preferences.c"
}

static gchar*
haguichi_preferences_get_minutes_interval_label (gint interval)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* result;
#line 340 "../src/preferences.vala"
	_tmp0_ = g_strdup_printf ("%i", interval);
#line 340 "../src/preferences.vala"
	_tmp1_ = _tmp0_;
#line 340 "../src/preferences.vala"
	_tmp2_ = string_replace (ngettext ("%S minute", "%S minutes", (gulong) interval), "%S", _tmp1_);
#line 340 "../src/preferences.vala"
	_tmp3_ = _tmp2_;
#line 340 "../src/preferences.vala"
	_g_free0 (_tmp1_);
#line 340 "../src/preferences.vala"
	result = _tmp3_;
#line 340 "../src/preferences.vala"
	return result;
#line 1275 "preferences.c"
}

HaguichiPreferences*
haguichi_preferences_construct (GType object_type)
{
	HaguichiPreferences * self = NULL;
#line 16 "../src/preferences.vala"
	self = (HaguichiPreferences*) g_object_new (object_type, NULL);
#line 16 "../src/preferences.vala"
	return self;
#line 1286 "preferences.c"
}

HaguichiPreferences*
haguichi_preferences_new (void)
{
#line 16 "../src/preferences.vala"
	return haguichi_preferences_construct (HAGUICHI_TYPE_PREFERENCES);
#line 1294 "preferences.c"
}

static Block25Data*
block25_data_ref (Block25Data* _data25_)
{
#line 115 "../src/preferences.vala"
	g_atomic_int_inc (&_data25_->_ref_count_);
#line 115 "../src/preferences.vala"
	return _data25_;
#line 1304 "preferences.c"
}

static void
block25_data_unref (void * _userdata_)
{
	Block25Data* _data25_;
	_data25_ = (Block25Data*) _userdata_;
#line 115 "../src/preferences.vala"
	if (g_atomic_int_dec_and_test (&_data25_->_ref_count_)) {
#line 1314 "preferences.c"
		HaguichiPreferences* self;
#line 115 "../src/preferences.vala"
		self = _data25_->self;
#line 115 "../src/preferences.vala"
		_g_free0 (_data25_->parsed_nick);
#line 115 "../src/preferences.vala"
		_g_object_unref0 (self);
#line 115 "../src/preferences.vala"
		g_slice_free (Block25Data, _data25_);
#line 1324 "preferences.c"
	}
}

static void*
___lambda78_ (Block25Data* _data25_)
{
	HaguichiPreferences* self;
	const gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
#line 131 "../src/preferences.vala"
	self = _data25_->self;
#line 132 "../src/preferences.vala"
	_tmp0_ = _data25_->parsed_nick;
#line 132 "../src/preferences.vala"
	_tmp1_ = haguichi_hamachi_set_nick (_tmp0_);
#line 132 "../src/preferences.vala"
	_tmp2_ = _tmp1_;
#line 132 "../src/preferences.vala"
	_g_free0 (_tmp2_);
#line 1345 "preferences.c"
}

static gpointer
____lambda78__gthread_func (gpointer self)
{
	gpointer result;
	result = ___lambda78_ (self);
#line 131 "../src/preferences.vala"
	block25_data_unref (self);
#line 131 "../src/preferences.vala"
	return result;
#line 1357 "preferences.c"
}

static void
_haguichi_preferences___lambda77_ (HaguichiPreferences* self)
{
	Block25Data* _data25_;
	gchar* nick = NULL;
	AdwEntryRow* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	gchar* _tmp3_;
	const gchar* _tmp4_;
	gchar* _tmp5_;
	const gchar* _tmp6_;
	const gchar* _tmp7_;
	AdwEntryRow* _tmp8_;
	AdwEntryRow* _tmp9_;
	AdwEntryRow* _tmp10_;
	const gchar* _tmp11_;
	AdwEntryRow* _tmp12_;
	AdwEntryRow* _tmp13_;
	GSettings* _tmp14_;
	const gchar* _tmp15_;
	HaguichiWindow* _tmp16_;
	const gchar* _tmp17_;
#line 115 "../src/preferences.vala"
	_data25_ = g_slice_new0 (Block25Data);
#line 115 "../src/preferences.vala"
	_data25_->_ref_count_ = 1;
#line 115 "../src/preferences.vala"
	_data25_->self = g_object_ref (self);
#line 116 "../src/preferences.vala"
	_tmp0_ = self->priv->nickname;
#line 116 "../src/preferences.vala"
	_tmp1_ = gtk_editable_get_text ((GtkEditable*) _tmp0_);
#line 116 "../src/preferences.vala"
	_tmp2_ = _tmp1_;
#line 116 "../src/preferences.vala"
	_tmp3_ = g_strdup (_tmp2_);
#line 116 "../src/preferences.vala"
	nick = _tmp3_;
#line 117 "../src/preferences.vala"
	_tmp4_ = nick;
#line 117 "../src/preferences.vala"
	_tmp5_ = haguichi_utils_parse_nick (_tmp4_);
#line 117 "../src/preferences.vala"
	_data25_->parsed_nick = _tmp5_;
#line 118 "../src/preferences.vala"
	_tmp6_ = nick;
#line 118 "../src/preferences.vala"
	_tmp7_ = _data25_->parsed_nick;
#line 118 "../src/preferences.vala"
	g_debug ("preferences.vala:118: nickname changed to: %s (parsed: %s)", _tmp6_, _tmp7_);
#line 120 "../src/preferences.vala"
	_tmp8_ = self->priv->nickname;
#line 120 "../src/preferences.vala"
	gtk_editable_set_editable ((GtkEditable*) _tmp8_, FALSE);
#line 121 "../src/preferences.vala"
	_tmp9_ = self->priv->nickname;
#line 121 "../src/preferences.vala"
	gtk_widget_set_sensitive ((GtkWidget*) _tmp9_, FALSE);
#line 122 "../src/preferences.vala"
	_tmp10_ = self->priv->nickname;
#line 122 "../src/preferences.vala"
	_tmp11_ = _data25_->parsed_nick;
#line 122 "../src/preferences.vala"
	gtk_editable_set_text ((GtkEditable*) _tmp10_, _tmp11_);
#line 123 "../src/preferences.vala"
	_tmp12_ = self->priv->nickname;
#line 123 "../src/preferences.vala"
	gtk_widget_set_sensitive ((GtkWidget*) _tmp12_, TRUE);
#line 124 "../src/preferences.vala"
	_tmp13_ = self->priv->nickname;
#line 124 "../src/preferences.vala"
	gtk_editable_set_editable ((GtkEditable*) _tmp13_, TRUE);
#line 126 "../src/preferences.vala"
	_tmp14_ = self->priv->config;
#line 126 "../src/preferences.vala"
	_tmp15_ = nick;
#line 126 "../src/preferences.vala"
	g_settings_set_string (_tmp14_, "nickname", _tmp15_);
#line 127 "../src/preferences.vala"
	_tmp16_ = haguichi_win;
#line 127 "../src/preferences.vala"
	_tmp17_ = _data25_->parsed_nick;
#line 127 "../src/preferences.vala"
	haguichi_window_set_nick (_tmp16_, _tmp17_);
#line 130 "../src/preferences.vala"
	if (haguichi_controller_last_status >= 6) {
#line 1447 "preferences.c"
		GThread* _tmp18_;
		GThread* _tmp19_;
#line 131 "../src/preferences.vala"
		_tmp18_ = g_thread_new (NULL, ____lambda78__gthread_func, block25_data_ref (_data25_));
#line 131 "../src/preferences.vala"
		_tmp19_ = _tmp18_;
#line 131 "../src/preferences.vala"
		_g_thread_unref0 (_tmp19_);
#line 1456 "preferences.c"
	}
#line 115 "../src/preferences.vala"
	_g_free0 (nick);
#line 115 "../src/preferences.vala"
	block25_data_unref (_data25_);
#line 115 "../src/preferences.vala"
	_data25_ = NULL;
#line 1464 "preferences.c"
}

static void
__haguichi_preferences___lambda77__adw_entry_row_apply (AdwEntryRow* _sender,
                                                        gpointer self)
{
#line 115 "../src/preferences.vala"
	_haguichi_preferences___lambda77_ ((HaguichiPreferences*) self);
#line 1473 "preferences.c"
}

static Block26Data*
block26_data_ref (Block26Data* _data26_)
{
#line 138 "../src/preferences.vala"
	g_atomic_int_inc (&_data26_->_ref_count_);
#line 138 "../src/preferences.vala"
	return _data26_;
#line 1483 "preferences.c"
}

static void
block26_data_unref (void * _userdata_)
{
	Block26Data* _data26_;
	_data26_ = (Block26Data*) _userdata_;
#line 138 "../src/preferences.vala"
	if (g_atomic_int_dec_and_test (&_data26_->_ref_count_)) {
#line 1493 "preferences.c"
		HaguichiPreferences* self;
#line 138 "../src/preferences.vala"
		self = _data26_->self;
#line 138 "../src/preferences.vala"
		_g_object_unref0 (self);
#line 138 "../src/preferences.vala"
		g_slice_free (Block26Data, _data26_);
#line 1501 "preferences.c"
	}
}

static void*
___lambda80_ (Block26Data* _data26_)
{
	HaguichiPreferences* self;
	gchar* protocol = NULL;
	gchar* _tmp0_;
	const gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
#line 144 "../src/preferences.vala"
	self = _data26_->self;
#line 145 "../src/preferences.vala"
	_tmp0_ = g_strdup ("both");
#line 145 "../src/preferences.vala"
	protocol = _tmp0_;
#line 146 "../src/preferences.vala"
	if (_data26_->i == 1) {
#line 1522 "preferences.c"
		gchar* _tmp1_;
#line 147 "../src/preferences.vala"
		_tmp1_ = g_strdup ("ipv4");
#line 147 "../src/preferences.vala"
		_g_free0 (protocol);
#line 147 "../src/preferences.vala"
		protocol = _tmp1_;
#line 1530 "preferences.c"
	} else {
#line 148 "../src/preferences.vala"
		if (_data26_->i == 2) {
#line 1534 "preferences.c"
			gchar* _tmp2_;
#line 149 "../src/preferences.vala"
			_tmp2_ = g_strdup ("ipv6");
#line 149 "../src/preferences.vala"
			_g_free0 (protocol);
#line 149 "../src/preferences.vala"
			protocol = _tmp2_;
#line 1542 "preferences.c"
		}
	}
#line 151 "../src/preferences.vala"
	_tmp3_ = protocol;
#line 151 "../src/preferences.vala"
	_tmp4_ = haguichi_hamachi_set_protocol (_tmp3_);
#line 151 "../src/preferences.vala"
	_tmp5_ = _tmp4_;
#line 151 "../src/preferences.vala"
	_g_free0 (_tmp5_);
#line 144 "../src/preferences.vala"
	_g_free0 (protocol);
#line 1555 "preferences.c"
}

static gpointer
____lambda80__gthread_func (gpointer self)
{
	gpointer result;
	result = ___lambda80_ (self);
#line 144 "../src/preferences.vala"
	block26_data_unref (self);
#line 144 "../src/preferences.vala"
	return result;
#line 1567 "preferences.c"
}

static void
_haguichi_preferences___lambda79_ (HaguichiPreferences* self,
                                   GObject* sender,
                                   GParamSpec* property)
{
	Block26Data* _data26_;
	AdwComboRow* _tmp0_;
	guint _tmp1_;
	guint _tmp2_;
	GSettings* _tmp3_;
#line 138 "../src/preferences.vala"
	g_return_if_fail (sender != NULL);
#line 138 "../src/preferences.vala"
	g_return_if_fail (property != NULL);
#line 138 "../src/preferences.vala"
	_data26_ = g_slice_new0 (Block26Data);
#line 138 "../src/preferences.vala"
	_data26_->_ref_count_ = 1;
#line 138 "../src/preferences.vala"
	_data26_->self = g_object_ref (self);
#line 139 "../src/preferences.vala"
	_tmp0_ = self->priv->protocol;
#line 139 "../src/preferences.vala"
	_tmp1_ = adw_combo_row_get_selected (_tmp0_);
#line 139 "../src/preferences.vala"
	_tmp2_ = _tmp1_;
#line 139 "../src/preferences.vala"
	_data26_->i = (gint) _tmp2_;
#line 140 "../src/preferences.vala"
	_tmp3_ = self->priv->config;
#line 140 "../src/preferences.vala"
	g_settings_set_enum (_tmp3_, "protocol", _data26_->i);
#line 143 "../src/preferences.vala"
	if (haguichi_controller_last_status >= 6) {
#line 1604 "preferences.c"
		GThread* _tmp4_;
		GThread* _tmp5_;
#line 144 "../src/preferences.vala"
		_tmp4_ = g_thread_new (NULL, ____lambda80__gthread_func, block26_data_ref (_data26_));
#line 144 "../src/preferences.vala"
		_tmp5_ = _tmp4_;
#line 144 "../src/preferences.vala"
		_g_thread_unref0 (_tmp5_);
#line 1613 "preferences.c"
	}
#line 138 "../src/preferences.vala"
	block26_data_unref (_data26_);
#line 138 "../src/preferences.vala"
	_data26_ = NULL;
#line 1619 "preferences.c"
}

static void
__haguichi_preferences___lambda79__g_object_notify (GObject* _sender,
                                                    GParamSpec* pspec,
                                                    gpointer self)
{
#line 138 "../src/preferences.vala"
	_haguichi_preferences___lambda79_ ((HaguichiPreferences*) self, _sender, pspec);
#line 1629 "preferences.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 162 "../src/preferences.vala"
	return self ? g_object_ref (self) : NULL;
#line 1637 "preferences.c"
}

static void
_haguichi_preferences___lambda81_ (HaguichiPreferences* self,
                                   GObject* sender,
                                   GParamSpec* property)
{
	AdwEnumListItem* item = NULL;
	AdwComboRow* _tmp0_;
	GObject* _tmp1_;
	GObject* _tmp2_;
	AdwEnumListItem* _tmp3_;
	HaguichiPreferencesUpdateInterval val = 0;
	AdwEnumListItem* _tmp4_;
	GSettings* _tmp5_;
#line 161 "../src/preferences.vala"
	g_return_if_fail (sender != NULL);
#line 161 "../src/preferences.vala"
	g_return_if_fail (property != NULL);
#line 162 "../src/preferences.vala"
	_tmp0_ = self->priv->update_interval;
#line 162 "../src/preferences.vala"
	_tmp1_ = adw_combo_row_get_selected_item (_tmp0_);
#line 162 "../src/preferences.vala"
	_tmp2_ = _tmp1_;
#line 162 "../src/preferences.vala"
	_tmp3_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp2_, adw_enum_list_item_get_type (), AdwEnumListItem));
#line 162 "../src/preferences.vala"
	item = _tmp3_;
#line 163 "../src/preferences.vala"
	_tmp4_ = item;
#line 163 "../src/preferences.vala"
	val = (HaguichiPreferencesUpdateInterval) adw_enum_list_item_get_value (_tmp4_);
#line 164 "../src/preferences.vala"
	_tmp5_ = self->priv->config;
#line 164 "../src/preferences.vala"
	g_settings_set_int (_tmp5_, "update-interval", (gint) val);
#line 161 "../src/preferences.vala"
	_g_object_unref0 (item);
#line 1677 "preferences.c"
}

static void
__haguichi_preferences___lambda81__g_object_notify (GObject* _sender,
                                                    GParamSpec* pspec,
                                                    gpointer self)
{
#line 161 "../src/preferences.vala"
	_haguichi_preferences___lambda81_ ((HaguichiPreferences*) self, _sender, pspec);
#line 1687 "preferences.c"
}

static void
_haguichi_preferences___lambda82_ (HaguichiPreferences* self)
{
	AdwSwitchRow* _tmp0_;
	HaguichiIndicator* _tmp1_;
	StatusNotifierItem* _tmp2_;
	gboolean _tmp3_;
	gboolean _tmp4_;
#line 184 "../src/preferences.vala"
	_tmp0_ = self->show_indicator;
#line 184 "../src/preferences.vala"
	_tmp1_ = haguichi_indicator;
#line 184 "../src/preferences.vala"
	_tmp2_ = _tmp1_->item;
#line 184 "../src/preferences.vala"
	_tmp3_ = status_notifier_item_get_host_registered (_tmp2_);
#line 184 "../src/preferences.vala"
	_tmp4_ = _tmp3_;
#line 184 "../src/preferences.vala"
	gtk_widget_set_visible ((GtkWidget*) _tmp0_, _tmp4_);
#line 1710 "preferences.c"
}

static void
__haguichi_preferences___lambda82__g_object_notify (GObject* _sender,
                                                    GParamSpec* pspec,
                                                    gpointer self)
{
#line 183 "../src/preferences.vala"
	_haguichi_preferences___lambda82_ ((HaguichiPreferences*) self);
#line 1720 "preferences.c"
}

static void
_haguichi_preferences___lambda83_ (HaguichiPreferences* self,
                                   GObject* sender,
                                   GParamSpec* property)
{
	HaguichiIndicator* _tmp0_;
	GSettings* _tmp1_;
	HaguichiWindow* _tmp2_;
#line 186 "../src/preferences.vala"
	g_return_if_fail (sender != NULL);
#line 186 "../src/preferences.vala"
	g_return_if_fail (property != NULL);
#line 187 "../src/preferences.vala"
	_tmp0_ = haguichi_indicator;
#line 187 "../src/preferences.vala"
	_tmp1_ = self->priv->ui;
#line 187 "../src/preferences.vala"
	haguichi_indicator_set_active (_tmp0_, g_settings_get_boolean (_tmp1_, "show-indicator"));
#line 188 "../src/preferences.vala"
	_tmp2_ = haguichi_win;
#line 188 "../src/preferences.vala"
	haguichi_window_update_indicator_status (_tmp2_);
#line 1745 "preferences.c"
}

static void
__haguichi_preferences___lambda83__g_object_notify (GObject* _sender,
                                                    GParamSpec* pspec,
                                                    gpointer self)
{
#line 186 "../src/preferences.vala"
	_haguichi_preferences___lambda83_ ((HaguichiPreferences*) self, _sender, pspec);
#line 1755 "preferences.c"
}

static void
_haguichi_preferences____lambda84_ (HaguichiPreferences* self,
                                    GObject* sender,
                                    GParamSpec* property)
{
#line 198 "../src/preferences.vala"
	g_return_if_fail (sender != NULL);
#line 198 "../src/preferences.vala"
	g_return_if_fail (property != NULL);
#line 199 "../src/preferences.vala"
	haguichi_controller_notify_connection_lost ();
#line 1769 "preferences.c"
}

static void
__haguichi_preferences____lambda84__g_object_notify (GObject* _sender,
                                                     GParamSpec* pspec,
                                                     gpointer self)
{
#line 198 "../src/preferences.vala"
	_haguichi_preferences____lambda84_ ((HaguichiPreferences*) self, _sender, pspec);
#line 1779 "preferences.c"
}

static void
_haguichi_preferences____lambda85_ (HaguichiPreferences* self,
                                    GObject* sender,
                                    GParamSpec* property)
{
	gchar* _tmp0_;
	gchar** _tmp1_;
	gchar** _tmp2_;
	gint _tmp2__length1;
#line 201 "../src/preferences.vala"
	g_return_if_fail (sender != NULL);
#line 201 "../src/preferences.vala"
	g_return_if_fail (property != NULL);
#line 202 "../src/preferences.vala"
	_tmp0_ = g_strdup ("000-000-000");
#line 202 "../src/preferences.vala"
	_tmp1_ = g_new0 (gchar*, 1 + 1);
#line 202 "../src/preferences.vala"
	_tmp1_[0] = _tmp0_;
#line 202 "../src/preferences.vala"
	_tmp2_ = _tmp1_;
#line 202 "../src/preferences.vala"
	_tmp2__length1 = 1;
#line 202 "../src/preferences.vala"
	haguichi_controller_notify_member_joined ("T-800", "Skynet", 0, "000-000-000", _tmp2_, (gint) 1);
#line 202 "../src/preferences.vala"
	_tmp2_ = (_vala_array_free (_tmp2_, _tmp2__length1, (GDestroyNotify) g_free), NULL);
#line 1809 "preferences.c"
}

static void
__haguichi_preferences____lambda85__g_object_notify (GObject* _sender,
                                                     GParamSpec* pspec,
                                                     gpointer self)
{
#line 201 "../src/preferences.vala"
	_haguichi_preferences____lambda85_ ((HaguichiPreferences*) self, _sender, pspec);
#line 1819 "preferences.c"
}

static void
_haguichi_preferences____lambda86_ (HaguichiPreferences* self,
                                    GObject* sender,
                                    GParamSpec* property)
{
#line 204 "../src/preferences.vala"
	g_return_if_fail (sender != NULL);
#line 204 "../src/preferences.vala"
	g_return_if_fail (property != NULL);
#line 205 "../src/preferences.vala"
	haguichi_controller_notify_member_left ("T-800", "Skynet", 0);
#line 1833 "preferences.c"
}

static void
__haguichi_preferences____lambda86__g_object_notify (GObject* _sender,
                                                     GParamSpec* pspec,
                                                     gpointer self)
{
#line 204 "../src/preferences.vala"
	_haguichi_preferences____lambda86_ ((HaguichiPreferences*) self, _sender, pspec);
#line 1843 "preferences.c"
}

static void
_haguichi_preferences____lambda87_ (HaguichiPreferences* self,
                                    GObject* sender,
                                    GParamSpec* property)
{
#line 207 "../src/preferences.vala"
	g_return_if_fail (sender != NULL);
#line 207 "../src/preferences.vala"
	g_return_if_fail (property != NULL);
#line 208 "../src/preferences.vala"
	haguichi_controller_notify_member_online ("T-800", "Skynet", 1);
#line 1857 "preferences.c"
}

static void
__haguichi_preferences____lambda87__g_object_notify (GObject* _sender,
                                                     GParamSpec* pspec,
                                                     gpointer self)
{
#line 207 "../src/preferences.vala"
	_haguichi_preferences____lambda87_ ((HaguichiPreferences*) self, _sender, pspec);
#line 1867 "preferences.c"
}

static void
_haguichi_preferences____lambda88_ (HaguichiPreferences* self,
                                    GObject* sender,
                                    GParamSpec* property)
{
#line 210 "../src/preferences.vala"
	g_return_if_fail (sender != NULL);
#line 210 "../src/preferences.vala"
	g_return_if_fail (property != NULL);
#line 211 "../src/preferences.vala"
	haguichi_controller_notify_member_offline ("T-800", "Skynet", 2);
#line 1881 "preferences.c"
}

static void
__haguichi_preferences____lambda88__g_object_notify (GObject* _sender,
                                                     GParamSpec* pspec,
                                                     gpointer self)
{
#line 210 "../src/preferences.vala"
	_haguichi_preferences____lambda88_ ((HaguichiPreferences*) self, _sender, pspec);
#line 1891 "preferences.c"
}

static GObject *
haguichi_preferences_constructor (GType type,
                                  guint n_construct_properties,
                                  GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	HaguichiPreferences * self;
	AdwPreferencesPage* _tmp0_;
	GtkWidget* _tmp1_;
	AdwPreferencesPage* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	gchar** _tmp6_;
	gchar** _tmp7_;
	gint _tmp7__length1;
	gchar* _tmp8_;
	gchar* _tmp9_;
	AdwPreferencesPage* _tmp10_;
	gchar* _tmp11_;
	gchar* _tmp12_;
	gchar** _tmp13_;
	gchar** _tmp14_;
	gint _tmp14__length1;
	gchar* _tmp15_;
	gchar* _tmp16_;
	AdwPreferencesPage* _tmp17_;
	gchar* _tmp18_;
	gchar* _tmp19_;
	gchar** _tmp20_;
	gchar** _tmp21_;
	gint _tmp21__length1;
	gchar* _tmp22_;
	gchar* _tmp23_;
	GSettings* _tmp24_;
	GSettings* _tmp25_;
	GSettings* _tmp26_;
	GSettings* _tmp27_;
	gboolean config_exists = FALSE;
	const gchar* _tmp28_ = NULL;
	AdwActionRow* _tmp29_;
	AdwEntryRow* _tmp30_;
	GSettings* _tmp31_;
	gchar* _tmp32_;
	gchar* _tmp33_;
	gchar* _tmp34_;
	gchar* _tmp35_;
	AdwEntryRow* _tmp36_;
	AdwComboRow* _tmp37_;
	GSettings* _tmp38_;
	AdwComboRow* _tmp39_;
	AdwEnumListModel* model = NULL;
	AdwEnumListModel* _tmp40_;
	GtkCClosureExpression* expression = NULL;
	GtkExpression** _tmp41_;
	GtkCClosureExpression* _tmp42_;
	AdwComboRow* _tmp43_;
	GtkCClosureExpression* _tmp44_;
	AdwComboRow* _tmp45_;
	AdwEnumListModel* _tmp46_;
	AdwComboRow* _tmp47_;
	AdwComboRow* _tmp48_;
	GSettings* _tmp49_;
	AdwSwitchRow* _tmp50_;
	GSettings* _tmp51_;
	AdwSwitchRow* _tmp52_;
	GSettings* _tmp53_;
	AdwSwitchRow* _tmp54_;
	gint scheme = 0;
	GSettings* _tmp55_;
	GSettings* _tmp59_;
	AdwSwitchRow* _tmp60_;
	AdwSwitchRow* _tmp61_;
	HaguichiIndicator* _tmp62_;
	StatusNotifierItem* _tmp63_;
	gboolean _tmp64_;
	gboolean _tmp65_;
	HaguichiIndicator* _tmp66_;
	StatusNotifierItem* _tmp67_;
	AdwSwitchRow* _tmp68_;
	GSettings* _tmp69_;
	AdwSwitchRow* _tmp70_;
	GSettings* _tmp71_;
	AdwSwitchRow* _tmp72_;
	GSettings* _tmp73_;
	AdwSwitchRow* _tmp74_;
	GSettings* _tmp75_;
	AdwSwitchRow* _tmp76_;
	GSettings* _tmp77_;
	AdwSwitchRow* _tmp78_;
#line 81 "../src/preferences.vala"
	parent_class = G_OBJECT_CLASS (haguichi_preferences_parent_class);
#line 81 "../src/preferences.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 81 "../src/preferences.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, HAGUICHI_TYPE_PREFERENCES, HaguichiPreferences);
#line 83 "../src/preferences.vala"
	_tmp0_ = self->priv->general_page;
#line 83 "../src/preferences.vala"
	_tmp1_ = gtk_widget_get_ancestor ((GtkWidget*) _tmp0_, adw_breakpoint_bin_get_type ());
#line 83 "../src/preferences.vala"
	g_object_set ((GtkWidget*) G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, adw_breakpoint_bin_get_type (), AdwBreakpointBin), "width-request", 320, NULL);
#line 85 "../src/preferences.vala"
	_tmp2_ = self->priv->general_page;
#line 85 "../src/preferences.vala"
	_tmp3_ = g_strdup ("applications-system-symbolic");
#line 85 "../src/preferences.vala"
	_tmp4_ = g_strdup ("emblem-system-symbolic");
#line 85 "../src/preferences.vala"
	_tmp5_ = g_strdup ("preferences-system-symbolic");
#line 85 "../src/preferences.vala"
	_tmp6_ = g_new0 (gchar*, 3 + 1);
#line 85 "../src/preferences.vala"
	_tmp6_[0] = _tmp3_;
#line 85 "../src/preferences.vala"
	_tmp6_[1] = _tmp4_;
#line 85 "../src/preferences.vala"
	_tmp6_[2] = _tmp5_;
#line 85 "../src/preferences.vala"
	_tmp7_ = _tmp6_;
#line 85 "../src/preferences.vala"
	_tmp7__length1 = 3;
#line 85 "../src/preferences.vala"
	_tmp8_ = haguichi_utils_get_available_theme_icon (_tmp7_, (gint) 3);
#line 85 "../src/preferences.vala"
	_tmp9_ = _tmp8_;
#line 85 "../src/preferences.vala"
	adw_preferences_page_set_icon_name (_tmp2_, _tmp9_);
#line 85 "../src/preferences.vala"
	_g_free0 (_tmp9_);
#line 85 "../src/preferences.vala"
	_tmp7_ = (_vala_array_free (_tmp7_, _tmp7__length1, (GDestroyNotify) g_free), NULL);
#line 90 "../src/preferences.vala"
	_tmp10_ = self->priv->commands_page;
#line 90 "../src/preferences.vala"
	_tmp11_ = g_strdup ("utilities-terminal-symbolic");
#line 90 "../src/preferences.vala"
	_tmp12_ = g_strdup ("system-run-symbolic");
#line 90 "../src/preferences.vala"
	_tmp13_ = g_new0 (gchar*, 2 + 1);
#line 90 "../src/preferences.vala"
	_tmp13_[0] = _tmp11_;
#line 90 "../src/preferences.vala"
	_tmp13_[1] = _tmp12_;
#line 90 "../src/preferences.vala"
	_tmp14_ = _tmp13_;
#line 90 "../src/preferences.vala"
	_tmp14__length1 = 2;
#line 90 "../src/preferences.vala"
	_tmp15_ = haguichi_utils_get_available_theme_icon (_tmp14_, (gint) 2);
#line 90 "../src/preferences.vala"
	_tmp16_ = _tmp15_;
#line 90 "../src/preferences.vala"
	adw_preferences_page_set_icon_name (_tmp10_, _tmp16_);
#line 90 "../src/preferences.vala"
	_g_free0 (_tmp16_);
#line 90 "../src/preferences.vala"
	_tmp14_ = (_vala_array_free (_tmp14_, _tmp14__length1, (GDestroyNotify) g_free), NULL);
#line 94 "../src/preferences.vala"
	_tmp17_ = self->priv->desktop_page;
#line 94 "../src/preferences.vala"
	_tmp18_ = g_strdup ("preferences-desktop-appearance-symbolic");
#line 94 "../src/preferences.vala"
	_tmp19_ = g_strdup ("user-desktop-symbolic");
#line 94 "../src/preferences.vala"
	_tmp20_ = g_new0 (gchar*, 2 + 1);
#line 94 "../src/preferences.vala"
	_tmp20_[0] = _tmp18_;
#line 94 "../src/preferences.vala"
	_tmp20_[1] = _tmp19_;
#line 94 "../src/preferences.vala"
	_tmp21_ = _tmp20_;
#line 94 "../src/preferences.vala"
	_tmp21__length1 = 2;
#line 94 "../src/preferences.vala"
	_tmp22_ = haguichi_utils_get_available_theme_icon (_tmp21_, (gint) 2);
#line 94 "../src/preferences.vala"
	_tmp23_ = _tmp22_;
#line 94 "../src/preferences.vala"
	adw_preferences_page_set_icon_name (_tmp17_, _tmp23_);
#line 94 "../src/preferences.vala"
	_g_free0 (_tmp23_);
#line 94 "../src/preferences.vala"
	_tmp21_ = (_vala_array_free (_tmp21_, _tmp21__length1, (GDestroyNotify) g_free), NULL);
#line 99 "../src/preferences.vala"
	_tmp24_ = g_settings_new (CONFIG_APP_ID ".config");
#line 99 "../src/preferences.vala"
	_g_object_unref0 (self->priv->config);
#line 99 "../src/preferences.vala"
	self->priv->config = _tmp24_;
#line 100 "../src/preferences.vala"
	_tmp25_ = g_settings_new (CONFIG_APP_ID ".behavior");
#line 100 "../src/preferences.vala"
	_g_object_unref0 (self->priv->behavior);
#line 100 "../src/preferences.vala"
	self->priv->behavior = _tmp25_;
#line 101 "../src/preferences.vala"
	_tmp26_ = g_settings_new (CONFIG_APP_ID ".notifications");
#line 101 "../src/preferences.vala"
	_g_object_unref0 (self->priv->notifications);
#line 101 "../src/preferences.vala"
	self->priv->notifications = _tmp26_;
#line 102 "../src/preferences.vala"
	_tmp27_ = g_settings_new (CONFIG_APP_ID ".ui");
#line 102 "../src/preferences.vala"
	_g_object_unref0 (self->priv->ui);
#line 102 "../src/preferences.vala"
	self->priv->ui = _tmp27_;
#line 104 "../src/preferences.vala"
	gtk_widget_class_install_action (G_TYPE_INSTANCE_GET_CLASS (self, gtk_widget_get_type (), GtkWidgetClass), "config.open", NULL, (GtkWidgetActionActivateFunc) haguichi_preferences_open_config);
#line 105 "../src/preferences.vala"
	gtk_widget_class_install_action (G_TYPE_INSTANCE_GET_CLASS (self, gtk_widget_get_type (), GtkWidgetClass), "config.save", NULL, (GtkWidgetActionActivateFunc) haguichi_preferences_save_config);
#line 106 "../src/preferences.vala"
	gtk_widget_class_install_action (G_TYPE_INSTANCE_GET_CLASS (self, gtk_widget_get_type (), GtkWidgetClass), "config.restore", NULL, (GtkWidgetActionActivateFunc) haguichi_preferences_restore_config);
#line 108 "../src/preferences.vala"
	config_exists = haguichi_utils_path_exists ("d", HAGUICHI_HAMACHI_DATA_PATH);
#line 110 "../src/preferences.vala"
	if (config_exists) {
#line 110 "../src/preferences.vala"
		_tmp28_ = HAGUICHI_HAMACHI_DATA_PATH;
#line 2115 "preferences.c"
	} else {
#line 110 "../src/preferences.vala"
		_tmp28_ = _ ("Not present");
#line 2119 "preferences.c"
	}
#line 110 "../src/preferences.vala"
	_tmp29_ = self->priv->configuration;
#line 110 "../src/preferences.vala"
	adw_action_row_set_subtitle (_tmp29_, _tmp28_);
#line 111 "../src/preferences.vala"
	gtk_widget_action_set_enabled ((GtkWidget*) self, "config.open", config_exists);
#line 112 "../src/preferences.vala"
	gtk_widget_action_set_enabled ((GtkWidget*) self, "config.save", config_exists);
#line 114 "../src/preferences.vala"
	_tmp30_ = self->priv->nickname;
#line 114 "../src/preferences.vala"
	_tmp31_ = self->priv->config;
#line 114 "../src/preferences.vala"
	_tmp32_ = g_settings_get_string (_tmp31_, "nickname");
#line 114 "../src/preferences.vala"
	_tmp33_ = _tmp32_;
#line 114 "../src/preferences.vala"
	_tmp34_ = haguichi_utils_parse_nick (_tmp33_);
#line 114 "../src/preferences.vala"
	_tmp35_ = _tmp34_;
#line 114 "../src/preferences.vala"
	gtk_editable_set_text ((GtkEditable*) _tmp30_, _tmp35_);
#line 114 "../src/preferences.vala"
	_g_free0 (_tmp35_);
#line 114 "../src/preferences.vala"
	_g_free0 (_tmp33_);
#line 115 "../src/preferences.vala"
	_tmp36_ = self->priv->nickname;
#line 115 "../src/preferences.vala"
	g_signal_connect_object (_tmp36_, "apply", (GCallback) __haguichi_preferences___lambda77__adw_entry_row_apply, self, 0);
#line 137 "../src/preferences.vala"
	_tmp37_ = self->priv->protocol;
#line 137 "../src/preferences.vala"
	_tmp38_ = self->priv->config;
#line 137 "../src/preferences.vala"
	adw_combo_row_set_selected (_tmp37_, (guint) ((gint) g_settings_get_enum (_tmp38_, "protocol")));
#line 138 "../src/preferences.vala"
	_tmp39_ = self->priv->protocol;
#line 138 "../src/preferences.vala"
	g_signal_connect_object ((GObject*) _tmp39_, "notify::selected-item", (GCallback) __haguichi_preferences___lambda79__g_object_notify, self, 0);
#line 156 "../src/preferences.vala"
	_tmp40_ = adw_enum_list_model_new (HAGUICHI_PREFERENCES_TYPE_UPDATE_INTERVAL);
#line 156 "../src/preferences.vala"
	model = _tmp40_;
#line 157 "../src/preferences.vala"
	_tmp41_ = g_new0 (GtkExpression*, 0 + 1);
#line 157 "../src/preferences.vala"
	_tmp42_ = (GtkCClosureExpression*) gtk_cclosure_expression_new (G_TYPE_STRING, NULL, 0, _tmp41_, (GCallback) haguichi_preferences_update_interval_name, NULL, NULL);
#line 157 "../src/preferences.vala"
	expression = _tmp42_;
#line 158 "../src/preferences.vala"
	_tmp43_ = self->priv->update_interval;
#line 158 "../src/preferences.vala"
	_tmp44_ = expression;
#line 158 "../src/preferences.vala"
	adw_combo_row_set_expression (_tmp43_, (GtkExpression*) _tmp44_);
#line 159 "../src/preferences.vala"
	_tmp45_ = self->priv->update_interval;
#line 159 "../src/preferences.vala"
	_tmp46_ = model;
#line 159 "../src/preferences.vala"
	adw_combo_row_set_model (_tmp45_, (GListModel*) _tmp46_);
#line 160 "../src/preferences.vala"
	_tmp47_ = self->priv->update_interval;
#line 160 "../src/preferences.vala"
	adw_combo_row_set_selected (_tmp47_, (guint) haguichi_preferences_get_update_interval_row_index (self));
#line 161 "../src/preferences.vala"
	_tmp48_ = self->priv->update_interval;
#line 161 "../src/preferences.vala"
	g_signal_connect_object ((GObject*) _tmp48_, "notify::selected-item", (GCallback) __haguichi_preferences___lambda81__g_object_notify, self, 0);
#line 167 "../src/preferences.vala"
	_tmp49_ = self->priv->behavior;
#line 167 "../src/preferences.vala"
	_tmp50_ = self->priv->connect_on_startup;
#line 167 "../src/preferences.vala"
	g_settings_bind (_tmp49_, "connect-on-startup", (GObject*) _tmp50_, "active", G_SETTINGS_BIND_DEFAULT);
#line 168 "../src/preferences.vala"
	_tmp51_ = self->priv->behavior;
#line 168 "../src/preferences.vala"
	_tmp52_ = self->priv->reconnect_on_connection_loss;
#line 168 "../src/preferences.vala"
	g_settings_bind (_tmp51_, "reconnect-on-connection-loss", (GObject*) _tmp52_, "active", G_SETTINGS_BIND_DEFAULT);
#line 169 "../src/preferences.vala"
	_tmp53_ = self->priv->behavior;
#line 169 "../src/preferences.vala"
	_tmp54_ = self->priv->disconnect_on_quit;
#line 169 "../src/preferences.vala"
	g_settings_bind (_tmp53_, "disconnect-on-quit", (GObject*) _tmp54_, "active", G_SETTINGS_BIND_DEFAULT);
#line 171 "../src/preferences.vala"
	_tmp55_ = self->priv->ui;
#line 171 "../src/preferences.vala"
	scheme = (gint) g_settings_get_enum (_tmp55_, "color-scheme");
#line 172 "../src/preferences.vala"
	if (scheme == 1) {
#line 2215 "preferences.c"
		GtkCheckButton* _tmp56_;
#line 173 "../src/preferences.vala"
		_tmp56_ = self->light;
#line 173 "../src/preferences.vala"
		gtk_check_button_set_active (_tmp56_, TRUE);
#line 2221 "preferences.c"
	} else {
#line 174 "../src/preferences.vala"
		if (scheme == 2) {
#line 2225 "preferences.c"
			GtkCheckButton* _tmp57_;
#line 175 "../src/preferences.vala"
			_tmp57_ = self->dark;
#line 175 "../src/preferences.vala"
			gtk_check_button_set_active (_tmp57_, TRUE);
#line 2231 "preferences.c"
		} else {
			GtkCheckButton* _tmp58_;
#line 177 "../src/preferences.vala"
			_tmp58_ = self->system;
#line 177 "../src/preferences.vala"
			gtk_check_button_set_active (_tmp58_, TRUE);
#line 2238 "preferences.c"
		}
	}
#line 180 "../src/preferences.vala"
	_tmp59_ = self->priv->ui;
#line 180 "../src/preferences.vala"
	_tmp60_ = self->show_indicator;
#line 180 "../src/preferences.vala"
	g_settings_bind (_tmp59_, "show-indicator", (GObject*) _tmp60_, "active", G_SETTINGS_BIND_DEFAULT);
#line 182 "../src/preferences.vala"
	_tmp61_ = self->show_indicator;
#line 182 "../src/preferences.vala"
	_tmp62_ = haguichi_indicator;
#line 182 "../src/preferences.vala"
	_tmp63_ = _tmp62_->item;
#line 182 "../src/preferences.vala"
	_tmp64_ = status_notifier_item_get_host_registered (_tmp63_);
#line 182 "../src/preferences.vala"
	_tmp65_ = _tmp64_;
#line 182 "../src/preferences.vala"
	gtk_widget_set_visible ((GtkWidget*) _tmp61_, _tmp65_);
#line 183 "../src/preferences.vala"
	_tmp66_ = haguichi_indicator;
#line 183 "../src/preferences.vala"
	_tmp67_ = _tmp66_->item;
#line 183 "../src/preferences.vala"
	g_signal_connect_object ((GObject*) _tmp67_, "notify::host-registered", (GCallback) __haguichi_preferences___lambda82__g_object_notify, self, 0);
#line 186 "../src/preferences.vala"
	_tmp68_ = self->show_indicator;
#line 186 "../src/preferences.vala"
	g_signal_connect_object ((GObject*) _tmp68_, "notify::active", (GCallback) __haguichi_preferences___lambda83__g_object_notify, self, 0);
#line 191 "../src/preferences.vala"
	_tmp69_ = self->priv->notifications;
#line 191 "../src/preferences.vala"
	_tmp70_ = self->priv->notify_on_connection_loss;
#line 191 "../src/preferences.vala"
	g_settings_bind (_tmp69_, "connection-loss", (GObject*) _tmp70_, "active", G_SETTINGS_BIND_DEFAULT);
#line 192 "../src/preferences.vala"
	_tmp71_ = self->priv->notifications;
#line 192 "../src/preferences.vala"
	_tmp72_ = self->priv->notify_on_member_join;
#line 192 "../src/preferences.vala"
	g_settings_bind (_tmp71_, "member-join", (GObject*) _tmp72_, "active", G_SETTINGS_BIND_DEFAULT);
#line 193 "../src/preferences.vala"
	_tmp73_ = self->priv->notifications;
#line 193 "../src/preferences.vala"
	_tmp74_ = self->priv->notify_on_member_leave;
#line 193 "../src/preferences.vala"
	g_settings_bind (_tmp73_, "member-leave", (GObject*) _tmp74_, "active", G_SETTINGS_BIND_DEFAULT);
#line 194 "../src/preferences.vala"
	_tmp75_ = self->priv->notifications;
#line 194 "../src/preferences.vala"
	_tmp76_ = self->priv->notify_on_member_online;
#line 194 "../src/preferences.vala"
	g_settings_bind (_tmp75_, "member-online", (GObject*) _tmp76_, "active", G_SETTINGS_BIND_DEFAULT);
#line 195 "../src/preferences.vala"
	_tmp77_ = self->priv->notifications;
#line 195 "../src/preferences.vala"
	_tmp78_ = self->priv->notify_on_member_offline;
#line 195 "../src/preferences.vala"
	g_settings_bind (_tmp77_, "member-offline", (GObject*) _tmp78_, "active", G_SETTINGS_BIND_DEFAULT);
#line 197 "../src/preferences.vala"
	if (haguichi_demo_mode) {
#line 2301 "preferences.c"
		AdwSwitchRow* _tmp79_;
		AdwSwitchRow* _tmp80_;
		AdwSwitchRow* _tmp81_;
		AdwSwitchRow* _tmp82_;
		AdwSwitchRow* _tmp83_;
#line 198 "../src/preferences.vala"
		_tmp79_ = self->priv->notify_on_connection_loss;
#line 198 "../src/preferences.vala"
		g_signal_connect_object ((GObject*) _tmp79_, "notify::active", (GCallback) __haguichi_preferences____lambda84__g_object_notify, self, 0);
#line 201 "../src/preferences.vala"
		_tmp80_ = self->priv->notify_on_member_join;
#line 201 "../src/preferences.vala"
		g_signal_connect_object ((GObject*) _tmp80_, "notify::active", (GCallback) __haguichi_preferences____lambda85__g_object_notify, self, 0);
#line 204 "../src/preferences.vala"
		_tmp81_ = self->priv->notify_on_member_leave;
#line 204 "../src/preferences.vala"
		g_signal_connect_object ((GObject*) _tmp81_, "notify::active", (GCallback) __haguichi_preferences____lambda86__g_object_notify, self, 0);
#line 207 "../src/preferences.vala"
		_tmp82_ = self->priv->notify_on_member_online;
#line 207 "../src/preferences.vala"
		g_signal_connect_object ((GObject*) _tmp82_, "notify::active", (GCallback) __haguichi_preferences____lambda87__g_object_notify, self, 0);
#line 210 "../src/preferences.vala"
		_tmp83_ = self->priv->notify_on_member_offline;
#line 210 "../src/preferences.vala"
		g_signal_connect_object ((GObject*) _tmp83_, "notify::active", (GCallback) __haguichi_preferences____lambda88__g_object_notify, self, 0);
#line 2327 "preferences.c"
	}
#line 81 "../src/preferences.vala"
	_gtk_expression_unref0 (expression);
#line 81 "../src/preferences.vala"
	_g_object_unref0 (model);
#line 81 "../src/preferences.vala"
	return obj;
#line 2335 "preferences.c"
}

static void
haguichi_preferences_class_init (HaguichiPreferencesClass * klass,
                                 gpointer klass_data)
{
#line 16 "../src/preferences.vala"
	haguichi_preferences_parent_class = g_type_class_peek_parent (klass);
#line 16 "../src/preferences.vala"
	g_type_class_adjust_private_offset (klass, &HaguichiPreferences_private_offset);
#line 16 "../src/preferences.vala"
	G_OBJECT_CLASS (klass)->constructor = haguichi_preferences_constructor;
#line 16 "../src/preferences.vala"
	G_OBJECT_CLASS (klass)->finalize = haguichi_preferences_finalize;
#line 16 "../src/preferences.vala"
	gtk_widget_class_set_template_from_resource (GTK_WIDGET_CLASS (klass), "/com/github/ztefn/haguichi/ui/preferences.ui");
#line 16 "../src/preferences.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "general_page", FALSE, HaguichiPreferences_private_offset + G_STRUCT_OFFSET (HaguichiPreferencesPrivate, general_page));
#line 16 "../src/preferences.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "commands_page", FALSE, HaguichiPreferences_private_offset + G_STRUCT_OFFSET (HaguichiPreferencesPrivate, commands_page));
#line 16 "../src/preferences.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "desktop_page", FALSE, HaguichiPreferences_private_offset + G_STRUCT_OFFSET (HaguichiPreferencesPrivate, desktop_page));
#line 16 "../src/preferences.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "configuration", FALSE, HaguichiPreferences_private_offset + G_STRUCT_OFFSET (HaguichiPreferencesPrivate, configuration));
#line 16 "../src/preferences.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "nickname", FALSE, HaguichiPreferences_private_offset + G_STRUCT_OFFSET (HaguichiPreferencesPrivate, nickname));
#line 16 "../src/preferences.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "protocol", FALSE, HaguichiPreferences_private_offset + G_STRUCT_OFFSET (HaguichiPreferencesPrivate, protocol));
#line 16 "../src/preferences.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "update_interval", FALSE, HaguichiPreferences_private_offset + G_STRUCT_OFFSET (HaguichiPreferencesPrivate, update_interval));
#line 16 "../src/preferences.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "connect_on_startup", FALSE, HaguichiPreferences_private_offset + G_STRUCT_OFFSET (HaguichiPreferencesPrivate, connect_on_startup));
#line 16 "../src/preferences.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "reconnect_on_connection_loss", FALSE, HaguichiPreferences_private_offset + G_STRUCT_OFFSET (HaguichiPreferencesPrivate, reconnect_on_connection_loss));
#line 16 "../src/preferences.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "disconnect_on_quit", FALSE, HaguichiPreferences_private_offset + G_STRUCT_OFFSET (HaguichiPreferencesPrivate, disconnect_on_quit));
#line 16 "../src/preferences.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "commands_editor", FALSE, G_STRUCT_OFFSET (HaguichiPreferences, commands_editor));
#line 16 "../src/preferences.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "system", FALSE, G_STRUCT_OFFSET (HaguichiPreferences, system));
#line 16 "../src/preferences.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "light", FALSE, G_STRUCT_OFFSET (HaguichiPreferences, light));
#line 16 "../src/preferences.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "dark", FALSE, G_STRUCT_OFFSET (HaguichiPreferences, dark));
#line 16 "../src/preferences.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "show_indicator", FALSE, G_STRUCT_OFFSET (HaguichiPreferences, show_indicator));
#line 16 "../src/preferences.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "notify_on_connection_loss", FALSE, HaguichiPreferences_private_offset + G_STRUCT_OFFSET (HaguichiPreferencesPrivate, notify_on_connection_loss));
#line 16 "../src/preferences.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "notify_on_member_join", FALSE, HaguichiPreferences_private_offset + G_STRUCT_OFFSET (HaguichiPreferencesPrivate, notify_on_member_join));
#line 16 "../src/preferences.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "notify_on_member_leave", FALSE, HaguichiPreferences_private_offset + G_STRUCT_OFFSET (HaguichiPreferencesPrivate, notify_on_member_leave));
#line 16 "../src/preferences.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "notify_on_member_online", FALSE, HaguichiPreferences_private_offset + G_STRUCT_OFFSET (HaguichiPreferencesPrivate, notify_on_member_online));
#line 16 "../src/preferences.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "notify_on_member_offline", FALSE, HaguichiPreferences_private_offset + G_STRUCT_OFFSET (HaguichiPreferencesPrivate, notify_on_member_offline));
#line 16 "../src/preferences.vala"
	gtk_widget_class_bind_template_callback_full (GTK_WIDGET_CLASS (klass), "on_style_selection", G_CALLBACK(_haguichi_preferences_on_style_selection_g_object_notify));
#line 2394 "preferences.c"
}

static void
haguichi_preferences_instance_init (HaguichiPreferences * self,
                                    gpointer klass)
{
#line 16 "../src/preferences.vala"
	self->priv = haguichi_preferences_get_instance_private (self);
#line 16 "../src/preferences.vala"
	g_type_ensure (HAGUICHI_TYPE_COMMANDS_EDITOR);
#line 16 "../src/preferences.vala"
	gtk_widget_init_template (GTK_WIDGET (self));
#line 2407 "preferences.c"
}

static void
haguichi_preferences_finalize (GObject * obj)
{
	HaguichiPreferences * self;
#line 16 "../src/preferences.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, HAGUICHI_TYPE_PREFERENCES, HaguichiPreferences);
#line 20 "../src/preferences.vala"
	_g_object_unref0 (self->priv->config);
#line 21 "../src/preferences.vala"
	_g_object_unref0 (self->priv->behavior);
#line 22 "../src/preferences.vala"
	_g_object_unref0 (self->priv->notifications);
#line 23 "../src/preferences.vala"
	_g_object_unref0 (self->priv->ui);
#line 16 "../src/preferences.vala"
	G_OBJECT_CLASS (haguichi_preferences_parent_class)->finalize (obj);
#line 2426 "preferences.c"
}

static GType
haguichi_preferences_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (HaguichiPreferencesClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) haguichi_preferences_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (HaguichiPreferences), 0, (GInstanceInitFunc) haguichi_preferences_instance_init, NULL };
	GType haguichi_preferences_type_id;
	haguichi_preferences_type_id = g_type_register_static (adw_preferences_dialog_get_type (), "HaguichiPreferences", &g_define_type_info, 0);
	HaguichiPreferences_private_offset = g_type_add_instance_private (haguichi_preferences_type_id, sizeof (HaguichiPreferencesPrivate));
	return haguichi_preferences_type_id;
}

GType
haguichi_preferences_get_type (void)
{
	static volatile gsize haguichi_preferences_type_id__once = 0;
	if (g_once_init_enter (&haguichi_preferences_type_id__once)) {
		GType haguichi_preferences_type_id;
		haguichi_preferences_type_id = haguichi_preferences_get_type_once ();
		g_once_init_leave (&haguichi_preferences_type_id__once, haguichi_preferences_type_id);
	}
	return haguichi_preferences_type_id__once;
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

