/* utils.c generated by valac 0.56.17, the Vala compiler
 * generated from utils.vala, do not modify */

/*
 * This file is part of Haguichi, a graphical frontend for Hamachi.
 * Copyright (C) 2007-2024 Stephen Brandt <stephen@stephenbrandt.com>
 *
 * Haguichi is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published
 * by the Free Software Foundation, either version 3 of the License,
 * or (at your option) any later version.
 *
 * SPDX-License-Identifier: GPL-3.0-or-later
 */

#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <gtk/gtk.h>
#include <gdk/gdk.h>
#include <glib/gstdio.h>
#include <libportal/portal.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define HAGUICHI_TYPE_UTILS (haguichi_utils_get_type ())
#define HAGUICHI_UTILS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), HAGUICHI_TYPE_UTILS, HaguichiUtils))
#define HAGUICHI_UTILS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), HAGUICHI_TYPE_UTILS, HaguichiUtilsClass))
#define HAGUICHI_IS_UTILS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), HAGUICHI_TYPE_UTILS))
#define HAGUICHI_IS_UTILS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), HAGUICHI_TYPE_UTILS))
#define HAGUICHI_UTILS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), HAGUICHI_TYPE_UTILS, HaguichiUtilsClass))

typedef struct _HaguichiUtils HaguichiUtils;
typedef struct _HaguichiUtilsClass HaguichiUtilsClass;
typedef struct _HaguichiUtilsPrivate HaguichiUtilsPrivate;
enum  {
	HAGUICHI_UTILS_0_PROPERTY,
	HAGUICHI_UTILS_NUM_PROPERTIES
};
static GParamSpec* haguichi_utils_properties[HAGUICHI_UTILS_NUM_PROPERTIES];
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_regex_unref0(var) ((var == NULL) ? NULL : (var = (g_regex_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))

struct _HaguichiUtils {
	GObject parent_instance;
	HaguichiUtilsPrivate * priv;
};

struct _HaguichiUtilsClass {
	GObjectClass parent_class;
};

static gpointer haguichi_utils_parent_class = NULL;

VALA_EXTERN GType haguichi_utils_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (HaguichiUtils, g_object_unref)
VALA_EXTERN gchar* haguichi_utils_remove_mnemonics (gchar* label);
VALA_EXTERN gchar* haguichi_utils_clean_string (gchar* _string);
VALA_EXTERN gchar* haguichi_utils_parse_nick (const gchar* nick);
VALA_EXTERN GtkIconTheme* haguichi_utils_get_icon_theme (void);
VALA_EXTERN gchar* haguichi_utils_get_available_theme_icon (gchar** icon_names,
                                                gint icon_names_length1);
VALA_EXTERN gboolean haguichi_utils_path_exists (const gchar* type,
                                     const gchar* path);
VALA_EXTERN gchar* haguichi_command_return_output (const gchar* command);
VALA_EXTERN HaguichiUtils* haguichi_utils_new (void);
VALA_EXTERN HaguichiUtils* haguichi_utils_construct (GType object_type);
static GType haguichi_utils_get_type_once (void);
static inline gpointer _vala_memdup2 (gconstpointer mem,
                        gsize byte_size);

static gchar*
string_replace (const gchar* self,
                const gchar* old,
                const gchar* replacement)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	GError* _inner_error0_ = NULL;
	gchar* result;
#line 1588 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1588 "glib-2.0.vapi"
	g_return_val_if_fail (old != NULL, NULL);
#line 1588 "glib-2.0.vapi"
	g_return_val_if_fail (replacement != NULL, NULL);
#line 1589 "glib-2.0.vapi"
	if ((*((gchar*) self)) == '\0') {
#line 1589 "glib-2.0.vapi"
		_tmp1_ = TRUE;
#line 110 "utils.c"
	} else {
#line 1589 "glib-2.0.vapi"
		_tmp1_ = (*((gchar*) old)) == '\0';
#line 114 "utils.c"
	}
#line 1589 "glib-2.0.vapi"
	if (_tmp1_) {
#line 1589 "glib-2.0.vapi"
		_tmp0_ = TRUE;
#line 120 "utils.c"
	} else {
#line 1589 "glib-2.0.vapi"
		_tmp0_ = g_strcmp0 (old, replacement) == 0;
#line 124 "utils.c"
	}
#line 1589 "glib-2.0.vapi"
	if (_tmp0_) {
#line 128 "utils.c"
		gchar* _tmp2_;
#line 1590 "glib-2.0.vapi"
		_tmp2_ = g_strdup (self);
#line 1590 "glib-2.0.vapi"
		result = _tmp2_;
#line 1590 "glib-2.0.vapi"
		return result;
#line 136 "utils.c"
	}
	{
		GRegex* regex = NULL;
		gchar* _tmp3_;
		gchar* _tmp4_;
		GRegex* _tmp5_;
		GRegex* _tmp6_;
		gchar* _tmp7_ = NULL;
		GRegex* _tmp8_;
		gchar* _tmp9_;
		gchar* _tmp10_;
#line 1593 "glib-2.0.vapi"
		_tmp3_ = g_regex_escape_string (old, -1);
#line 1593 "glib-2.0.vapi"
		_tmp4_ = _tmp3_;
#line 1593 "glib-2.0.vapi"
		_tmp5_ = g_regex_new (_tmp4_, 0, 0, &_inner_error0_);
#line 1593 "glib-2.0.vapi"
		_tmp6_ = _tmp5_;
#line 1593 "glib-2.0.vapi"
		_g_free0 (_tmp4_);
#line 1593 "glib-2.0.vapi"
		regex = _tmp6_;
#line 1593 "glib-2.0.vapi"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1593 "glib-2.0.vapi"
			if (_inner_error0_->domain == G_REGEX_ERROR) {
#line 164 "utils.c"
				goto __catch0_g_regex_error;
			}
#line 1593 "glib-2.0.vapi"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1593 "glib-2.0.vapi"
			g_clear_error (&_inner_error0_);
#line 1593 "glib-2.0.vapi"
			return NULL;
#line 173 "utils.c"
		}
#line 1594 "glib-2.0.vapi"
		_tmp8_ = regex;
#line 1594 "glib-2.0.vapi"
		_tmp9_ = g_regex_replace_literal (_tmp8_, self, (gssize) -1, 0, replacement, 0, &_inner_error0_);
#line 1594 "glib-2.0.vapi"
		_tmp7_ = _tmp9_;
#line 1594 "glib-2.0.vapi"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1594 "glib-2.0.vapi"
			_g_regex_unref0 (regex);
#line 1594 "glib-2.0.vapi"
			if (_inner_error0_->domain == G_REGEX_ERROR) {
#line 187 "utils.c"
				goto __catch0_g_regex_error;
			}
#line 1594 "glib-2.0.vapi"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1594 "glib-2.0.vapi"
			g_clear_error (&_inner_error0_);
#line 1594 "glib-2.0.vapi"
			return NULL;
#line 196 "utils.c"
		}
#line 1594 "glib-2.0.vapi"
		_tmp10_ = _tmp7_;
#line 1594 "glib-2.0.vapi"
		_tmp7_ = NULL;
#line 1594 "glib-2.0.vapi"
		result = _tmp10_;
#line 1594 "glib-2.0.vapi"
		_g_free0 (_tmp7_);
#line 1594 "glib-2.0.vapi"
		_g_regex_unref0 (regex);
#line 1594 "glib-2.0.vapi"
		return result;
#line 210 "utils.c"
	}
	goto __finally0;
	__catch0_g_regex_error:
	{
#line 1592 "glib-2.0.vapi"
		g_clear_error (&_inner_error0_);
#line 1596 "glib-2.0.vapi"
		g_assert_not_reached ();
#line 219 "utils.c"
	}
	__finally0:
#line 1592 "glib-2.0.vapi"
	g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1592 "glib-2.0.vapi"
	g_clear_error (&_inner_error0_);
#line 1592 "glib-2.0.vapi"
	return NULL;
#line 228 "utils.c"
}

gchar*
haguichi_utils_remove_mnemonics (gchar* label)
{
	gchar* _tmp8_;
	GError* _inner_error0_ = NULL;
	gchar* result;
#line 15 "../src/utils.vala"
	g_return_val_if_fail (label != NULL, NULL);
#line 239 "utils.c"
	{
		GRegex* _tmp0_ = NULL;
		GRegex* _tmp1_;
		gchar* _tmp2_ = NULL;
		gchar* _tmp3_;
		gchar* _tmp4_;
		gchar* _tmp5_;
#line 17 "../src/utils.vala"
		_tmp1_ = g_regex_new ("\\(_[a-zA-Z]\\)", 0, 0, &_inner_error0_);
#line 17 "../src/utils.vala"
		_tmp0_ = _tmp1_;
#line 17 "../src/utils.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 17 "../src/utils.vala"
			if (_inner_error0_->domain == G_REGEX_ERROR) {
#line 255 "utils.c"
				goto __catch0_g_regex_error;
			}
#line 17 "../src/utils.vala"
			_g_free0 (label);
#line 17 "../src/utils.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 17 "../src/utils.vala"
			g_clear_error (&_inner_error0_);
#line 17 "../src/utils.vala"
			return NULL;
#line 266 "utils.c"
		}
#line 17 "../src/utils.vala"
		_tmp3_ = g_regex_replace (_tmp0_, label, (gssize) -1, 0, "", 0, &_inner_error0_);
#line 17 "../src/utils.vala"
		_tmp2_ = _tmp3_;
#line 17 "../src/utils.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 17 "../src/utils.vala"
			_g_regex_unref0 (_tmp0_);
#line 17 "../src/utils.vala"
			if (_inner_error0_->domain == G_REGEX_ERROR) {
#line 278 "utils.c"
				goto __catch0_g_regex_error;
			}
#line 17 "../src/utils.vala"
			_g_free0 (label);
#line 17 "../src/utils.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 17 "../src/utils.vala"
			g_clear_error (&_inner_error0_);
#line 17 "../src/utils.vala"
			return NULL;
#line 289 "utils.c"
		}
#line 17 "../src/utils.vala"
		_tmp4_ = _tmp2_;
#line 17 "../src/utils.vala"
		_tmp2_ = NULL;
#line 17 "../src/utils.vala"
		_g_free0 (label);
#line 17 "../src/utils.vala"
		label = _tmp4_;
#line 18 "../src/utils.vala"
		_tmp5_ = string_replace (label, "_", "");
#line 18 "../src/utils.vala"
		_g_free0 (label);
#line 18 "../src/utils.vala"
		label = _tmp5_;
#line 16 "../src/utils.vala"
		_g_free0 (_tmp2_);
#line 16 "../src/utils.vala"
		_g_regex_unref0 (_tmp0_);
#line 309 "utils.c"
	}
	goto __finally0;
	__catch0_g_regex_error:
	{
		GError* e = NULL;
		GError* _tmp6_;
		const gchar* _tmp7_;
#line 16 "../src/utils.vala"
		e = _inner_error0_;
#line 16 "../src/utils.vala"
		_inner_error0_ = NULL;
#line 20 "../src/utils.vala"
		_tmp6_ = e;
#line 20 "../src/utils.vala"
		_tmp7_ = _tmp6_->message;
#line 20 "../src/utils.vala"
		g_critical ("utils.vala:20: remove_mnemonics: %s", _tmp7_);
#line 16 "../src/utils.vala"
		_g_error_free0 (e);
#line 329 "utils.c"
	}
	__finally0:
#line 16 "../src/utils.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 16 "../src/utils.vala"
		_g_free0 (label);
#line 16 "../src/utils.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 16 "../src/utils.vala"
		g_clear_error (&_inner_error0_);
#line 16 "../src/utils.vala"
		return NULL;
#line 342 "utils.c"
	}
#line 23 "../src/utils.vala"
	_tmp8_ = g_strdup (label);
#line 23 "../src/utils.vala"
	result = _tmp8_;
#line 23 "../src/utils.vala"
	_g_free0 (label);
#line 23 "../src/utils.vala"
	return result;
#line 352 "utils.c"
}

gchar*
haguichi_utils_clean_string (gchar* _string)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* result;
#line 26 "../src/utils.vala"
	g_return_val_if_fail (_string != NULL, NULL);
#line 27 "../src/utils.vala"
	_tmp0_ = string_replace (_string, "\\", "\\\\");
#line 27 "../src/utils.vala"
	_g_free0 (_string);
#line 27 "../src/utils.vala"
	_string = _tmp0_;
#line 28 "../src/utils.vala"
	_tmp1_ = string_replace (_string, "\"", "\\\"");
#line 28 "../src/utils.vala"
	_g_free0 (_string);
#line 28 "../src/utils.vala"
	_string = _tmp1_;
#line 30 "../src/utils.vala"
	_tmp2_ = g_strdup (_string);
#line 30 "../src/utils.vala"
	result = _tmp2_;
#line 30 "../src/utils.vala"
	_g_free0 (_string);
#line 30 "../src/utils.vala"
	return result;
#line 384 "utils.c"
}

gchar*
haguichi_utils_parse_nick (const gchar* nick)
{
	gchar* parsed_nick = NULL;
	gchar* _tmp0_;
	gchar* result;
#line 33 "../src/utils.vala"
	g_return_val_if_fail (nick != NULL, NULL);
#line 34 "../src/utils.vala"
	_tmp0_ = g_strdup (nick);
#line 34 "../src/utils.vala"
	parsed_nick = _tmp0_;
#line 36 "../src/utils.vala"
	if (g_strcmp0 (nick, "%USERNAME") == 0) {
#line 401 "utils.c"
		const gchar* _tmp1_;
		gchar* _tmp2_;
#line 37 "../src/utils.vala"
		_tmp1_ = g_get_user_name ();
#line 37 "../src/utils.vala"
		_tmp2_ = g_strdup (_tmp1_);
#line 37 "../src/utils.vala"
		_g_free0 (parsed_nick);
#line 37 "../src/utils.vala"
		parsed_nick = _tmp2_;
#line 412 "utils.c"
	} else {
#line 38 "../src/utils.vala"
		if (g_strcmp0 (nick, "%REALNAME") == 0) {
#line 416 "utils.c"
			const gchar* _tmp3_;
			gchar* _tmp4_;
#line 39 "../src/utils.vala"
			_tmp3_ = g_get_real_name ();
#line 39 "../src/utils.vala"
			_tmp4_ = g_strdup (_tmp3_);
#line 39 "../src/utils.vala"
			_g_free0 (parsed_nick);
#line 39 "../src/utils.vala"
			parsed_nick = _tmp4_;
#line 427 "utils.c"
		} else {
#line 40 "../src/utils.vala"
			if (g_strcmp0 (nick, "%HOSTNAME") == 0) {
#line 431 "utils.c"
				const gchar* _tmp5_;
				gchar* _tmp6_;
#line 41 "../src/utils.vala"
				_tmp5_ = g_get_host_name ();
#line 41 "../src/utils.vala"
				_tmp6_ = g_strdup (_tmp5_);
#line 41 "../src/utils.vala"
				_g_free0 (parsed_nick);
#line 41 "../src/utils.vala"
				parsed_nick = _tmp6_;
#line 442 "utils.c"
			}
		}
	}
#line 44 "../src/utils.vala"
	result = parsed_nick;
#line 44 "../src/utils.vala"
	return result;
#line 450 "utils.c"
}

GtkIconTheme*
haguichi_utils_get_icon_theme (void)
{
	GdkDisplay* _tmp0_;
	GtkIconTheme* _tmp1_;
	GtkIconTheme* result;
#line 48 "../src/utils.vala"
	_tmp0_ = gdk_display_get_default ();
#line 48 "../src/utils.vala"
	_tmp1_ = gtk_icon_theme_get_for_display (_tmp0_);
#line 48 "../src/utils.vala"
	result = _tmp1_;
#line 48 "../src/utils.vala"
	return result;
#line 467 "utils.c"
}

gchar*
haguichi_utils_get_available_theme_icon (gchar** icon_names,
                                         gint icon_names_length1)
{
	const gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* result;
	{
		gchar** icon_name_collection = NULL;
		gint icon_name_collection_length1 = 0;
		gint _icon_name_collection_size_ = 0;
		gint icon_name_it = 0;
#line 53 "../src/utils.vala"
		icon_name_collection = icon_names;
#line 53 "../src/utils.vala"
		icon_name_collection_length1 = icon_names_length1;
#line 53 "../src/utils.vala"
		for (icon_name_it = 0; icon_name_it < icon_name_collection_length1; icon_name_it = icon_name_it + 1) {
#line 488 "utils.c"
			gchar* _tmp0_;
			gchar* icon_name = NULL;
#line 53 "../src/utils.vala"
			_tmp0_ = g_strdup (icon_name_collection[icon_name_it]);
#line 53 "../src/utils.vala"
			icon_name = _tmp0_;
#line 495 "utils.c"
			{
				GtkIconTheme* _tmp1_;
				const gchar* _tmp2_;
#line 54 "../src/utils.vala"
				_tmp1_ = haguichi_utils_get_icon_theme ();
#line 54 "../src/utils.vala"
				_tmp2_ = icon_name;
#line 54 "../src/utils.vala"
				if (gtk_icon_theme_has_icon (_tmp1_, _tmp2_)) {
#line 55 "../src/utils.vala"
					result = icon_name;
#line 55 "../src/utils.vala"
					return result;
#line 509 "utils.c"
				}
#line 53 "../src/utils.vala"
				_g_free0 (icon_name);
#line 513 "utils.c"
			}
		}
	}
#line 60 "../src/utils.vala"
	_tmp3_ = icon_names[0];
#line 60 "../src/utils.vala"
	_tmp4_ = g_strdup (_tmp3_);
#line 60 "../src/utils.vala"
	result = _tmp4_;
#line 60 "../src/utils.vala"
	return result;
#line 525 "utils.c"
}

static gchar*
bool_to_string (gboolean self)
{
	gchar* result;
#line 37 "glib-2.0.vapi"
	if (self) {
#line 534 "utils.c"
		gchar* _tmp0_;
#line 38 "glib-2.0.vapi"
		_tmp0_ = g_strdup ("true");
#line 38 "glib-2.0.vapi"
		result = _tmp0_;
#line 38 "glib-2.0.vapi"
		return result;
#line 542 "utils.c"
	} else {
		gchar* _tmp1_;
#line 40 "glib-2.0.vapi"
		_tmp1_ = g_strdup ("false");
#line 40 "glib-2.0.vapi"
		result = _tmp1_;
#line 40 "glib-2.0.vapi"
		return result;
#line 551 "utils.c"
	}
}

static gboolean
string_contains (const gchar* self,
                 const gchar* needle)
{
	gchar* _tmp0_;
	gboolean result;
#line 1584 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1584 "glib-2.0.vapi"
	g_return_val_if_fail (needle != NULL, FALSE);
#line 1585 "glib-2.0.vapi"
	_tmp0_ = strstr ((gchar*) self, (gchar*) needle);
#line 1585 "glib-2.0.vapi"
	result = _tmp0_ != NULL;
#line 1585 "glib-2.0.vapi"
	return result;
#line 571 "utils.c"
}

gboolean
haguichi_utils_path_exists (const gchar* type,
                            const gchar* path)
{
	gboolean _result_ = FALSE;
	gchar* _tmp0_;
	gchar* _tmp1_;
	gboolean result;
#line 63 "../src/utils.vala"
	g_return_val_if_fail (type != NULL, FALSE);
#line 63 "../src/utils.vala"
	g_return_val_if_fail (path != NULL, FALSE);
#line 64 "../src/utils.vala"
	_result_ = g_file_test (path, G_FILE_TEST_EXISTS);
#line 65 "../src/utils.vala"
	_tmp0_ = bool_to_string (_result_);
#line 65 "../src/utils.vala"
	_tmp1_ = _tmp0_;
#line 65 "../src/utils.vala"
	g_debug ("utils.vala:65: path_exists: FileUtils tested %s for path %s", _tmp1_, path);
#line 65 "../src/utils.vala"
	_g_free0 (_tmp1_);
#line 67 "../src/utils.vala"
	if (_result_) {
#line 68 "../src/utils.vala"
		result = TRUE;
#line 68 "../src/utils.vala"
		return result;
#line 602 "utils.c"
	}
#line 71 "../src/utils.vala"
	if (xdp_portal_running_under_flatpak ()) {
#line 606 "utils.c"
		gchar* output = NULL;
		gchar* _tmp2_;
		gchar* _tmp3_;
		gchar* _tmp4_;
		gchar* _tmp5_;
		const gchar* _tmp6_;
		const gchar* _tmp7_;
#line 72 "../src/utils.vala"
		_tmp2_ = g_strdup_printf ("bash -c \"test -%s %s &>/dev/null || echo 'path not found'\"", type, path);
#line 72 "../src/utils.vala"
		_tmp3_ = _tmp2_;
#line 72 "../src/utils.vala"
		_tmp4_ = haguichi_command_return_output (_tmp3_);
#line 72 "../src/utils.vala"
		_tmp5_ = _tmp4_;
#line 72 "../src/utils.vala"
		_g_free0 (_tmp3_);
#line 72 "../src/utils.vala"
		output = _tmp5_;
#line 73 "../src/utils.vala"
		_tmp6_ = output;
#line 73 "../src/utils.vala"
		g_debug ("utils.vala:73: path_exists test output: %s", _tmp6_);
#line 75 "../src/utils.vala"
		_tmp7_ = output;
#line 75 "../src/utils.vala"
		if (!string_contains (_tmp7_, "path not found")) {
#line 76 "../src/utils.vala"
			result = TRUE;
#line 76 "../src/utils.vala"
			_g_free0 (output);
#line 76 "../src/utils.vala"
			return result;
#line 640 "utils.c"
		}
#line 71 "../src/utils.vala"
		_g_free0 (output);
#line 644 "utils.c"
	}
#line 80 "../src/utils.vala"
	g_debug ("utils.vala:80: path_exists: Path %s was not found", path);
#line 81 "../src/utils.vala"
	result = FALSE;
#line 81 "../src/utils.vala"
	return result;
#line 652 "utils.c"
}

HaguichiUtils*
haguichi_utils_construct (GType object_type)
{
	HaguichiUtils * self = NULL;
#line 14 "../src/utils.vala"
	self = (HaguichiUtils*) g_object_new (object_type, NULL);
#line 14 "../src/utils.vala"
	return self;
#line 663 "utils.c"
}

HaguichiUtils*
haguichi_utils_new (void)
{
#line 14 "../src/utils.vala"
	return haguichi_utils_construct (HAGUICHI_TYPE_UTILS);
#line 671 "utils.c"
}

static void
haguichi_utils_class_init (HaguichiUtilsClass * klass,
                           gpointer klass_data)
{
#line 14 "../src/utils.vala"
	haguichi_utils_parent_class = g_type_class_peek_parent (klass);
#line 680 "utils.c"
}

static void
haguichi_utils_instance_init (HaguichiUtils * self,
                              gpointer klass)
{
}

static GType
haguichi_utils_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (HaguichiUtilsClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) haguichi_utils_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (HaguichiUtils), 0, (GInstanceInitFunc) haguichi_utils_instance_init, NULL };
	GType haguichi_utils_type_id;
	haguichi_utils_type_id = g_type_register_static (G_TYPE_OBJECT, "HaguichiUtils", &g_define_type_info, 0);
	return haguichi_utils_type_id;
}

GType
haguichi_utils_get_type (void)
{
	static volatile gsize haguichi_utils_type_id__once = 0;
	if (g_once_init_enter (&haguichi_utils_type_id__once)) {
		GType haguichi_utils_type_id;
		haguichi_utils_type_id = haguichi_utils_get_type_once ();
		g_once_init_leave (&haguichi_utils_type_id__once, haguichi_utils_type_id);
	}
	return haguichi_utils_type_id__once;
}

static inline gpointer
_vala_memdup2 (gconstpointer mem,
               gsize byte_size)
{
	gpointer new_mem;
	if (mem && byte_size != 0) {
		new_mem = g_malloc (byte_size);
		memcpy (new_mem, mem, byte_size);
	} else {
		new_mem = NULL;
	}
	return new_mem;
}

