/* window.c generated by valac 0.56.17, the Vala compiler
 * generated from window.vala, do not modify */

/*
 * This file is part of Haguichi, a graphical frontend for Hamachi.
 * Copyright (C) 2007-2024 Stephen Brandt <stephen@stephenbrandt.com>
 *
 * Haguichi is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published
 * by the Free Software Foundation, either version 3 of the License,
 * or (at your option) any later version.
 *
 * SPDX-License-Identifier: GPL-3.0-or-later
 */

#include <adwaita.h>
#include <glib-object.h>
#include <gtk/gtk.h>
#include <libportal/portal.h>
#include <glib.h>
#include <stdlib.h>
#include <string.h>
#include <gio/gio.h>
#include <glib/gi18n-lib.h>
#include <libportal-gtk4/portal-gtk4.h>

#define CONFIG_APP_NAME "Haguichi"
#define CONFIG_APP_ID "com.github.ztefn.haguichi"
#define CONFIG_VERSION "1.5.1"
#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define HAGUICHI_TYPE_WINDOW (haguichi_window_get_type ())
#define HAGUICHI_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), HAGUICHI_TYPE_WINDOW, HaguichiWindow))
#define HAGUICHI_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), HAGUICHI_TYPE_WINDOW, HaguichiWindowClass))
#define HAGUICHI_IS_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), HAGUICHI_TYPE_WINDOW))
#define HAGUICHI_IS_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), HAGUICHI_TYPE_WINDOW))
#define HAGUICHI_WINDOW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), HAGUICHI_TYPE_WINDOW, HaguichiWindowClass))

typedef struct _HaguichiWindow HaguichiWindow;
typedef struct _HaguichiWindowClass HaguichiWindowClass;
typedef struct _HaguichiWindowPrivate HaguichiWindowPrivate;

#define HAGUICHI_TYPE_SIDEBAR (haguichi_sidebar_get_type ())
#define HAGUICHI_SIDEBAR(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), HAGUICHI_TYPE_SIDEBAR, HaguichiSidebar))
#define HAGUICHI_SIDEBAR_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), HAGUICHI_TYPE_SIDEBAR, HaguichiSidebarClass))
#define HAGUICHI_IS_SIDEBAR(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), HAGUICHI_TYPE_SIDEBAR))
#define HAGUICHI_IS_SIDEBAR_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), HAGUICHI_TYPE_SIDEBAR))
#define HAGUICHI_SIDEBAR_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), HAGUICHI_TYPE_SIDEBAR, HaguichiSidebarClass))

typedef struct _HaguichiSidebar HaguichiSidebar;
typedef struct _HaguichiSidebarClass HaguichiSidebarClass;

#define HAGUICHI_TYPE_NETWORK_LIST (haguichi_network_list_get_type ())
#define HAGUICHI_NETWORK_LIST(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), HAGUICHI_TYPE_NETWORK_LIST, HaguichiNetworkList))
#define HAGUICHI_NETWORK_LIST_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), HAGUICHI_TYPE_NETWORK_LIST, HaguichiNetworkListClass))
#define HAGUICHI_IS_NETWORK_LIST(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), HAGUICHI_TYPE_NETWORK_LIST))
#define HAGUICHI_IS_NETWORK_LIST_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), HAGUICHI_TYPE_NETWORK_LIST))
#define HAGUICHI_NETWORK_LIST_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), HAGUICHI_TYPE_NETWORK_LIST, HaguichiNetworkListClass))

typedef struct _HaguichiNetworkList HaguichiNetworkList;
typedef struct _HaguichiNetworkListClass HaguichiNetworkListClass;

#define HAGUICHI_TYPE_THROBBER (haguichi_throbber_get_type ())
#define HAGUICHI_THROBBER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), HAGUICHI_TYPE_THROBBER, HaguichiThrobber))
#define HAGUICHI_THROBBER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), HAGUICHI_TYPE_THROBBER, HaguichiThrobberClass))
#define HAGUICHI_IS_THROBBER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), HAGUICHI_TYPE_THROBBER))
#define HAGUICHI_IS_THROBBER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), HAGUICHI_TYPE_THROBBER))
#define HAGUICHI_THROBBER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), HAGUICHI_TYPE_THROBBER, HaguichiThrobberClass))

typedef struct _HaguichiThrobber HaguichiThrobber;
typedef struct _HaguichiThrobberClass HaguichiThrobberClass;
enum  {
	HAGUICHI_WINDOW_0_PROPERTY,
	HAGUICHI_WINDOW_NUM_PROPERTIES
};
static GParamSpec* haguichi_window_properties[HAGUICHI_WINDOW_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

#define HAGUICHI_TYPE_APPLICATION (haguichi_application_get_type ())
#define HAGUICHI_APPLICATION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), HAGUICHI_TYPE_APPLICATION, HaguichiApplication))
#define HAGUICHI_APPLICATION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), HAGUICHI_TYPE_APPLICATION, HaguichiApplicationClass))
#define HAGUICHI_IS_APPLICATION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), HAGUICHI_TYPE_APPLICATION))
#define HAGUICHI_IS_APPLICATION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), HAGUICHI_TYPE_APPLICATION))
#define HAGUICHI_APPLICATION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), HAGUICHI_TYPE_APPLICATION, HaguichiApplicationClass))

typedef struct _HaguichiApplication HaguichiApplication;
typedef struct _HaguichiApplicationClass HaguichiApplicationClass;
#define _g_free0(var) (var = (g_free (var), NULL))

#define HAGUICHI_TYPE_INDICATOR (haguichi_indicator_get_type ())
#define HAGUICHI_INDICATOR(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), HAGUICHI_TYPE_INDICATOR, HaguichiIndicator))
#define HAGUICHI_INDICATOR_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), HAGUICHI_TYPE_INDICATOR, HaguichiIndicatorClass))
#define HAGUICHI_IS_INDICATOR(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), HAGUICHI_TYPE_INDICATOR))
#define HAGUICHI_IS_INDICATOR_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), HAGUICHI_TYPE_INDICATOR))
#define HAGUICHI_INDICATOR_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), HAGUICHI_TYPE_INDICATOR, HaguichiIndicatorClass))

typedef struct _HaguichiIndicator HaguichiIndicator;
typedef struct _HaguichiIndicatorClass HaguichiIndicatorClass;
#define _haguichi_indicator_unref0(var) ((var == NULL) ? NULL : (var = (haguichi_indicator_unref (var), NULL)))

#define HAGUICHI_TYPE_SESSION (haguichi_session_get_type ())
#define HAGUICHI_SESSION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), HAGUICHI_TYPE_SESSION, HaguichiSession))
#define HAGUICHI_SESSION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), HAGUICHI_TYPE_SESSION, HaguichiSessionClass))
#define HAGUICHI_IS_SESSION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), HAGUICHI_TYPE_SESSION))
#define HAGUICHI_IS_SESSION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), HAGUICHI_TYPE_SESSION))
#define HAGUICHI_SESSION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), HAGUICHI_TYPE_SESSION, HaguichiSessionClass))

typedef struct _HaguichiSession HaguichiSession;
typedef struct _HaguichiSessionClass HaguichiSessionClass;

#define HAGUICHI_TYPE_JOIN_CREATE_NETWORK_DIALOG (haguichi_join_create_network_dialog_get_type ())
#define HAGUICHI_JOIN_CREATE_NETWORK_DIALOG(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), HAGUICHI_TYPE_JOIN_CREATE_NETWORK_DIALOG, HaguichiJoinCreateNetworkDialog))
#define HAGUICHI_JOIN_CREATE_NETWORK_DIALOG_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), HAGUICHI_TYPE_JOIN_CREATE_NETWORK_DIALOG, HaguichiJoinCreateNetworkDialogClass))
#define HAGUICHI_IS_JOIN_CREATE_NETWORK_DIALOG(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), HAGUICHI_TYPE_JOIN_CREATE_NETWORK_DIALOG))
#define HAGUICHI_IS_JOIN_CREATE_NETWORK_DIALOG_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), HAGUICHI_TYPE_JOIN_CREATE_NETWORK_DIALOG))
#define HAGUICHI_JOIN_CREATE_NETWORK_DIALOG_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), HAGUICHI_TYPE_JOIN_CREATE_NETWORK_DIALOG, HaguichiJoinCreateNetworkDialogClass))

typedef struct _HaguichiJoinCreateNetworkDialog HaguichiJoinCreateNetworkDialog;
typedef struct _HaguichiJoinCreateNetworkDialogClass HaguichiJoinCreateNetworkDialogClass;

#define HAGUICHI_TYPE_ATTACH_DIALOG (haguichi_attach_dialog_get_type ())
#define HAGUICHI_ATTACH_DIALOG(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), HAGUICHI_TYPE_ATTACH_DIALOG, HaguichiAttachDialog))
#define HAGUICHI_ATTACH_DIALOG_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), HAGUICHI_TYPE_ATTACH_DIALOG, HaguichiAttachDialogClass))
#define HAGUICHI_IS_ATTACH_DIALOG(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), HAGUICHI_TYPE_ATTACH_DIALOG))
#define HAGUICHI_IS_ATTACH_DIALOG_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), HAGUICHI_TYPE_ATTACH_DIALOG))
#define HAGUICHI_ATTACH_DIALOG_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), HAGUICHI_TYPE_ATTACH_DIALOG, HaguichiAttachDialogClass))

typedef struct _HaguichiAttachDialog HaguichiAttachDialog;
typedef struct _HaguichiAttachDialogClass HaguichiAttachDialogClass;
#define _g_thread_unref0(var) ((var == NULL) ? NULL : (var = (g_thread_unref (var), NULL)))

#define HAGUICHI_TYPE_PREFERENCES (haguichi_preferences_get_type ())
#define HAGUICHI_PREFERENCES(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), HAGUICHI_TYPE_PREFERENCES, HaguichiPreferences))
#define HAGUICHI_PREFERENCES_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), HAGUICHI_TYPE_PREFERENCES, HaguichiPreferencesClass))
#define HAGUICHI_IS_PREFERENCES(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), HAGUICHI_TYPE_PREFERENCES))
#define HAGUICHI_IS_PREFERENCES_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), HAGUICHI_TYPE_PREFERENCES))
#define HAGUICHI_PREFERENCES_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), HAGUICHI_TYPE_PREFERENCES, HaguichiPreferencesClass))

typedef struct _HaguichiPreferences HaguichiPreferences;
typedef struct _HaguichiPreferencesClass HaguichiPreferencesClass;

#define HAGUICHI_TYPE_CONNECTION (haguichi_connection_get_type ())
#define HAGUICHI_CONNECTION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), HAGUICHI_TYPE_CONNECTION, HaguichiConnection))
#define HAGUICHI_CONNECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), HAGUICHI_TYPE_CONNECTION, HaguichiConnectionClass))
#define HAGUICHI_IS_CONNECTION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), HAGUICHI_TYPE_CONNECTION))
#define HAGUICHI_IS_CONNECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), HAGUICHI_TYPE_CONNECTION))
#define HAGUICHI_CONNECTION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), HAGUICHI_TYPE_CONNECTION, HaguichiConnectionClass))

typedef struct _HaguichiConnection HaguichiConnection;
typedef struct _HaguichiConnectionClass HaguichiConnectionClass;
typedef struct _HaguichiSidebarPrivate HaguichiSidebarPrivate;
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
typedef struct _HaguichiWindowSetBackgroundStatusData HaguichiWindowSetBackgroundStatusData;
#define _g_ptr_array_unref0(var) ((var == NULL) ? NULL : (var = (g_ptr_array_unref (var), NULL)))
#define __vala_XdpParent_free0(var) ((var == NULL) ? NULL : (var = (_vala_XdpParent_free (var), NULL)))
typedef struct _HaguichiWindowRequestBackgroundData HaguichiWindowRequestBackgroundData;

struct _HaguichiWindow {
	AdwApplicationWindow parent_instance;
	HaguichiWindowPrivate * priv;
	AdwOverlaySplitView* split_view;
	AdwWindowTitle* window_title;
	AdwStatusPage* not_installed_status_page;
	HaguichiSidebar* sidebar;
	HaguichiNetworkList* network_list;
	GtkToggleButton* connect_button;
	GtkToggleButton* disconnect_button;
	GtkToggleButton* search_button;
	GtkSearchBar* search_bar;
	GtkSearchEntry* search_entry;
	GtkStack* stack;
	GtkStack* connected_stack;
	HaguichiThrobber* throbber;
	GtkWidget* modal_dialog;
};

struct _HaguichiWindowClass {
	AdwApplicationWindowClass parent_class;
};

struct _HaguichiWindowPrivate {
	AdwToastOverlay* toast_overlay;
	GtkButton* refresh_button;
	GtkButton* configure_button;
	GtkButton* overlay_refresh_button;
	GtkMenuButton* overlay_add_network_button;
	XdpPortal* portal;
};

struct _HaguichiSidebar {
	AdwBin parent_instance;
	HaguichiSidebarPrivate * priv;
	GtkButton* attach_button;
	GtkButton* cancel_button;
	GtkButton* network_leave_button;
	GtkButton* network_delete_button;
	GtkButton* network_password_button;
	GtkButton* network_access_button;
	GtkButton* network_go_online_button;
	GtkButton* network_go_offline_button;
	GtkButton* member_approve_button;
	GtkButton* member_reject_button;
	GtkButton* member_evict_button;
};

struct _HaguichiSidebarClass {
	AdwBinClass parent_class;
};

struct _HaguichiWindowSetBackgroundStatusData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	HaguichiWindow* self;
	gboolean success;
	XdpPortal* _tmp0_;
	AdwWindowTitle* _tmp1_;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	GError* e;
	GError* _tmp4_;
	const gchar* _tmp5_;
	GError* _inner_error0_;
};

struct _HaguichiWindowRequestBackgroundData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	HaguichiWindow* self;
	gboolean result;
	XdpParent* parent;
	XdpParent* _tmp0_;
	GPtrArray* command;
	GPtrArray* _tmp1_;
	gboolean _tmp2_;
	XdpPortal* _tmp3_;
	GPtrArray* _tmp4_;
	GError* e;
	GError* _tmp5_;
	const gchar* _tmp6_;
	GError* _inner_error0_;
};

static gint HaguichiWindow_private_offset;
static gpointer haguichi_window_parent_class = NULL;
VALA_EXTERN gchar* haguichi_current_desktop;
VALA_EXTERN gboolean haguichi_demo_mode;
VALA_EXTERN HaguichiIndicator* haguichi_indicator;
VALA_EXTERN HaguichiSession* haguichi_session;
VALA_EXTERN gint haguichi_controller_last_status;
VALA_EXTERN HaguichiConnection* haguichi_connection;
VALA_EXTERN HaguichiApplication* haguichi_app;
VALA_EXTERN gchar* haguichi_hamachi_version;

VALA_EXTERN GType haguichi_window_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (HaguichiWindow, g_object_unref)
VALA_EXTERN GType haguichi_sidebar_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (HaguichiSidebar, g_object_unref)
VALA_EXTERN GType haguichi_network_list_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (HaguichiNetworkList, g_object_unref)
VALA_EXTERN GType haguichi_throbber_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (HaguichiThrobber, g_object_unref)
VALA_EXTERN GType haguichi_application_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (HaguichiApplication, g_object_unref)
VALA_EXTERN HaguichiWindow* haguichi_window_new (HaguichiApplication* app);
VALA_EXTERN HaguichiWindow* haguichi_window_construct (GType object_type,
                                           HaguichiApplication* app);
VALA_EXTERN gchar* haguichi_utils_parse_nick (const gchar* nick);
VALA_EXTERN void haguichi_window_set_nick (HaguichiWindow* self,
                               const gchar* nick);
VALA_EXTERN void haguichi_application_set_color_scheme (HaguichiApplication* self,
                                            gint scheme);
VALA_EXTERN HaguichiIndicator* haguichi_indicator_new (void);
VALA_EXTERN HaguichiIndicator* haguichi_indicator_construct (GType object_type);
VALA_EXTERN gpointer haguichi_indicator_ref (gpointer instance);
VALA_EXTERN void haguichi_indicator_unref (gpointer instance);
VALA_EXTERN GParamSpec* haguichi_param_spec_indicator (const gchar* name,
                                           const gchar* nick,
                                           const gchar* blurb,
                                           GType object_type,
                                           GParamFlags flags);
VALA_EXTERN void haguichi_value_set_indicator (GValue* value,
                                   gpointer v_object);
VALA_EXTERN void haguichi_value_take_indicator (GValue* value,
                                    gpointer v_object);
VALA_EXTERN gpointer haguichi_value_get_indicator (const GValue* value);
VALA_EXTERN GType haguichi_indicator_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (HaguichiIndicator, haguichi_indicator_unref)
VALA_EXTERN void haguichi_indicator_set_active (HaguichiIndicator* self,
                                    gboolean value);
VALA_EXTERN void haguichi_window_update_indicator_status (HaguichiWindow* self);
static void __lambda130_ (HaguichiWindow* self);
VALA_EXTERN void haguichi_network_list_refilter (HaguichiNetworkList* self);
static void ___lambda130__gtk_search_entry_search_changed (GtkSearchEntry* _sender,
                                                    gpointer self);
static void __lambda131_ (HaguichiWindow* self);
VALA_EXTERN GType haguichi_session_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (HaguichiSession, g_object_unref)
VALA_EXTERN guint haguichi_session_register_object (void* object,
                                        GDBusConnection* connection,
                                        const gchar* path,
                                        GError** error);
static void ___lambda131__gtk_widget_hide (GtkWidget* _sender,
                                    gpointer self);
static void __lambda132_ (HaguichiWindow* self);
static void ___lambda132__gtk_widget_show (GtkWidget* _sender,
                                    gpointer self);
static void haguichi_window_download_hamachi (HaguichiWindow* self);
VALA_EXTERN void haguichi_command_open_redirect_uri (const gchar* action);
static void _haguichi_window_download_hamachi_gtk_button_clicked (GtkButton* _sender,
                                                           gpointer self);
static void haguichi_window_configure_hamachi (HaguichiWindow* self);
VALA_EXTERN void haguichi_hamachi_configure (void);
static void _haguichi_window_configure_hamachi_gtk_button_clicked (GtkButton* _sender,
                                                            gpointer self);
static void haguichi_window_go_back_button_clicked (HaguichiWindow* self);
static void _haguichi_window_go_back_button_clicked_gtk_button_clicked (GtkButton* _sender,
                                                                 gpointer self);
VALA_EXTERN void haguichi_window_connect_action (HaguichiWindow* self);
VALA_EXTERN void haguichi_controller_start_hamachi (void);
VALA_EXTERN void haguichi_window_disconnect_action (HaguichiWindow* self);
VALA_EXTERN void haguichi_controller_stop_hamachi (void);
VALA_EXTERN void haguichi_window_join_network_action (HaguichiWindow* self);
static void haguichi_window_add_network_action (HaguichiWindow* self,
                                         const gchar* mode);
VALA_EXTERN void haguichi_window_create_network_action (HaguichiWindow* self);
VALA_EXTERN GType haguichi_join_create_network_dialog_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (HaguichiJoinCreateNetworkDialog, g_object_unref)
VALA_EXTERN HaguichiJoinCreateNetworkDialog* haguichi_join_create_network_dialog_new (const gchar* _mode);
VALA_EXTERN HaguichiJoinCreateNetworkDialog* haguichi_join_create_network_dialog_construct (GType object_type,
                                                                                const gchar* _mode);
VALA_EXTERN void haguichi_window_show_dialog (HaguichiWindow* self,
                                  GtkWidget* widget);
static void haguichi_window_attach_action (HaguichiWindow* self);
VALA_EXTERN GType haguichi_attach_dialog_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (HaguichiAttachDialog, g_object_unref)
VALA_EXTERN HaguichiAttachDialog* haguichi_attach_dialog_new (void);
VALA_EXTERN HaguichiAttachDialog* haguichi_attach_dialog_construct (GType object_type);
static void haguichi_window_attach_cancel_action (HaguichiWindow* self);
static void* __lambda135_ (HaguichiWindow* self);
VALA_EXTERN gchar* haguichi_hamachi_cancel (void);
static gpointer ___lambda135__gthread_func (gpointer self);
VALA_EXTERN void haguichi_sidebar_set_account (HaguichiSidebar* self,
                                   const gchar* account);
static void haguichi_window_start_search_action (HaguichiWindow* self);
static void haguichi_window_refresh_action (HaguichiWindow* self);
VALA_EXTERN void haguichi_controller_init (void);
VALA_EXTERN void haguichi_controller_update_connection (void);
static void haguichi_window_toggle_sidebar_action (HaguichiWindow* self);
VALA_EXTERN void haguichi_window_toggle_sidebar (HaguichiWindow* self);
static void haguichi_window_cycle_mode_action (HaguichiWindow* self);
VALA_EXTERN gchar* haguichi_window_get_mode (HaguichiWindow* self);
VALA_EXTERN void haguichi_window_set_mode (HaguichiWindow* self,
                               const gchar* mode);
VALA_EXTERN void haguichi_window_expand_all_networks_action (HaguichiWindow* self);
VALA_EXTERN void haguichi_network_list_set_all_rows_expanded (HaguichiNetworkList* self,
                                                  gboolean expanded);
VALA_EXTERN void haguichi_window_collapse_all_networks_action (HaguichiWindow* self);
VALA_EXTERN void haguichi_window_preferences_action (HaguichiWindow* self);
VALA_EXTERN GType haguichi_preferences_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (HaguichiPreferences, g_object_unref)
VALA_EXTERN HaguichiPreferences* haguichi_preferences_new (void);
VALA_EXTERN HaguichiPreferences* haguichi_preferences_construct (GType object_type);
static void haguichi_window_shortcuts_action (HaguichiWindow* self);
static void haguichi_window_help_action (HaguichiWindow* self);
VALA_EXTERN void haguichi_window_info_action (HaguichiWindow* self);
VALA_EXTERN void haguichi_window_show_info (HaguichiWindow* self);
VALA_EXTERN void haguichi_window_about_action (HaguichiWindow* self);
VALA_EXTERN void haguichi_window_quit_action (HaguichiWindow* self);
VALA_EXTERN void haguichi_controller_quit (void);
VALA_EXTERN GType haguichi_connection_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (HaguichiConnection, g_object_unref)
VALA_EXTERN void haguichi_connection_save_long_nicks (HaguichiConnection* self);
static gboolean ___lambda52_ (HaguichiWindow* self);
static void haguichi_window_set_modal_dialog (HaguichiWindow* self,
                                       GtkWidget* dialog);
static gboolean ____lambda52__gtk_window_close_request (GtkWindow* _sender,
                                                 gpointer self);
static void ____lambda65_ (HaguichiWindow* self);
static void _____lambda65__adw_dialog_closed (AdwDialog* _sender,
                                       gpointer self);
VALA_EXTERN void haguichi_window_show_toast (HaguichiWindow* self,
                                 const gchar* title,
                                 guint timeout);
VALA_EXTERN void haguichi_window_show_copied_to_clipboard_toast (HaguichiWindow* self);
VALA_EXTERN void haguichi_network_list_unselect (HaguichiNetworkList* self);
VALA_EXTERN void haguichi_window_show_sidebar (HaguichiWindow* self);
VALA_EXTERN void haguichi_window_hide_sidebar (HaguichiWindow* self);
VALA_EXTERN void haguichi_window_set_connected_stack_page (HaguichiWindow* self,
                                               const gchar* page);
VALA_EXTERN void haguichi_throbber_set_spinning (HaguichiThrobber* self,
                                     gboolean value);
VALA_EXTERN void haguichi_sidebar_show_page (HaguichiSidebar* self,
                                 const gchar* page);
VALA_EXTERN void haguichi_window_set_background_status (HaguichiWindow* self,
                                            GAsyncReadyCallback _callback_,
                                            gpointer _user_data_);
VALA_EXTERN void haguichi_window_set_background_status_finish (HaguichiWindow* self,
                                                   GAsyncResult* _res_);
static void haguichi_window_set_background_status_data_free (gpointer _data);
static gboolean haguichi_window_set_background_status_co (HaguichiWindowSetBackgroundStatusData* _data_);
static void haguichi_window_set_background_status_ready (GObject* source_object,
                                                  GAsyncResult* _res_,
                                                  gpointer _user_data_);
VALA_EXTERN void haguichi_indicator_update_status (HaguichiIndicator* self,
                                       const gchar* mode,
                                       gboolean modal,
                                       gboolean visible);
static void haguichi_window_real_hide (GtkWidget* base);
static gboolean haguichi_window_real_close_request (GtkWindow* base);
VALA_EXTERN void haguichi_window_request_background (HaguichiWindow* self,
                                         GAsyncReadyCallback _callback_,
                                         gpointer _user_data_);
VALA_EXTERN gboolean haguichi_window_request_background_finish (HaguichiWindow* self,
                                                    GAsyncResult* _res_);
static void ___lambda136_ (HaguichiWindow* self,
                    GObject* obj,
                    GAsyncResult* res);
static void ____lambda136__gasync_ready_callback (GObject* source_object,
                                           GAsyncResult* res,
                                           gpointer self);
static void haguichi_window_request_background_data_free (gpointer _data);
static gboolean haguichi_window_request_background_co (HaguichiWindowRequestBackgroundData* _data_);
static void haguichi_window_request_background_ready (GObject* source_object,
                                               GAsyncResult* _res_,
                                               gpointer _user_data_);
static void _vala_XdpParent_free (XdpParent* self);
static GObject * haguichi_window_constructor (GType type,
                                       guint n_construct_properties,
                                       GObjectConstructParam * construct_properties);
static void haguichi_window_finalize (GObject * obj);
static GType haguichi_window_get_type_once (void);
static gssize _vala_array_length (gpointer array);
static inline gpointer _vala_memdup2 (gconstpointer mem,
                        gsize byte_size);

static inline gpointer
haguichi_window_get_instance_private (HaguichiWindow* self)
{
	return G_STRUCT_MEMBER_P (self, HaguichiWindow_private_offset);
}

static void
__lambda130_ (HaguichiWindow* self)
{
	HaguichiNetworkList* _tmp0_;
#line 100 "../src/window.vala"
	_tmp0_ = self->network_list;
#line 100 "../src/window.vala"
	haguichi_network_list_refilter (_tmp0_);
#line 471 "window.c"
}

static void
___lambda130__gtk_search_entry_search_changed (GtkSearchEntry* _sender,
                                               gpointer self)
{
#line 99 "../src/window.vala"
	__lambda130_ ((HaguichiWindow*) self);
#line 480 "window.c"
}

static void
__lambda131_ (HaguichiWindow* self)
{
	HaguichiSession* _tmp0_;
#line 104 "../src/window.vala"
	_tmp0_ = haguichi_session;
#line 104 "../src/window.vala"
	g_signal_emit_by_name (_tmp0_, "visibility-changed", FALSE);
#line 105 "../src/window.vala"
	haguichi_window_update_indicator_status (self);
#line 493 "window.c"
}

static void
___lambda131__gtk_widget_hide (GtkWidget* _sender,
                               gpointer self)
{
#line 103 "../src/window.vala"
	__lambda131_ ((HaguichiWindow*) self);
#line 502 "window.c"
}

static void
__lambda132_ (HaguichiWindow* self)
{
	HaguichiSession* _tmp0_;
#line 108 "../src/window.vala"
	_tmp0_ = haguichi_session;
#line 108 "../src/window.vala"
	g_signal_emit_by_name (_tmp0_, "visibility-changed", TRUE);
#line 109 "../src/window.vala"
	haguichi_window_update_indicator_status (self);
#line 515 "window.c"
}

static void
___lambda132__gtk_widget_show (GtkWidget* _sender,
                               gpointer self)
{
#line 107 "../src/window.vala"
	__lambda132_ ((HaguichiWindow*) self);
#line 524 "window.c"
}

HaguichiWindow*
haguichi_window_construct (GType object_type,
                           HaguichiApplication* app)
{
	HaguichiWindow * self = NULL;
	const gchar* _tmp0_;
	GSettings* config = NULL;
	GSettings* _tmp1_;
	GSettings* list = NULL;
	GSettings* _tmp2_;
	GSettings* ui = NULL;
	GSettings* _tmp3_;
	gchar* _tmp4_ = NULL;
	GAction* sort_by = NULL;
	GSettings* _tmp10_;
	GAction* _tmp11_;
	GAction* _tmp12_;
	GAction* show_offline_members = NULL;
	GSettings* _tmp13_;
	GAction* _tmp14_;
	GAction* _tmp15_;
	GSettings* _tmp16_;
	gchar** _tmp17_;
	gchar** _tmp18_;
	GSettings* _tmp19_;
	GSettings* _tmp20_;
	GSettings* _tmp21_;
	GSettings* _tmp22_;
	HaguichiIndicator* _tmp23_;
	HaguichiIndicator* _tmp24_;
	GSettings* _tmp25_;
	GtkSearchEntry* _tmp26_;
#line 63 "../src/window.vala"
	g_return_val_if_fail (app != NULL, NULL);
#line 64 "../src/window.vala"
	self = (HaguichiWindow*) g_object_new (object_type, "application", app, "title", CONFIG_APP_NAME, NULL);
#line 67 "../src/window.vala"
	_tmp0_ = haguichi_current_desktop;
#line 67 "../src/window.vala"
	if (g_strcmp0 (_tmp0_, "KDE") != 0) {
#line 68 "../src/window.vala"
		gtk_window_set_icon_name ((GtkWindow*) self, CONFIG_APP_ID);
#line 569 "window.c"
	}
#line 71 "../src/window.vala"
	_tmp1_ = g_settings_new (CONFIG_APP_ID ".config");
#line 71 "../src/window.vala"
	config = _tmp1_;
#line 72 "../src/window.vala"
	_tmp2_ = g_settings_new (CONFIG_APP_ID ".network-list");
#line 72 "../src/window.vala"
	list = _tmp2_;
#line 73 "../src/window.vala"
	_tmp3_ = g_settings_new (CONFIG_APP_ID ".ui");
#line 73 "../src/window.vala"
	ui = _tmp3_;
#line 75 "../src/window.vala"
	if (haguichi_demo_mode) {
#line 585 "window.c"
		gchar* _tmp5_;
#line 75 "../src/window.vala"
		_tmp5_ = g_strdup ("Joe Demo");
#line 75 "../src/window.vala"
		_g_free0 (_tmp4_);
#line 75 "../src/window.vala"
		_tmp4_ = _tmp5_;
#line 593 "window.c"
	} else {
		GSettings* _tmp6_;
		gchar* _tmp7_;
		gchar* _tmp8_;
		gchar* _tmp9_;
#line 75 "../src/window.vala"
		_tmp6_ = config;
#line 75 "../src/window.vala"
		_tmp7_ = g_settings_get_string (_tmp6_, "nickname");
#line 75 "../src/window.vala"
		_tmp8_ = _tmp7_;
#line 75 "../src/window.vala"
		_tmp9_ = haguichi_utils_parse_nick (_tmp8_);
#line 75 "../src/window.vala"
		_g_free0 (_tmp4_);
#line 75 "../src/window.vala"
		_tmp4_ = _tmp9_;
#line 75 "../src/window.vala"
		_g_free0 (_tmp8_);
#line 613 "window.c"
	}
#line 75 "../src/window.vala"
	haguichi_window_set_nick (self, _tmp4_);
#line 77 "../src/window.vala"
	_tmp10_ = list;
#line 77 "../src/window.vala"
	_tmp11_ = g_settings_create_action (_tmp10_, "sort-by");
#line 77 "../src/window.vala"
	sort_by = _tmp11_;
#line 78 "../src/window.vala"
	_tmp12_ = sort_by;
#line 78 "../src/window.vala"
	g_action_map_add_action ((GActionMap*) self, _tmp12_);
#line 80 "../src/window.vala"
	_tmp13_ = list;
#line 80 "../src/window.vala"
	_tmp14_ = g_settings_create_action (_tmp13_, "show-offline-members");
#line 80 "../src/window.vala"
	show_offline_members = _tmp14_;
#line 81 "../src/window.vala"
	_tmp15_ = show_offline_members;
#line 81 "../src/window.vala"
	g_action_map_add_action ((GActionMap*) self, _tmp15_);
#line 83 "../src/window.vala"
	_tmp16_ = ui;
#line 83 "../src/window.vala"
	haguichi_application_set_color_scheme (app, (gint) g_settings_get_enum (_tmp16_, "color-scheme"));
#line 85 "../src/window.vala"
	_tmp18_ = _tmp17_ = g_get_language_names ();
#line 85 "../src/window.vala"
	if (g_strv_contains (_tmp18_, "ru")) {
#line 86 "../src/window.vala"
		gtk_widget_add_css_class ((GtkWidget*) self, "custom");
#line 647 "window.c"
	}
#line 89 "../src/window.vala"
	_tmp19_ = ui;
#line 89 "../src/window.vala"
	g_object_set ((GtkWindow*) self, "default-width", g_settings_get_int (_tmp19_, "width"), NULL);
#line 90 "../src/window.vala"
	_tmp20_ = ui;
#line 90 "../src/window.vala"
	g_object_set ((GtkWindow*) self, "default-height", g_settings_get_int (_tmp20_, "height"), NULL);
#line 92 "../src/window.vala"
	_tmp21_ = ui;
#line 92 "../src/window.vala"
	g_settings_bind (_tmp21_, "width", (GObject*) self, "default-width", G_SETTINGS_BIND_DEFAULT);
#line 93 "../src/window.vala"
	_tmp22_ = ui;
#line 93 "../src/window.vala"
	g_settings_bind (_tmp22_, "height", (GObject*) self, "default-height", G_SETTINGS_BIND_DEFAULT);
#line 95 "../src/window.vala"
	_tmp23_ = haguichi_indicator_new ();
#line 95 "../src/window.vala"
	_haguichi_indicator_unref0 (haguichi_indicator);
#line 95 "../src/window.vala"
	haguichi_indicator = _tmp23_;
#line 96 "../src/window.vala"
	_tmp24_ = haguichi_indicator;
#line 96 "../src/window.vala"
	_tmp25_ = ui;
#line 96 "../src/window.vala"
	haguichi_indicator_set_active (_tmp24_, g_settings_get_boolean (_tmp25_, "show-indicator"));
#line 97 "../src/window.vala"
	haguichi_window_update_indicator_status (self);
#line 99 "../src/window.vala"
	_tmp26_ = self->search_entry;
#line 99 "../src/window.vala"
	g_signal_connect_object (_tmp26_, "search-changed", (GCallback) ___lambda130__gtk_search_entry_search_changed, self, 0);
#line 103 "../src/window.vala"
	g_signal_connect_object ((GtkWidget*) self, "hide", (GCallback) ___lambda131__gtk_widget_hide, self, 0);
#line 107 "../src/window.vala"
	g_signal_connect_object ((GtkWidget*) self, "show", (GCallback) ___lambda132__gtk_widget_show, self, 0);
#line 63 "../src/window.vala"
	_g_object_unref0 (show_offline_members);
#line 63 "../src/window.vala"
	_g_object_unref0 (sort_by);
#line 63 "../src/window.vala"
	_g_free0 (_tmp4_);
#line 63 "../src/window.vala"
	_g_object_unref0 (ui);
#line 63 "../src/window.vala"
	_g_object_unref0 (list);
#line 63 "../src/window.vala"
	_g_object_unref0 (config);
#line 63 "../src/window.vala"
	return self;
#line 701 "window.c"
}

HaguichiWindow*
haguichi_window_new (HaguichiApplication* app)
{
#line 63 "../src/window.vala"
	return haguichi_window_construct (HAGUICHI_TYPE_WINDOW, app);
#line 709 "window.c"
}

static void
haguichi_window_download_hamachi (HaguichiWindow* self)
{
#line 135 "../src/window.vala"
	g_return_if_fail (self != NULL);
#line 136 "../src/window.vala"
	haguichi_command_open_redirect_uri ("get-hamachi");
#line 719 "window.c"
}

static void
_haguichi_window_download_hamachi_gtk_button_clicked (GtkButton* _sender,
                                                      gpointer self)
{
#line 17 "../src/window.vala"
	haguichi_window_download_hamachi ((HaguichiWindow*) self);
#line 728 "window.c"
}

static void
haguichi_window_configure_hamachi (HaguichiWindow* self)
{
	AdwWindowTitle* _tmp0_;
	GtkButton* _tmp1_;
#line 140 "../src/window.vala"
	g_return_if_fail (self != NULL);
#line 141 "../src/window.vala"
	_tmp0_ = self->window_title;
#line 141 "../src/window.vala"
	adw_window_title_set_subtitle (_tmp0_, _ ("Configuring"));
#line 142 "../src/window.vala"
	_tmp1_ = self->priv->configure_button;
#line 142 "../src/window.vala"
	gtk_widget_set_sensitive ((GtkWidget*) _tmp1_, FALSE);
#line 143 "../src/window.vala"
	gtk_widget_action_set_enabled ((GtkWidget*) self, "win.refresh", FALSE);
#line 144 "../src/window.vala"
	if (!haguichi_demo_mode) {
#line 145 "../src/window.vala"
		haguichi_hamachi_configure ();
#line 752 "window.c"
	}
}

static void
_haguichi_window_configure_hamachi_gtk_button_clicked (GtkButton* _sender,
                                                       gpointer self)
{
#line 17 "../src/window.vala"
	haguichi_window_configure_hamachi ((HaguichiWindow*) self);
#line 762 "window.c"
}

static void
haguichi_window_go_back_button_clicked (HaguichiWindow* self)
{
	AdwOverlaySplitView* _tmp0_;
#line 150 "../src/window.vala"
	g_return_if_fail (self != NULL);
#line 151 "../src/window.vala"
	_tmp0_ = self->split_view;
#line 151 "../src/window.vala"
	adw_overlay_split_view_set_show_sidebar (_tmp0_, FALSE);
#line 775 "window.c"
}

static void
_haguichi_window_go_back_button_clicked_gtk_button_clicked (GtkButton* _sender,
                                                            gpointer self)
{
#line 17 "../src/window.vala"
	haguichi_window_go_back_button_clicked ((HaguichiWindow*) self);
#line 784 "window.c"
}

void
haguichi_window_connect_action (HaguichiWindow* self)
{
#line 154 "../src/window.vala"
	g_return_if_fail (self != NULL);
#line 155 "../src/window.vala"
	haguichi_controller_start_hamachi ();
#line 794 "window.c"
}

void
haguichi_window_disconnect_action (HaguichiWindow* self)
{
#line 158 "../src/window.vala"
	g_return_if_fail (self != NULL);
#line 159 "../src/window.vala"
	haguichi_controller_stop_hamachi ();
#line 804 "window.c"
}

void
haguichi_window_join_network_action (HaguichiWindow* self)
{
#line 162 "../src/window.vala"
	g_return_if_fail (self != NULL);
#line 163 "../src/window.vala"
	haguichi_window_add_network_action (self, "Join");
#line 814 "window.c"
}

void
haguichi_window_create_network_action (HaguichiWindow* self)
{
#line 166 "../src/window.vala"
	g_return_if_fail (self != NULL);
#line 167 "../src/window.vala"
	haguichi_window_add_network_action (self, "Create");
#line 824 "window.c"
}

static void
haguichi_window_add_network_action (HaguichiWindow* self,
                                    const gchar* mode)
{
	HaguichiJoinCreateNetworkDialog* add_network = NULL;
	HaguichiJoinCreateNetworkDialog* _tmp0_;
#line 170 "../src/window.vala"
	g_return_if_fail (self != NULL);
#line 170 "../src/window.vala"
	g_return_if_fail (mode != NULL);
#line 171 "../src/window.vala"
	_tmp0_ = haguichi_join_create_network_dialog_new (mode);
#line 171 "../src/window.vala"
	g_object_ref_sink (_tmp0_);
#line 171 "../src/window.vala"
	add_network = _tmp0_;
#line 172 "../src/window.vala"
	haguichi_window_show_dialog (self, (GtkWidget*) add_network);
#line 170 "../src/window.vala"
	_g_object_unref0 (add_network);
#line 847 "window.c"
}

static void
haguichi_window_attach_action (HaguichiWindow* self)
{
	HaguichiAttachDialog* attach = NULL;
	HaguichiAttachDialog* _tmp0_;
#line 175 "../src/window.vala"
	g_return_if_fail (self != NULL);
#line 176 "../src/window.vala"
	_tmp0_ = haguichi_attach_dialog_new ();
#line 176 "../src/window.vala"
	g_object_ref_sink (_tmp0_);
#line 176 "../src/window.vala"
	attach = _tmp0_;
#line 177 "../src/window.vala"
	haguichi_window_show_dialog (self, (GtkWidget*) attach);
#line 175 "../src/window.vala"
	_g_object_unref0 (attach);
#line 867 "window.c"
}

static void*
__lambda135_ (HaguichiWindow* self)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
	void* result;
#line 182 "../src/window.vala"
	_tmp0_ = haguichi_hamachi_cancel ();
#line 182 "../src/window.vala"
	_tmp1_ = _tmp0_;
#line 182 "../src/window.vala"
	_g_free0 (_tmp1_);
#line 183 "../src/window.vala"
	result = NULL;
#line 183 "../src/window.vala"
	return result;
#line 886 "window.c"
}

static gpointer
___lambda135__gthread_func (gpointer self)
{
	gpointer result;
	result = __lambda135_ ((HaguichiWindow*) self);
#line 181 "../src/window.vala"
	g_object_unref (self);
#line 181 "../src/window.vala"
	return result;
#line 898 "window.c"
}

static void
haguichi_window_attach_cancel_action (HaguichiWindow* self)
{
	GThread* _tmp0_;
	GThread* _tmp1_;
	HaguichiSidebar* _tmp2_;
#line 180 "../src/window.vala"
	g_return_if_fail (self != NULL);
#line 181 "../src/window.vala"
	_tmp0_ = g_thread_new (NULL, ___lambda135__gthread_func, g_object_ref (self));
#line 181 "../src/window.vala"
	_tmp1_ = _tmp0_;
#line 181 "../src/window.vala"
	_g_thread_unref0 (_tmp1_);
#line 186 "../src/window.vala"
	_tmp2_ = self->sidebar;
#line 186 "../src/window.vala"
	haguichi_sidebar_set_account (_tmp2_, "-");
#line 919 "window.c"
}

static void
haguichi_window_start_search_action (HaguichiWindow* self)
{
	GtkSearchBar* _tmp0_;
#line 189 "../src/window.vala"
	g_return_if_fail (self != NULL);
#line 190 "../src/window.vala"
	_tmp0_ = self->search_bar;
#line 190 "../src/window.vala"
	g_object_set (_tmp0_, "search-mode-enabled", TRUE, NULL);
#line 932 "window.c"
}

static void
haguichi_window_refresh_action (HaguichiWindow* self)
{
#line 193 "../src/window.vala"
	g_return_if_fail (self != NULL);
#line 194 "../src/window.vala"
	if (haguichi_controller_last_status <= 1) {
#line 195 "../src/window.vala"
		haguichi_controller_init ();
#line 944 "window.c"
	} else {
#line 196 "../src/window.vala"
		if (haguichi_controller_last_status >= 6) {
#line 197 "../src/window.vala"
			haguichi_controller_update_connection ();
#line 950 "window.c"
		}
	}
}

static void
haguichi_window_toggle_sidebar_action (HaguichiWindow* self)
{
	AdwOverlaySplitView* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
#line 201 "../src/window.vala"
	g_return_if_fail (self != NULL);
#line 202 "../src/window.vala"
	_tmp0_ = self->split_view;
#line 202 "../src/window.vala"
	_tmp1_ = adw_overlay_split_view_get_collapsed (_tmp0_);
#line 202 "../src/window.vala"
	_tmp2_ = _tmp1_;
#line 202 "../src/window.vala"
	if (_tmp2_ == FALSE) {
#line 202 "../src/window.vala"
		return;
#line 973 "window.c"
	}
#line 204 "../src/window.vala"
	haguichi_window_toggle_sidebar (self);
#line 977 "window.c"
}

static void
haguichi_window_cycle_mode_action (HaguichiWindow* self)
{
	gchar* cur_mode = NULL;
	gchar* _tmp0_;
	gchar* new_mode = NULL;
	gchar* _tmp1_;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	GQuark _tmp5_ = 0U;
#line 212 "../src/window.vala"
	static GQuark _tmp4_label0 = 0;
#line 212 "../src/window.vala"
	static GQuark _tmp4_label1 = 0;
#line 212 "../src/window.vala"
	static GQuark _tmp4_label2 = 0;
#line 212 "../src/window.vala"
	static GQuark _tmp4_label3 = 0;
#line 212 "../src/window.vala"
	static GQuark _tmp4_label4 = 0;
#line 212 "../src/window.vala"
	static GQuark _tmp4_label5 = 0;
#line 1002 "window.c"
	const gchar* _tmp12_;
	const gchar* _tmp13_;
#line 207 "../src/window.vala"
	g_return_if_fail (self != NULL);
#line 208 "../src/window.vala"
	if (!haguichi_demo_mode) {
#line 208 "../src/window.vala"
		return;
#line 1011 "window.c"
	}
#line 210 "../src/window.vala"
	_tmp0_ = haguichi_window_get_mode (self);
#line 210 "../src/window.vala"
	cur_mode = _tmp0_;
#line 211 "../src/window.vala"
	_tmp1_ = g_strdup ("");
#line 211 "../src/window.vala"
	new_mode = _tmp1_;
#line 212 "../src/window.vala"
	_tmp2_ = cur_mode;
#line 212 "../src/window.vala"
	_tmp3_ = _tmp2_;
#line 212 "../src/window.vala"
	_tmp5_ = (NULL == _tmp3_) ? 0 : g_quark_from_string (_tmp3_);
#line 212 "../src/window.vala"
	if (_tmp5_ == ((0 != _tmp4_label0) ? _tmp4_label0 : (_tmp4_label0 = g_quark_from_static_string ("Initializing")))) {
#line 212 "../src/window.vala"
		switch (0) {
#line 1031 "window.c"
			default:
			{
				gchar* _tmp6_;
#line 214 "../src/window.vala"
				_tmp6_ = g_strdup ("Disconnected");
#line 214 "../src/window.vala"
				_g_free0 (new_mode);
#line 214 "../src/window.vala"
				new_mode = _tmp6_;
#line 215 "../src/window.vala"
				break;
#line 1043 "window.c"
			}
		}
	} else if (_tmp5_ == ((0 != _tmp4_label1) ? _tmp4_label1 : (_tmp4_label1 = g_quark_from_static_string ("Disconnected")))) {
#line 212 "../src/window.vala"
		switch (0) {
#line 1049 "window.c"
			default:
			{
				gchar* _tmp7_;
#line 217 "../src/window.vala"
				_tmp7_ = g_strdup ("Connecting");
#line 217 "../src/window.vala"
				_g_free0 (new_mode);
#line 217 "../src/window.vala"
				new_mode = _tmp7_;
#line 218 "../src/window.vala"
				break;
#line 1061 "window.c"
			}
		}
	} else if (_tmp5_ == ((0 != _tmp4_label2) ? _tmp4_label2 : (_tmp4_label2 = g_quark_from_static_string ("Connecting")))) {
#line 212 "../src/window.vala"
		switch (0) {
#line 1067 "window.c"
			default:
			{
				gchar* _tmp8_;
#line 220 "../src/window.vala"
				_tmp8_ = g_strdup ("Connected");
#line 220 "../src/window.vala"
				_g_free0 (new_mode);
#line 220 "../src/window.vala"
				new_mode = _tmp8_;
#line 221 "../src/window.vala"
				break;
#line 1079 "window.c"
			}
		}
	} else if (_tmp5_ == ((0 != _tmp4_label3) ? _tmp4_label3 : (_tmp4_label3 = g_quark_from_static_string ("Connected")))) {
#line 212 "../src/window.vala"
		switch (0) {
#line 1085 "window.c"
			default:
			{
				gchar* _tmp9_;
#line 223 "../src/window.vala"
				_tmp9_ = g_strdup ("Not installed");
#line 223 "../src/window.vala"
				_g_free0 (new_mode);
#line 223 "../src/window.vala"
				new_mode = _tmp9_;
#line 224 "../src/window.vala"
				break;
#line 1097 "window.c"
			}
		}
	} else if (_tmp5_ == ((0 != _tmp4_label4) ? _tmp4_label4 : (_tmp4_label4 = g_quark_from_static_string ("Not installed")))) {
#line 212 "../src/window.vala"
		switch (0) {
#line 1103 "window.c"
			default:
			{
				gchar* _tmp10_;
#line 226 "../src/window.vala"
				_tmp10_ = g_strdup ("Not configured");
#line 226 "../src/window.vala"
				_g_free0 (new_mode);
#line 226 "../src/window.vala"
				new_mode = _tmp10_;
#line 227 "../src/window.vala"
				break;
#line 1115 "window.c"
			}
		}
	} else if (_tmp5_ == ((0 != _tmp4_label5) ? _tmp4_label5 : (_tmp4_label5 = g_quark_from_static_string ("Not configured")))) {
#line 212 "../src/window.vala"
		switch (0) {
#line 1121 "window.c"
			default:
			{
				gchar* _tmp11_;
#line 229 "../src/window.vala"
				_tmp11_ = g_strdup ("Initializing");
#line 229 "../src/window.vala"
				_g_free0 (new_mode);
#line 229 "../src/window.vala"
				new_mode = _tmp11_;
#line 230 "../src/window.vala"
				break;
#line 1133 "window.c"
			}
		}
	}
#line 233 "../src/window.vala"
	_tmp12_ = new_mode;
#line 233 "../src/window.vala"
	g_debug ("window.vala:233: new mode: %s", _tmp12_);
#line 234 "../src/window.vala"
	_tmp13_ = new_mode;
#line 234 "../src/window.vala"
	haguichi_window_set_mode (self, _tmp13_);
#line 207 "../src/window.vala"
	_g_free0 (new_mode);
#line 207 "../src/window.vala"
	_g_free0 (cur_mode);
#line 1149 "window.c"
}

void
haguichi_window_expand_all_networks_action (HaguichiWindow* self)
{
	HaguichiNetworkList* _tmp0_;
#line 237 "../src/window.vala"
	g_return_if_fail (self != NULL);
#line 238 "../src/window.vala"
	_tmp0_ = self->network_list;
#line 238 "../src/window.vala"
	haguichi_network_list_set_all_rows_expanded (_tmp0_, TRUE);
#line 1162 "window.c"
}

void
haguichi_window_collapse_all_networks_action (HaguichiWindow* self)
{
	HaguichiNetworkList* _tmp0_;
#line 241 "../src/window.vala"
	g_return_if_fail (self != NULL);
#line 242 "../src/window.vala"
	_tmp0_ = self->network_list;
#line 242 "../src/window.vala"
	haguichi_network_list_set_all_rows_expanded (_tmp0_, FALSE);
#line 1175 "window.c"
}

void
haguichi_window_preferences_action (HaguichiWindow* self)
{
	HaguichiPreferences* prefs = NULL;
	HaguichiPreferences* _tmp0_ = NULL;
#line 245 "../src/window.vala"
	g_return_if_fail (self != NULL);
#line 246 "../src/window.vala"
	_tmp0_ = haguichi_preferences_new ();
#line 246 "../src/window.vala"
	adw_preferences_dialog_set_search_enabled ((AdwPreferencesDialog*) _tmp0_, TRUE);
#line 246 "../src/window.vala"
	g_object_ref_sink (_tmp0_);
#line 246 "../src/window.vala"
	prefs = _tmp0_;
#line 253 "../src/window.vala"
	haguichi_window_show_dialog (self, (GtkWidget*) prefs);
#line 245 "../src/window.vala"
	_g_object_unref0 (prefs);
#line 1197 "window.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 258 "../src/window.vala"
	return self ? g_object_ref (self) : NULL;
#line 1205 "window.c"
}

static void
haguichi_window_shortcuts_action (HaguichiWindow* self)
{
	GtkBuilder* builder = NULL;
	GtkBuilder* _tmp0_;
	GtkShortcutsWindow* shortcuts = NULL;
	GObject* _tmp1_;
	GtkShortcutsWindow* _tmp2_;
#line 256 "../src/window.vala"
	g_return_if_fail (self != NULL);
#line 257 "../src/window.vala"
	_tmp0_ = gtk_builder_new_from_resource ("/com/github/ztefn/haguichi/ui/shortcuts.ui");
#line 257 "../src/window.vala"
	builder = _tmp0_;
#line 258 "../src/window.vala"
	_tmp1_ = gtk_builder_get_object (builder, "shortcuts");
#line 258 "../src/window.vala"
	_tmp2_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, gtk_shortcuts_window_get_type (), GtkShortcutsWindow));
#line 258 "../src/window.vala"
	shortcuts = _tmp2_;
#line 259 "../src/window.vala"
	haguichi_window_show_dialog (self, (GtkWidget*) shortcuts);
#line 256 "../src/window.vala"
	_g_object_unref0 (shortcuts);
#line 256 "../src/window.vala"
	_g_object_unref0 (builder);
#line 1234 "window.c"
}

static void
haguichi_window_help_action (HaguichiWindow* self)
{
#line 262 "../src/window.vala"
	g_return_if_fail (self != NULL);
#line 263 "../src/window.vala"
	haguichi_command_open_redirect_uri ("help");
#line 1244 "window.c"
}

void
haguichi_window_info_action (HaguichiWindow* self)
{
#line 266 "../src/window.vala"
	g_return_if_fail (self != NULL);
#line 267 "../src/window.vala"
	haguichi_window_show_info (self);
#line 1254 "window.c"
}

void
haguichi_window_about_action (HaguichiWindow* self)
{
	gchar* developer_name = NULL;
	gchar* _tmp0_;
	AdwAboutDialog* about = NULL;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	gchar* _tmp8_;
	AdwAboutDialog* _tmp9_ = NULL;
#line 270 "../src/window.vala"
	g_return_if_fail (self != NULL);
#line 271 "../src/window.vala"
	_tmp0_ = g_strdup ("Stephen Brandt");
#line 271 "../src/window.vala"
	developer_name = _tmp0_;
#line 273 "../src/window.vala"
	_tmp1_ = g_strdup (CONFIG_APP_NAME);
#line 273 "../src/window.vala"
	_tmp2_ = g_strdup (CONFIG_APP_ID);
#line 273 "../src/window.vala"
	_tmp3_ = g_strdup (developer_name);
#line 273 "../src/window.vala"
	_tmp4_ = g_strdup (_ ("translator-credits"));
#line 273 "../src/window.vala"
	_tmp5_ = g_strdup (CONFIG_VERSION);
#line 273 "../src/window.vala"
	_tmp6_ = g_strdup ("https://haguichi.net");
#line 273 "../src/window.vala"
	_tmp7_ = g_strdup ("https://github.com/ztefn/haguichi/issues");
#line 273 "../src/window.vala"
	_tmp8_ = g_strconcat ("© 2007-2024 ", developer_name, NULL);
#line 273 "../src/window.vala"
	_tmp9_ = (AdwAboutDialog*) adw_about_dialog_new ();
#line 273 "../src/window.vala"
	adw_about_dialog_set_application_name (_tmp9_, _tmp1_);
#line 273 "../src/window.vala"
	_g_free0 (_tmp1_);
#line 273 "../src/window.vala"
	adw_about_dialog_set_application_icon (_tmp9_, _tmp2_);
#line 273 "../src/window.vala"
	_g_free0 (_tmp2_);
#line 273 "../src/window.vala"
	adw_about_dialog_set_developer_name (_tmp9_, _tmp3_);
#line 273 "../src/window.vala"
	_g_free0 (_tmp3_);
#line 273 "../src/window.vala"
	adw_about_dialog_set_translator_credits (_tmp9_, _tmp4_);
#line 273 "../src/window.vala"
	_g_free0 (_tmp4_);
#line 273 "../src/window.vala"
	adw_about_dialog_set_version (_tmp9_, _tmp5_);
#line 273 "../src/window.vala"
	_g_free0 (_tmp5_);
#line 273 "../src/window.vala"
	adw_about_dialog_set_website (_tmp9_, _tmp6_);
#line 273 "../src/window.vala"
	_g_free0 (_tmp6_);
#line 273 "../src/window.vala"
	adw_about_dialog_set_issue_url (_tmp9_, _tmp7_);
#line 273 "../src/window.vala"
	_g_free0 (_tmp7_);
#line 273 "../src/window.vala"
	adw_about_dialog_set_copyright (_tmp9_, _tmp8_);
#line 273 "../src/window.vala"
	_g_free0 (_tmp8_);
#line 273 "../src/window.vala"
	adw_about_dialog_set_license_type (_tmp9_, GTK_LICENSE_GPL_3_0);
#line 273 "../src/window.vala"
	g_object_ref_sink (_tmp9_);
#line 273 "../src/window.vala"
	about = _tmp9_;
#line 289 "../src/window.vala"
	g_object_set ((GtkWidget*) about, "width-request", 320, NULL);
#line 291 "../src/window.vala"
	haguichi_window_show_dialog (self, (GtkWidget*) about);
#line 270 "../src/window.vala"
	_g_object_unref0 (about);
#line 270 "../src/window.vala"
	_g_free0 (developer_name);
#line 1342 "window.c"
}

void
haguichi_window_quit_action (HaguichiWindow* self)
{
	GtkWidget* _tmp0_;
	HaguichiConnection* _tmp2_;
	HaguichiSession* _tmp3_;
	HaguichiApplication* _tmp4_;
#line 294 "../src/window.vala"
	g_return_if_fail (self != NULL);
#line 295 "../src/window.vala"
	haguichi_controller_quit ();
#line 297 "../src/window.vala"
	_tmp0_ = self->modal_dialog;
#line 297 "../src/window.vala"
	if (_tmp0_ != NULL) {
#line 1360 "window.c"
		GtkWidget* _tmp1_;
#line 298 "../src/window.vala"
		_tmp1_ = self->modal_dialog;
#line 298 "../src/window.vala"
		g_signal_emit_by_name (_tmp1_, "destroy");
#line 1366 "window.c"
	}
#line 301 "../src/window.vala"
	gtk_widget_hide ((GtkWidget*) self);
#line 303 "../src/window.vala"
	_tmp2_ = haguichi_connection;
#line 303 "../src/window.vala"
	haguichi_connection_save_long_nicks (_tmp2_);
#line 304 "../src/window.vala"
	_tmp3_ = haguichi_session;
#line 304 "../src/window.vala"
	g_signal_emit_by_name (_tmp3_, "quitted");
#line 306 "../src/window.vala"
	g_debug ("window.vala:306: quit_action: Bye!");
#line 307 "../src/window.vala"
	_tmp4_ = haguichi_app;
#line 307 "../src/window.vala"
	g_application_quit ((GApplication*) _tmp4_);
#line 1384 "window.c"
}

static gboolean
___lambda52_ (HaguichiWindow* self)
{
	gboolean result;
#line 316 "../src/window.vala"
	haguichi_window_set_modal_dialog (self, NULL);
#line 317 "../src/window.vala"
	result = FALSE;
#line 317 "../src/window.vala"
	return result;
#line 1397 "window.c"
}

static gboolean
____lambda52__gtk_window_close_request (GtkWindow* _sender,
                                        gpointer self)
{
	gboolean result;
	result = ___lambda52_ ((HaguichiWindow*) self);
#line 315 "../src/window.vala"
	return result;
#line 1408 "window.c"
}

static void
____lambda65_ (HaguichiWindow* self)
{
#line 327 "../src/window.vala"
	haguichi_window_set_modal_dialog (self, NULL);
#line 1416 "window.c"
}

static void
_____lambda65__adw_dialog_closed (AdwDialog* _sender,
                                  gpointer self)
{
#line 326 "../src/window.vala"
	____lambda65_ ((HaguichiWindow*) self);
#line 1425 "window.c"
}

void
haguichi_window_show_dialog (HaguichiWindow* self,
                             GtkWidget* widget)
{
#line 310 "../src/window.vala"
	g_return_if_fail (self != NULL);
#line 310 "../src/window.vala"
	g_return_if_fail (widget != NULL);
#line 311 "../src/window.vala"
	if (G_TYPE_CHECK_INSTANCE_TYPE (widget, gtk_window_get_type ())) {
#line 1438 "window.c"
		GtkWindow* dialog = NULL;
		GtkWindow* _tmp0_;
		GtkWindow* _tmp1_;
		GtkWindow* _tmp2_;
		GtkWindow* _tmp3_;
		GtkWindow* _tmp4_;
		GtkWindow* _tmp5_;
#line 312 "../src/window.vala"
		_tmp0_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (widget, gtk_window_get_type (), GtkWindow));
#line 312 "../src/window.vala"
		dialog = _tmp0_;
#line 313 "../src/window.vala"
		_tmp1_ = dialog;
#line 313 "../src/window.vala"
		gtk_window_set_transient_for (_tmp1_, (GtkWindow*) self);
#line 314 "../src/window.vala"
		_tmp2_ = dialog;
#line 314 "../src/window.vala"
		gtk_window_set_modal (_tmp2_, TRUE);
#line 315 "../src/window.vala"
		_tmp3_ = dialog;
#line 315 "../src/window.vala"
		g_signal_connect_object (_tmp3_, "close-request", (GCallback) ____lambda52__gtk_window_close_request, self, 0);
#line 319 "../src/window.vala"
		_tmp4_ = dialog;
#line 319 "../src/window.vala"
		gtk_window_present (_tmp4_);
#line 321 "../src/window.vala"
		_tmp5_ = dialog;
#line 321 "../src/window.vala"
		haguichi_window_set_modal_dialog (self, (GtkWidget*) _tmp5_);
#line 311 "../src/window.vala"
		_g_object_unref0 (dialog);
#line 1472 "window.c"
	} else {
#line 324 "../src/window.vala"
		if (G_TYPE_CHECK_INSTANCE_TYPE (widget, adw_dialog_get_type ())) {
#line 1476 "window.c"
			AdwDialog* dialog = NULL;
			AdwDialog* _tmp6_;
			AdwDialog* _tmp7_;
			AdwDialog* _tmp8_;
			AdwDialog* _tmp9_;
#line 325 "../src/window.vala"
			_tmp6_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (widget, adw_dialog_get_type (), AdwDialog));
#line 325 "../src/window.vala"
			dialog = _tmp6_;
#line 326 "../src/window.vala"
			_tmp7_ = dialog;
#line 326 "../src/window.vala"
			g_signal_connect_object (_tmp7_, "closed", (GCallback) _____lambda65__adw_dialog_closed, self, 0);
#line 329 "../src/window.vala"
			_tmp8_ = dialog;
#line 329 "../src/window.vala"
			adw_dialog_present (_tmp8_, (GtkWidget*) self);
#line 331 "../src/window.vala"
			_tmp9_ = dialog;
#line 331 "../src/window.vala"
			haguichi_window_set_modal_dialog (self, (GtkWidget*) _tmp9_);
#line 324 "../src/window.vala"
			_g_object_unref0 (dialog);
#line 1500 "window.c"
		}
	}
}

static void
haguichi_window_set_modal_dialog (HaguichiWindow* self,
                                  GtkWidget* dialog)
{
	GtkWidget* _tmp0_;
	gboolean _tmp1_ = FALSE;
	HaguichiSession* _tmp2_;
#line 336 "../src/window.vala"
	g_return_if_fail (self != NULL);
#line 337 "../src/window.vala"
	_tmp0_ = _g_object_ref0 (dialog);
#line 337 "../src/window.vala"
	_g_object_unref0 (self->modal_dialog);
#line 337 "../src/window.vala"
	self->modal_dialog = _tmp0_;
#line 338 "../src/window.vala"
	if (dialog == NULL) {
#line 338 "../src/window.vala"
		_tmp1_ = FALSE;
#line 1524 "window.c"
	} else {
#line 338 "../src/window.vala"
		_tmp1_ = TRUE;
#line 1528 "window.c"
	}
#line 338 "../src/window.vala"
	_tmp2_ = haguichi_session;
#line 338 "../src/window.vala"
	g_signal_emit_by_name (_tmp2_, "modality-changed", _tmp1_);
#line 339 "../src/window.vala"
	haguichi_window_update_indicator_status (self);
#line 1536 "window.c"
}

void
haguichi_window_show_toast (HaguichiWindow* self,
                            const gchar* title,
                            guint timeout)
{
	AdwToastOverlay* _tmp0_;
	AdwToast* _tmp1_ = NULL;
#line 342 "../src/window.vala"
	g_return_if_fail (self != NULL);
#line 342 "../src/window.vala"
	g_return_if_fail (title != NULL);
#line 343 "../src/window.vala"
	_tmp0_ = self->priv->toast_overlay;
#line 343 "../src/window.vala"
	_tmp1_ = adw_toast_new (title);
#line 343 "../src/window.vala"
	adw_toast_set_timeout (_tmp1_, timeout);
#line 343 "../src/window.vala"
	adw_toast_overlay_add_toast (_tmp0_, _tmp1_);
#line 1558 "window.c"
}

void
haguichi_window_show_copied_to_clipboard_toast (HaguichiWindow* self)
{
#line 348 "../src/window.vala"
	g_return_if_fail (self != NULL);
#line 349 "../src/window.vala"
	haguichi_window_show_toast (self, _ ("Copied to clipboard"), (guint) 2);
#line 1568 "window.c"
}

void
haguichi_window_show_info (HaguichiWindow* self)
{
	HaguichiNetworkList* _tmp0_;
	AdwOverlaySplitView* _tmp1_;
#line 352 "../src/window.vala"
	g_return_if_fail (self != NULL);
#line 353 "../src/window.vala"
	_tmp0_ = self->network_list;
#line 353 "../src/window.vala"
	haguichi_network_list_unselect (_tmp0_);
#line 354 "../src/window.vala"
	_tmp1_ = self->split_view;
#line 354 "../src/window.vala"
	adw_overlay_split_view_set_show_sidebar (_tmp1_, TRUE);
#line 1586 "window.c"
}

void
haguichi_window_toggle_sidebar (HaguichiWindow* self)
{
	AdwOverlaySplitView* _tmp0_;
	AdwOverlaySplitView* _tmp1_;
	gboolean _tmp2_;
	gboolean _tmp3_;
#line 357 "../src/window.vala"
	g_return_if_fail (self != NULL);
#line 358 "../src/window.vala"
	_tmp0_ = self->split_view;
#line 358 "../src/window.vala"
	_tmp1_ = self->split_view;
#line 358 "../src/window.vala"
	_tmp2_ = adw_overlay_split_view_get_show_sidebar (_tmp1_);
#line 358 "../src/window.vala"
	_tmp3_ = _tmp2_;
#line 358 "../src/window.vala"
	adw_overlay_split_view_set_show_sidebar (_tmp0_, !_tmp3_);
#line 1608 "window.c"
}

void
haguichi_window_show_sidebar (HaguichiWindow* self)
{
	AdwOverlaySplitView* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	AdwOverlaySplitView* _tmp3_;
#line 361 "../src/window.vala"
	g_return_if_fail (self != NULL);
#line 362 "../src/window.vala"
	_tmp0_ = self->split_view;
#line 362 "../src/window.vala"
	g_object_get ((GtkWindow*) self, "default-width", &_tmp1_, NULL);
#line 362 "../src/window.vala"
	_tmp2_ = _tmp1_;
#line 362 "../src/window.vala"
	adw_overlay_split_view_set_show_sidebar (_tmp0_, _tmp2_ > 520);
#line 363 "../src/window.vala"
	_tmp3_ = self->split_view;
#line 363 "../src/window.vala"
	adw_overlay_split_view_set_pin_sidebar (_tmp3_, FALSE);
#line 1632 "window.c"
}

void
haguichi_window_hide_sidebar (HaguichiWindow* self)
{
	AdwOverlaySplitView* _tmp0_;
	AdwOverlaySplitView* _tmp1_;
#line 366 "../src/window.vala"
	g_return_if_fail (self != NULL);
#line 367 "../src/window.vala"
	_tmp0_ = self->split_view;
#line 367 "../src/window.vala"
	adw_overlay_split_view_set_show_sidebar (_tmp0_, FALSE);
#line 368 "../src/window.vala"
	_tmp1_ = self->split_view;
#line 368 "../src/window.vala"
	adw_overlay_split_view_set_pin_sidebar (_tmp1_, TRUE);
#line 1650 "window.c"
}

void
haguichi_window_set_nick (HaguichiWindow* self,
                          const gchar* nick)
{
	const gchar* _tmp0_ = NULL;
	AdwWindowTitle* _tmp1_;
#line 371 "../src/window.vala"
	g_return_if_fail (self != NULL);
#line 371 "../src/window.vala"
	g_return_if_fail (nick != NULL);
#line 372 "../src/window.vala"
	if (g_strcmp0 (nick, "") == 0) {
#line 372 "../src/window.vala"
		_tmp0_ = _ ("Anonymous");
#line 1667 "window.c"
	} else {
#line 372 "../src/window.vala"
		_tmp0_ = nick;
#line 1671 "window.c"
	}
#line 372 "../src/window.vala"
	_tmp1_ = self->window_title;
#line 372 "../src/window.vala"
	adw_window_title_set_title (_tmp1_, _tmp0_);
#line 1677 "window.c"
}

void
haguichi_window_set_connected_stack_page (HaguichiWindow* self,
                                          const gchar* page)
{
	GtkStack* _tmp0_;
#line 375 "../src/window.vala"
	g_return_if_fail (self != NULL);
#line 375 "../src/window.vala"
	g_return_if_fail (page != NULL);
#line 376 "../src/window.vala"
	_tmp0_ = self->connected_stack;
#line 376 "../src/window.vala"
	gtk_stack_set_visible_child_name (_tmp0_, page);
#line 1693 "window.c"
}

gchar*
haguichi_window_get_mode (HaguichiWindow* self)
{
	GtkStack* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* result;
#line 379 "../src/window.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 380 "../src/window.vala"
	_tmp0_ = self->stack;
#line 380 "../src/window.vala"
	_tmp1_ = gtk_stack_get_visible_child_name (_tmp0_);
#line 380 "../src/window.vala"
	_tmp2_ = _tmp1_;
#line 380 "../src/window.vala"
	_tmp3_ = g_strdup (_tmp2_);
#line 380 "../src/window.vala"
	result = _tmp3_;
#line 380 "../src/window.vala"
	return result;
#line 1718 "window.c"
}

static gboolean
string_contains (const gchar* self,
                 const gchar* needle)
{
	gchar* _tmp0_;
	gboolean result;
#line 1584 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1584 "glib-2.0.vapi"
	g_return_val_if_fail (needle != NULL, FALSE);
#line 1585 "glib-2.0.vapi"
	_tmp0_ = strstr ((gchar*) self, (gchar*) needle);
#line 1585 "glib-2.0.vapi"
	result = _tmp0_ != NULL;
#line 1585 "glib-2.0.vapi"
	return result;
#line 1737 "window.c"
}

void
haguichi_window_set_mode (HaguichiWindow* self,
                          const gchar* mode)
{
	HaguichiSession* _tmp0_;
	GtkStack* _tmp1_;
	gboolean is_configured = FALSE;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gboolean _tmp4_;
	gboolean _tmp5_ = FALSE;
	GtkButton* _tmp6_;
	GtkToggleButton* _tmp14_;
	gboolean _tmp15_ = FALSE;
	GtkToggleButton* _tmp16_;
	GtkToggleButton* _tmp17_;
	GtkToggleButton* _tmp18_;
	GtkSearchBar* _tmp19_;
	HaguichiThrobber* _tmp25_;
	GtkButton* _tmp26_;
	GtkButton* _tmp27_;
	GtkMenuButton* _tmp28_;
#line 383 "../src/window.vala"
	g_return_if_fail (self != NULL);
#line 383 "../src/window.vala"
	g_return_if_fail (mode != NULL);
#line 384 "../src/window.vala"
	_tmp0_ = haguichi_session;
#line 384 "../src/window.vala"
	g_signal_emit_by_name (_tmp0_, "mode-changed", mode);
#line 386 "../src/window.vala"
	_tmp1_ = self->stack;
#line 386 "../src/window.vala"
	gtk_stack_set_visible_child_name (_tmp1_, mode);
#line 388 "../src/window.vala"
	_tmp2_ = g_utf8_strdown (mode, (gssize) -1);
#line 388 "../src/window.vala"
	_tmp3_ = _tmp2_;
#line 388 "../src/window.vala"
	_tmp4_ = string_contains (_tmp3_, "connect");
#line 388 "../src/window.vala"
	_g_free0 (_tmp3_);
#line 388 "../src/window.vala"
	is_configured = _tmp4_;
#line 390 "../src/window.vala"
	gtk_widget_action_set_enabled ((GtkWidget*) self, "win.connect", g_strcmp0 (mode, "Disconnected") == 0);
#line 391 "../src/window.vala"
	gtk_widget_action_set_enabled ((GtkWidget*) self, "win.disconnect", g_strcmp0 (mode, "Connected") == 0);
#line 392 "../src/window.vala"
	gtk_widget_action_set_enabled ((GtkWidget*) self, "win.join-network", g_strcmp0 (mode, "Connected") == 0);
#line 393 "../src/window.vala"
	gtk_widget_action_set_enabled ((GtkWidget*) self, "win.create-network", g_strcmp0 (mode, "Connected") == 0);
#line 394 "../src/window.vala"
	gtk_widget_action_set_enabled ((GtkWidget*) self, "win.start-search", g_strcmp0 (mode, "Connected") == 0);
#line 395 "../src/window.vala"
	gtk_widget_action_set_enabled ((GtkWidget*) self, "win.refresh", TRUE);
#line 396 "../src/window.vala"
	gtk_widget_action_set_enabled ((GtkWidget*) self, "win.toggle-sidebar", is_configured);
#line 397 "../src/window.vala"
	gtk_widget_action_set_enabled ((GtkWidget*) self, "win.info", is_configured);
#line 398 "../src/window.vala"
	gtk_widget_action_set_enabled ((GtkWidget*) self, "win.sort-by", is_configured);
#line 399 "../src/window.vala"
	gtk_widget_action_set_enabled ((GtkWidget*) self, "win.show-offline-members", is_configured);
#line 401 "../src/window.vala"
	if (g_strcmp0 (mode, "Not installed") == 0) {
#line 401 "../src/window.vala"
		_tmp5_ = TRUE;
#line 1808 "window.c"
	} else {
#line 401 "../src/window.vala"
		_tmp5_ = g_strcmp0 (mode, "Not configured") == 0;
#line 1812 "window.c"
	}
#line 401 "../src/window.vala"
	_tmp6_ = self->priv->refresh_button;
#line 401 "../src/window.vala"
	gtk_widget_set_visible ((GtkWidget*) _tmp6_, _tmp5_);
#line 403 "../src/window.vala"
	if (g_strcmp0 (mode, "Not installed") == 0) {
#line 1820 "window.c"
		gboolean _tmp7_ = FALSE;
#line 404 "../src/window.vala"
		if (haguichi_demo_mode) {
#line 404 "../src/window.vala"
			_tmp7_ = TRUE;
#line 1826 "window.c"
		} else {
			const gchar* _tmp8_;
#line 404 "../src/window.vala"
			_tmp8_ = haguichi_hamachi_version;
#line 404 "../src/window.vala"
			_tmp7_ = g_strcmp0 (_tmp8_, "") == 0;
#line 1833 "window.c"
		}
#line 404 "../src/window.vala"
		if (_tmp7_) {
#line 1837 "window.c"
			AdwStatusPage* _tmp9_;
#line 405 "../src/window.vala"
			_tmp9_ = self->not_installed_status_page;
#line 405 "../src/window.vala"
			adw_status_page_set_title (_tmp9_, _ ("Hamachi Is Not Installed"));
#line 1843 "window.c"
		} else {
			AdwStatusPage* _tmp10_;
			const gchar* _tmp11_;
			gchar* _tmp12_;
			gchar* _tmp13_;
#line 407 "../src/window.vala"
			_tmp10_ = self->not_installed_status_page;
#line 407 "../src/window.vala"
			_tmp11_ = haguichi_hamachi_version;
#line 407 "../src/window.vala"
			_tmp12_ = g_strdup_printf (_ ("Hamachi Version %s Is Obsolete"), _tmp11_);
#line 407 "../src/window.vala"
			_tmp13_ = _tmp12_;
#line 407 "../src/window.vala"
			adw_status_page_set_title (_tmp10_, _tmp13_);
#line 407 "../src/window.vala"
			_g_free0 (_tmp13_);
#line 1861 "window.c"
		}
	}
#line 411 "../src/window.vala"
	_tmp14_ = self->connect_button;
#line 411 "../src/window.vala"
	gtk_widget_set_visible ((GtkWidget*) _tmp14_, g_strcmp0 (mode, "Disconnected") == 0);
#line 412 "../src/window.vala"
	if (g_strcmp0 (mode, "Connecting") == 0) {
#line 412 "../src/window.vala"
		_tmp15_ = TRUE;
#line 1872 "window.c"
	} else {
#line 412 "../src/window.vala"
		_tmp15_ = g_strcmp0 (mode, "Connected") == 0;
#line 1876 "window.c"
	}
#line 412 "../src/window.vala"
	_tmp16_ = self->disconnect_button;
#line 412 "../src/window.vala"
	gtk_widget_set_visible ((GtkWidget*) _tmp16_, _tmp15_);
#line 414 "../src/window.vala"
	_tmp17_ = self->search_button;
#line 414 "../src/window.vala"
	gtk_widget_set_visible ((GtkWidget*) _tmp17_, is_configured);
#line 415 "../src/window.vala"
	_tmp18_ = self->search_button;
#line 415 "../src/window.vala"
	gtk_widget_set_sensitive ((GtkWidget*) _tmp18_, g_strcmp0 (mode, "Connected") == 0);
#line 416 "../src/window.vala"
	_tmp19_ = self->search_bar;
#line 416 "../src/window.vala"
	gtk_widget_set_sensitive ((GtkWidget*) _tmp19_, g_strcmp0 (mode, "Connected") == 0);
#line 417 "../src/window.vala"
	if (g_strcmp0 (mode, "Connected") != 0) {
#line 1896 "window.c"
		GtkSearchBar* _tmp20_;
#line 418 "../src/window.vala"
		_tmp20_ = self->search_bar;
#line 418 "../src/window.vala"
		g_object_set (_tmp20_, "search-mode-enabled", FALSE, NULL);
#line 1902 "window.c"
	}
#line 421 "../src/window.vala"
	if (is_configured) {
#line 1906 "window.c"
		HaguichiSidebar* _tmp21_;
		GtkButton* _tmp22_;
		HaguichiSidebar* _tmp23_;
		GtkButton* _tmp24_;
#line 422 "../src/window.vala"
		_tmp21_ = self->sidebar;
#line 422 "../src/window.vala"
		_tmp22_ = _tmp21_->attach_button;
#line 422 "../src/window.vala"
		gtk_widget_set_sensitive ((GtkWidget*) _tmp22_, g_strcmp0 (mode, "Connected") == 0);
#line 423 "../src/window.vala"
		_tmp23_ = self->sidebar;
#line 423 "../src/window.vala"
		_tmp24_ = _tmp23_->cancel_button;
#line 423 "../src/window.vala"
		gtk_widget_set_sensitive ((GtkWidget*) _tmp24_, g_strcmp0 (mode, "Connected") == 0);
#line 424 "../src/window.vala"
		haguichi_window_show_sidebar (self);
#line 1925 "window.c"
	} else {
#line 426 "../src/window.vala"
		haguichi_window_hide_sidebar (self);
#line 1929 "window.c"
	}
#line 429 "../src/window.vala"
	_tmp25_ = self->throbber;
#line 429 "../src/window.vala"
	haguichi_throbber_set_spinning (_tmp25_, g_strcmp0 (mode, "Connecting") == 0);
#line 431 "../src/window.vala"
	_tmp26_ = self->priv->configure_button;
#line 431 "../src/window.vala"
	gtk_widget_set_sensitive ((GtkWidget*) _tmp26_, g_strcmp0 (mode, "Not configured") == 0);
#line 433 "../src/window.vala"
	_tmp27_ = self->priv->overlay_refresh_button;
#line 433 "../src/window.vala"
	gtk_widget_set_visible ((GtkWidget*) _tmp27_, g_strcmp0 (mode, "Connected") == 0);
#line 434 "../src/window.vala"
	_tmp28_ = self->priv->overlay_add_network_button;
#line 434 "../src/window.vala"
	gtk_widget_set_visible ((GtkWidget*) _tmp28_, g_strcmp0 (mode, "Connected") == 0);
#line 436 "../src/window.vala"
	if (g_strcmp0 (mode, "Initializing") == 0) {
#line 1949 "window.c"
		AdwWindowTitle* _tmp29_;
#line 437 "../src/window.vala"
		_tmp29_ = self->window_title;
#line 437 "../src/window.vala"
		adw_window_title_set_subtitle (_tmp29_, _ ("Initializing"));
#line 1955 "window.c"
	} else {
#line 438 "../src/window.vala"
		if (g_strcmp0 (mode, "Connecting") == 0) {
#line 1959 "window.c"
			AdwWindowTitle* _tmp30_;
#line 439 "../src/window.vala"
			_tmp30_ = self->window_title;
#line 439 "../src/window.vala"
			adw_window_title_set_subtitle (_tmp30_, _ ("Connecting"));
#line 1965 "window.c"
		} else {
#line 440 "../src/window.vala"
			if (g_strcmp0 (mode, "Connected") == 0) {
#line 1969 "window.c"
				AdwWindowTitle* _tmp31_;
#line 441 "../src/window.vala"
				_tmp31_ = self->window_title;
#line 441 "../src/window.vala"
				adw_window_title_set_subtitle (_tmp31_, _ ("Connected"));
#line 1975 "window.c"
			} else {
				AdwWindowTitle* _tmp32_;
				HaguichiSidebar* _tmp33_;
#line 443 "../src/window.vala"
				_tmp32_ = self->window_title;
#line 443 "../src/window.vala"
				adw_window_title_set_subtitle (_tmp32_, _ ("Disconnected"));
#line 444 "../src/window.vala"
				_tmp33_ = self->sidebar;
#line 444 "../src/window.vala"
				haguichi_sidebar_show_page (_tmp33_, "Information");
#line 1987 "window.c"
			}
		}
	}
#line 448 "../src/window.vala"
	if (xdp_portal_running_under_flatpak ()) {
#line 449 "../src/window.vala"
		haguichi_window_set_background_status (self, NULL, NULL);
#line 1995 "window.c"
	}
#line 452 "../src/window.vala"
	haguichi_window_update_indicator_status (self);
#line 1999 "window.c"
}

static void
haguichi_window_set_background_status_data_free (gpointer _data)
{
	HaguichiWindowSetBackgroundStatusData* _data_;
	_data_ = _data;
#line 17 "../src/window.vala"
	_g_object_unref0 (_data_->self);
#line 17 "../src/window.vala"
	g_slice_free (HaguichiWindowSetBackgroundStatusData, _data_);
#line 2011 "window.c"
}

void
haguichi_window_set_background_status (HaguichiWindow* self,
                                       GAsyncReadyCallback _callback_,
                                       gpointer _user_data_)
{
	HaguichiWindowSetBackgroundStatusData* _data_;
	HaguichiWindow* _tmp0_;
#line 17 "../src/window.vala"
	g_return_if_fail (self != NULL);
#line 17 "../src/window.vala"
	_data_ = g_slice_new0 (HaguichiWindowSetBackgroundStatusData);
#line 17 "../src/window.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
#line 17 "../src/window.vala"
	g_task_set_task_data (_data_->_async_result, _data_, haguichi_window_set_background_status_data_free);
#line 17 "../src/window.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 17 "../src/window.vala"
	_data_->self = _tmp0_;
#line 17 "../src/window.vala"
	haguichi_window_set_background_status_co (_data_);
#line 2035 "window.c"
}

void
haguichi_window_set_background_status_finish (HaguichiWindow* self,
                                              GAsyncResult* _res_)
{
	HaguichiWindowSetBackgroundStatusData* _data_;
#line 17 "../src/window.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
#line 2045 "window.c"
}

static void
haguichi_window_set_background_status_ready (GObject* source_object,
                                             GAsyncResult* _res_,
                                             gpointer _user_data_)
{
	HaguichiWindowSetBackgroundStatusData* _data_;
#line 457 "../src/window.vala"
	_data_ = _user_data_;
#line 457 "../src/window.vala"
	_data_->_source_object_ = source_object;
#line 457 "../src/window.vala"
	_data_->_res_ = _res_;
#line 457 "../src/window.vala"
	haguichi_window_set_background_status_co (_data_);
#line 2062 "window.c"
}

static gboolean
haguichi_window_set_background_status_co (HaguichiWindowSetBackgroundStatusData* _data_)
{
#line 455 "../src/window.vala"
	switch (_data_->_state_) {
#line 455 "../src/window.vala"
		case 0:
#line 2072 "window.c"
		goto _state_0;
#line 455 "../src/window.vala"
		case 1:
#line 2076 "window.c"
		goto _state_1;
		default:
#line 455 "../src/window.vala"
		g_assert_not_reached ();
#line 2081 "window.c"
	}
	_state_0:
	{
#line 457 "../src/window.vala"
		_data_->_tmp0_ = _data_->self->priv->portal;
#line 457 "../src/window.vala"
		_data_->_tmp1_ = _data_->self->window_title;
#line 457 "../src/window.vala"
		_data_->_tmp2_ = adw_window_title_get_subtitle (_data_->_tmp1_);
#line 457 "../src/window.vala"
		_data_->_tmp3_ = _data_->_tmp2_;
#line 457 "../src/window.vala"
		_data_->_state_ = 1;
#line 457 "../src/window.vala"
		xdp_portal_set_background_status (_data_->_tmp0_, _data_->_tmp3_, NULL, haguichi_window_set_background_status_ready, _data_);
#line 457 "../src/window.vala"
		return FALSE;
#line 2099 "window.c"
		_state_1:
#line 457 "../src/window.vala"
		_data_->success = xdp_portal_set_background_status_finish (_data_->_tmp0_, _data_->_res_, &_data_->_inner_error0_);
#line 457 "../src/window.vala"
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 2105 "window.c"
			goto __catch0_g_error;
		}
#line 458 "../src/window.vala"
		if (!_data_->success) {
#line 459 "../src/window.vala"
			g_warning ("window.vala:459: set_background_status: Updating background status fai" \
"led");
#line 2112 "window.c"
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
#line 456 "../src/window.vala"
		_data_->e = _data_->_inner_error0_;
#line 456 "../src/window.vala"
		_data_->_inner_error0_ = NULL;
#line 462 "../src/window.vala"
		_data_->_tmp4_ = _data_->e;
#line 462 "../src/window.vala"
		_data_->_tmp5_ = _data_->_tmp4_->message;
#line 462 "../src/window.vala"
		g_critical ("window.vala:462: set_background_status: %s", _data_->_tmp5_);
#line 456 "../src/window.vala"
		_g_error_free0 (_data_->e);
#line 2130 "window.c"
	}
	__finally0:
#line 456 "../src/window.vala"
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 456 "../src/window.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error0_->message, g_quark_to_string (_data_->_inner_error0_->domain), _data_->_inner_error0_->code);
#line 456 "../src/window.vala"
		g_clear_error (&_data_->_inner_error0_);
#line 456 "../src/window.vala"
		g_object_unref (_data_->_async_result);
#line 456 "../src/window.vala"
		return FALSE;
#line 2143 "window.c"
	}
#line 455 "../src/window.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 455 "../src/window.vala"
	if (_data_->_state_ != 0) {
#line 455 "../src/window.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 455 "../src/window.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 2153 "window.c"
		}
	}
#line 455 "../src/window.vala"
	g_object_unref (_data_->_async_result);
#line 455 "../src/window.vala"
	return FALSE;
#line 2160 "window.c"
}

void
haguichi_window_update_indicator_status (HaguichiWindow* self)
{
	HaguichiIndicator* _tmp0_;
#line 466 "../src/window.vala"
	g_return_if_fail (self != NULL);
#line 467 "../src/window.vala"
	_tmp0_ = haguichi_indicator;
#line 467 "../src/window.vala"
	if (_tmp0_ != NULL) {
#line 2173 "window.c"
		HaguichiIndicator* _tmp1_;
		gchar* _tmp2_;
		gchar* _tmp3_;
		GtkWidget* _tmp4_;
		gboolean _tmp5_;
		gboolean _tmp6_;
#line 468 "../src/window.vala"
		_tmp1_ = haguichi_indicator;
#line 468 "../src/window.vala"
		_tmp2_ = haguichi_window_get_mode (self);
#line 468 "../src/window.vala"
		_tmp3_ = _tmp2_;
#line 468 "../src/window.vala"
		_tmp4_ = self->modal_dialog;
#line 468 "../src/window.vala"
		_tmp5_ = gtk_widget_get_visible ((GtkWidget*) self);
#line 468 "../src/window.vala"
		_tmp6_ = _tmp5_;
#line 468 "../src/window.vala"
		haguichi_indicator_update_status (_tmp1_, _tmp3_, _tmp4_ != NULL, _tmp6_);
#line 468 "../src/window.vala"
		_g_free0 (_tmp3_);
#line 2196 "window.c"
	}
}

static void
haguichi_window_real_hide (GtkWidget* base)
{
	HaguichiWindow * self;
	GtkWidget* _tmp0_;
#line 472 "../src/window.vala"
	self = (HaguichiWindow*) base;
#line 473 "../src/window.vala"
	_tmp0_ = self->modal_dialog;
#line 473 "../src/window.vala"
	if (_tmp0_ == NULL) {
#line 474 "../src/window.vala"
		GTK_WIDGET_CLASS (haguichi_window_parent_class)->hide ((GtkWidget*) G_TYPE_CHECK_INSTANCE_CAST (self, adw_application_window_get_type (), AdwApplicationWindow));
#line 2213 "window.c"
	}
}

static void
___lambda136_ (HaguichiWindow* self,
               GObject* obj,
               GAsyncResult* res)
{
#line 482 "../src/window.vala"
	g_return_if_fail (res != NULL);
#line 483 "../src/window.vala"
	if (haguichi_window_request_background_finish (self, res)) {
#line 484 "../src/window.vala"
		gtk_widget_hide ((GtkWidget*) self);
#line 2228 "window.c"
	} else {
#line 486 "../src/window.vala"
		gtk_window_destroy ((GtkWindow*) self);
#line 2232 "window.c"
	}
}

static void
____lambda136__gasync_ready_callback (GObject* source_object,
                                      GAsyncResult* res,
                                      gpointer self)
{
#line 482 "../src/window.vala"
	___lambda136_ ((HaguichiWindow*) self, source_object, res);
#line 482 "../src/window.vala"
	g_object_unref (self);
#line 2245 "window.c"
}

static gboolean
haguichi_window_real_close_request (GtkWindow* base)
{
	HaguichiWindow * self;
	gchar* mode = NULL;
	gchar* _tmp0_;
	gboolean _tmp1_ = FALSE;
	const gchar* _tmp2_;
	gboolean result;
#line 478 "../src/window.vala"
	self = (HaguichiWindow*) base;
#line 480 "../src/window.vala"
	_tmp0_ = haguichi_window_get_mode (self);
#line 480 "../src/window.vala"
	mode = _tmp0_;
#line 481 "../src/window.vala"
	_tmp2_ = mode;
#line 481 "../src/window.vala"
	if (g_strcmp0 (_tmp2_, "Connecting") == 0) {
#line 481 "../src/window.vala"
		_tmp1_ = TRUE;
#line 2269 "window.c"
	} else {
		const gchar* _tmp3_;
#line 481 "../src/window.vala"
		_tmp3_ = mode;
#line 481 "../src/window.vala"
		_tmp1_ = g_strcmp0 (_tmp3_, "Connected") == 0;
#line 2276 "window.c"
	}
#line 481 "../src/window.vala"
	if (_tmp1_) {
#line 482 "../src/window.vala"
		haguichi_window_request_background (self, ____lambda136__gasync_ready_callback, g_object_ref (self));
#line 2282 "window.c"
	} else {
#line 490 "../src/window.vala"
		gtk_window_destroy ((GtkWindow*) self);
#line 2286 "window.c"
	}
#line 493 "../src/window.vala"
	result = TRUE;
#line 493 "../src/window.vala"
	_g_free0 (mode);
#line 493 "../src/window.vala"
	return result;
#line 2294 "window.c"
}

static void
haguichi_window_request_background_data_free (gpointer _data)
{
	HaguichiWindowRequestBackgroundData* _data_;
	_data_ = _data;
#line 17 "../src/window.vala"
	_g_object_unref0 (_data_->self);
#line 17 "../src/window.vala"
	g_slice_free (HaguichiWindowRequestBackgroundData, _data_);
#line 2306 "window.c"
}

void
haguichi_window_request_background (HaguichiWindow* self,
                                    GAsyncReadyCallback _callback_,
                                    gpointer _user_data_)
{
	HaguichiWindowRequestBackgroundData* _data_;
	HaguichiWindow* _tmp0_;
#line 17 "../src/window.vala"
	g_return_if_fail (self != NULL);
#line 17 "../src/window.vala"
	_data_ = g_slice_new0 (HaguichiWindowRequestBackgroundData);
#line 17 "../src/window.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
#line 17 "../src/window.vala"
	g_task_set_task_data (_data_->_async_result, _data_, haguichi_window_request_background_data_free);
#line 17 "../src/window.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 17 "../src/window.vala"
	_data_->self = _tmp0_;
#line 17 "../src/window.vala"
	haguichi_window_request_background_co (_data_);
#line 2330 "window.c"
}

gboolean
haguichi_window_request_background_finish (HaguichiWindow* self,
                                           GAsyncResult* _res_)
{
	gboolean result;
	HaguichiWindowRequestBackgroundData* _data_;
#line 17 "../src/window.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
#line 17 "../src/window.vala"
	result = _data_->result;
#line 17 "../src/window.vala"
	return result;
#line 2345 "window.c"
}

static gpointer
_g_ptr_array_ref0 (gpointer self)
{
#line 504 "../src/window.vala"
	return self ? g_ptr_array_ref (self) : NULL;
#line 2353 "window.c"
}

static void
haguichi_window_request_background_ready (GObject* source_object,
                                          GAsyncResult* _res_,
                                          gpointer _user_data_)
{
	HaguichiWindowRequestBackgroundData* _data_;
#line 504 "../src/window.vala"
	_data_ = _user_data_;
#line 504 "../src/window.vala"
	_data_->_source_object_ = source_object;
#line 504 "../src/window.vala"
	_data_->_res_ = _res_;
#line 504 "../src/window.vala"
	haguichi_window_request_background_co (_data_);
#line 2370 "window.c"
}

static void
_vala_XdpParent_free (XdpParent* self)
{
#line 504 "../src/window.vala"
	g_boxed_free (xdp_parent_get_type (), self);
#line 2378 "window.c"
}

static gboolean
haguichi_window_request_background_co (HaguichiWindowRequestBackgroundData* _data_)
{
#line 496 "../src/window.vala"
	switch (_data_->_state_) {
#line 496 "../src/window.vala"
		case 0:
#line 2388 "window.c"
		goto _state_0;
#line 496 "../src/window.vala"
		case 1:
#line 2392 "window.c"
		goto _state_1;
		default:
#line 496 "../src/window.vala"
		g_assert_not_reached ();
#line 2397 "window.c"
	}
	_state_0:
#line 497 "../src/window.vala"
	_data_->_tmp0_ = xdp_parent_new_gtk ((GtkWindow*) _data_->self);
#line 497 "../src/window.vala"
	_data_->parent = _data_->_tmp0_;
#line 499 "../src/window.vala"
	_data_->_tmp1_ = g_ptr_array_new_full ((guint) 0, NULL);
#line 499 "../src/window.vala"
	_data_->command = _data_->_tmp1_;
#line 500 "../src/window.vala"
	g_ptr_array_add (_data_->command, CONFIG_APP_ID);
#line 501 "../src/window.vala"
	g_ptr_array_add (_data_->command, "--background");
#line 2412 "window.c"
	{
#line 504 "../src/window.vala"
		_data_->_tmp3_ = _data_->self->priv->portal;
#line 504 "../src/window.vala"
		_data_->_tmp4_ = _g_ptr_array_ref0 (_data_->command);
#line 504 "../src/window.vala"
		_data_->_state_ = 1;
#line 504 "../src/window.vala"
		xdp_portal_request_background (_data_->_tmp3_, _data_->parent, _ ("Haguichi will continue to run when its window is closed so that it can" \
" monitor the connection and send notifications."), _data_->_tmp4_, XDP_BACKGROUND_FLAG_NONE, NULL, haguichi_window_request_background_ready, _data_);
#line 504 "../src/window.vala"
		return FALSE;
#line 2424 "window.c"
		_state_1:
#line 504 "../src/window.vala"
		_data_->_tmp2_ = xdp_portal_request_background_finish (_data_->_tmp3_, _data_->_res_, &_data_->_inner_error0_);
#line 504 "../src/window.vala"
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 2430 "window.c"
			goto __catch0_g_error;
		}
#line 504 "../src/window.vala"
		_data_->result = _data_->_tmp2_;
#line 504 "../src/window.vala"
		_g_ptr_array_unref0 (_data_->command);
#line 504 "../src/window.vala"
		__vala_XdpParent_free0 (_data_->parent);
#line 504 "../src/window.vala"
		g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 504 "../src/window.vala"
		if (_data_->_state_ != 0) {
#line 504 "../src/window.vala"
			while (!g_task_get_completed (_data_->_async_result)) {
#line 504 "../src/window.vala"
				g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 2447 "window.c"
			}
		}
#line 504 "../src/window.vala"
		g_object_unref (_data_->_async_result);
#line 504 "../src/window.vala"
		return FALSE;
#line 2454 "window.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
#line 503 "../src/window.vala"
		_data_->e = _data_->_inner_error0_;
#line 503 "../src/window.vala"
		_data_->_inner_error0_ = NULL;
#line 512 "../src/window.vala"
		_data_->_tmp5_ = _data_->e;
#line 512 "../src/window.vala"
		_data_->_tmp6_ = _data_->_tmp5_->message;
#line 512 "../src/window.vala"
		g_critical ("window.vala:512: request_background: %s", _data_->_tmp6_);
#line 514 "../src/window.vala"
		_data_->result = TRUE;
#line 514 "../src/window.vala"
		_g_error_free0 (_data_->e);
#line 514 "../src/window.vala"
		_g_ptr_array_unref0 (_data_->command);
#line 514 "../src/window.vala"
		__vala_XdpParent_free0 (_data_->parent);
#line 514 "../src/window.vala"
		g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 514 "../src/window.vala"
		if (_data_->_state_ != 0) {
#line 514 "../src/window.vala"
			while (!g_task_get_completed (_data_->_async_result)) {
#line 514 "../src/window.vala"
				g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 2485 "window.c"
			}
		}
#line 514 "../src/window.vala"
		g_object_unref (_data_->_async_result);
#line 514 "../src/window.vala"
		return FALSE;
#line 2492 "window.c"
	}
	__finally0:
#line 503 "../src/window.vala"
	_g_ptr_array_unref0 (_data_->command);
#line 503 "../src/window.vala"
	__vala_XdpParent_free0 (_data_->parent);
#line 503 "../src/window.vala"
	g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error0_->message, g_quark_to_string (_data_->_inner_error0_->domain), _data_->_inner_error0_->code);
#line 503 "../src/window.vala"
	g_clear_error (&_data_->_inner_error0_);
#line 503 "../src/window.vala"
	g_object_unref (_data_->_async_result);
#line 503 "../src/window.vala"
	return FALSE;
#line 2507 "window.c"
}

static GObject *
haguichi_window_constructor (GType type,
                             guint n_construct_properties,
                             GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	HaguichiWindow * self;
#line 113 "../src/window.vala"
	parent_class = G_OBJECT_CLASS (haguichi_window_parent_class);
#line 113 "../src/window.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 113 "../src/window.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, HAGUICHI_TYPE_WINDOW, HaguichiWindow);
#line 114 "../src/window.vala"
	gtk_widget_class_install_action (G_TYPE_INSTANCE_GET_CLASS (self, gtk_widget_get_type (), GtkWidgetClass), "win.connect", NULL, (GtkWidgetActionActivateFunc) haguichi_window_connect_action);
#line 115 "../src/window.vala"
	gtk_widget_class_install_action (G_TYPE_INSTANCE_GET_CLASS (self, gtk_widget_get_type (), GtkWidgetClass), "win.disconnect", NULL, (GtkWidgetActionActivateFunc) haguichi_window_disconnect_action);
#line 116 "../src/window.vala"
	gtk_widget_class_install_action (G_TYPE_INSTANCE_GET_CLASS (self, gtk_widget_get_type (), GtkWidgetClass), "win.join-network", NULL, (GtkWidgetActionActivateFunc) haguichi_window_join_network_action);
#line 117 "../src/window.vala"
	gtk_widget_class_install_action (G_TYPE_INSTANCE_GET_CLASS (self, gtk_widget_get_type (), GtkWidgetClass), "win.create-network", NULL, (GtkWidgetActionActivateFunc) haguichi_window_create_network_action);
#line 118 "../src/window.vala"
	gtk_widget_class_install_action (G_TYPE_INSTANCE_GET_CLASS (self, gtk_widget_get_type (), GtkWidgetClass), "win.attach", NULL, (GtkWidgetActionActivateFunc) haguichi_window_attach_action);
#line 119 "../src/window.vala"
	gtk_widget_class_install_action (G_TYPE_INSTANCE_GET_CLASS (self, gtk_widget_get_type (), GtkWidgetClass), "win.attach-cancel", NULL, (GtkWidgetActionActivateFunc) haguichi_window_attach_cancel_action);
#line 120 "../src/window.vala"
	gtk_widget_class_install_action (G_TYPE_INSTANCE_GET_CLASS (self, gtk_widget_get_type (), GtkWidgetClass), "win.start-search", NULL, (GtkWidgetActionActivateFunc) haguichi_window_start_search_action);
#line 121 "../src/window.vala"
	gtk_widget_class_install_action (G_TYPE_INSTANCE_GET_CLASS (self, gtk_widget_get_type (), GtkWidgetClass), "win.refresh", NULL, (GtkWidgetActionActivateFunc) haguichi_window_refresh_action);
#line 122 "../src/window.vala"
	gtk_widget_class_install_action (G_TYPE_INSTANCE_GET_CLASS (self, gtk_widget_get_type (), GtkWidgetClass), "win.toggle-sidebar", NULL, (GtkWidgetActionActivateFunc) haguichi_window_toggle_sidebar_action);
#line 123 "../src/window.vala"
	gtk_widget_class_install_action (G_TYPE_INSTANCE_GET_CLASS (self, gtk_widget_get_type (), GtkWidgetClass), "win.cycle-mode", NULL, (GtkWidgetActionActivateFunc) haguichi_window_cycle_mode_action);
#line 124 "../src/window.vala"
	gtk_widget_class_install_action (G_TYPE_INSTANCE_GET_CLASS (self, gtk_widget_get_type (), GtkWidgetClass), "win.expand-all-networks", NULL, (GtkWidgetActionActivateFunc) haguichi_window_expand_all_networks_action);
#line 125 "../src/window.vala"
	gtk_widget_class_install_action (G_TYPE_INSTANCE_GET_CLASS (self, gtk_widget_get_type (), GtkWidgetClass), "win.collapse-all-networks", NULL, (GtkWidgetActionActivateFunc) haguichi_window_collapse_all_networks_action);
#line 126 "../src/window.vala"
	gtk_widget_class_install_action (G_TYPE_INSTANCE_GET_CLASS (self, gtk_widget_get_type (), GtkWidgetClass), "win.preferences", NULL, (GtkWidgetActionActivateFunc) haguichi_window_preferences_action);
#line 127 "../src/window.vala"
	gtk_widget_class_install_action (G_TYPE_INSTANCE_GET_CLASS (self, gtk_widget_get_type (), GtkWidgetClass), "win.shortcuts", NULL, (GtkWidgetActionActivateFunc) haguichi_window_shortcuts_action);
#line 128 "../src/window.vala"
	gtk_widget_class_install_action (G_TYPE_INSTANCE_GET_CLASS (self, gtk_widget_get_type (), GtkWidgetClass), "win.help", NULL, (GtkWidgetActionActivateFunc) haguichi_window_help_action);
#line 129 "../src/window.vala"
	gtk_widget_class_install_action (G_TYPE_INSTANCE_GET_CLASS (self, gtk_widget_get_type (), GtkWidgetClass), "win.info", NULL, (GtkWidgetActionActivateFunc) haguichi_window_info_action);
#line 130 "../src/window.vala"
	gtk_widget_class_install_action (G_TYPE_INSTANCE_GET_CLASS (self, gtk_widget_get_type (), GtkWidgetClass), "win.about", NULL, (GtkWidgetActionActivateFunc) haguichi_window_about_action);
#line 131 "../src/window.vala"
	gtk_widget_class_install_action (G_TYPE_INSTANCE_GET_CLASS (self, gtk_widget_get_type (), GtkWidgetClass), "win.quit", NULL, (GtkWidgetActionActivateFunc) haguichi_window_quit_action);
#line 113 "../src/window.vala"
	return obj;
#line 2562 "window.c"
}

static void
haguichi_window_class_init (HaguichiWindowClass * klass,
                            gpointer klass_data)
{
#line 17 "../src/window.vala"
	haguichi_window_parent_class = g_type_class_peek_parent (klass);
#line 17 "../src/window.vala"
	g_type_class_adjust_private_offset (klass, &HaguichiWindow_private_offset);
#line 17 "../src/window.vala"
	((GtkWidgetClass *) klass)->hide = (void (*) (GtkWidget*)) haguichi_window_real_hide;
#line 17 "../src/window.vala"
	((GtkWindowClass *) klass)->close_request = (gboolean (*) (GtkWindow*)) haguichi_window_real_close_request;
#line 17 "../src/window.vala"
	G_OBJECT_CLASS (klass)->constructor = haguichi_window_constructor;
#line 17 "../src/window.vala"
	G_OBJECT_CLASS (klass)->finalize = haguichi_window_finalize;
#line 17 "../src/window.vala"
	gtk_widget_class_set_template_from_resource (GTK_WIDGET_CLASS (klass), "/com/github/ztefn/haguichi/ui/window.ui");
#line 17 "../src/window.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "toast_overlay", FALSE, HaguichiWindow_private_offset + G_STRUCT_OFFSET (HaguichiWindowPrivate, toast_overlay));
#line 17 "../src/window.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "split_view", FALSE, G_STRUCT_OFFSET (HaguichiWindow, split_view));
#line 17 "../src/window.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "window_title", FALSE, G_STRUCT_OFFSET (HaguichiWindow, window_title));
#line 17 "../src/window.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "not_installed_status_page", FALSE, G_STRUCT_OFFSET (HaguichiWindow, not_installed_status_page));
#line 17 "../src/window.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "sidebar", FALSE, G_STRUCT_OFFSET (HaguichiWindow, sidebar));
#line 17 "../src/window.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "network_list", FALSE, G_STRUCT_OFFSET (HaguichiWindow, network_list));
#line 17 "../src/window.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "refresh_button", FALSE, HaguichiWindow_private_offset + G_STRUCT_OFFSET (HaguichiWindowPrivate, refresh_button));
#line 17 "../src/window.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "connect_button", FALSE, G_STRUCT_OFFSET (HaguichiWindow, connect_button));
#line 17 "../src/window.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "disconnect_button", FALSE, G_STRUCT_OFFSET (HaguichiWindow, disconnect_button));
#line 17 "../src/window.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "search_button", FALSE, G_STRUCT_OFFSET (HaguichiWindow, search_button));
#line 17 "../src/window.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "search_bar", FALSE, G_STRUCT_OFFSET (HaguichiWindow, search_bar));
#line 17 "../src/window.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "search_entry", FALSE, G_STRUCT_OFFSET (HaguichiWindow, search_entry));
#line 17 "../src/window.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "stack", FALSE, G_STRUCT_OFFSET (HaguichiWindow, stack));
#line 17 "../src/window.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "connected_stack", FALSE, G_STRUCT_OFFSET (HaguichiWindow, connected_stack));
#line 17 "../src/window.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "throbber", FALSE, G_STRUCT_OFFSET (HaguichiWindow, throbber));
#line 17 "../src/window.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "configure_button", FALSE, HaguichiWindow_private_offset + G_STRUCT_OFFSET (HaguichiWindowPrivate, configure_button));
#line 17 "../src/window.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "overlay_refresh_button", FALSE, HaguichiWindow_private_offset + G_STRUCT_OFFSET (HaguichiWindowPrivate, overlay_refresh_button));
#line 17 "../src/window.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "overlay_add_network_button", FALSE, HaguichiWindow_private_offset + G_STRUCT_OFFSET (HaguichiWindowPrivate, overlay_add_network_button));
#line 17 "../src/window.vala"
	gtk_widget_class_bind_template_callback_full (GTK_WIDGET_CLASS (klass), "download_hamachi", G_CALLBACK(_haguichi_window_download_hamachi_gtk_button_clicked));
#line 17 "../src/window.vala"
	gtk_widget_class_bind_template_callback_full (GTK_WIDGET_CLASS (klass), "configure_hamachi", G_CALLBACK(_haguichi_window_configure_hamachi_gtk_button_clicked));
#line 17 "../src/window.vala"
	gtk_widget_class_bind_template_callback_full (GTK_WIDGET_CLASS (klass), "go_back_button_clicked", G_CALLBACK(_haguichi_window_go_back_button_clicked_gtk_button_clicked));
#line 2625 "window.c"
}

static void
haguichi_window_instance_init (HaguichiWindow * self,
                               gpointer klass)
{
	XdpPortal* _tmp0_;
#line 17 "../src/window.vala"
	self->priv = haguichi_window_get_instance_private (self);
#line 59 "../src/window.vala"
	_tmp0_ = xdp_portal_new ();
#line 59 "../src/window.vala"
	self->priv->portal = _tmp0_;
#line 17 "../src/window.vala"
	g_type_ensure (HAGUICHI_TYPE_SIDEBAR);
#line 17 "../src/window.vala"
	g_type_ensure (HAGUICHI_TYPE_NETWORK_LIST);
#line 17 "../src/window.vala"
	g_type_ensure (HAGUICHI_TYPE_THROBBER);
#line 17 "../src/window.vala"
	gtk_widget_init_template (GTK_WIDGET (self));
#line 2647 "window.c"
}

static void
haguichi_window_finalize (GObject * obj)
{
	HaguichiWindow * self;
#line 17 "../src/window.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, HAGUICHI_TYPE_WINDOW, HaguichiWindow);
#line 59 "../src/window.vala"
	_g_object_unref0 (self->priv->portal);
#line 61 "../src/window.vala"
	_g_object_unref0 (self->modal_dialog);
#line 17 "../src/window.vala"
	G_OBJECT_CLASS (haguichi_window_parent_class)->finalize (obj);
#line 2662 "window.c"
}

static GType
haguichi_window_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (HaguichiWindowClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) haguichi_window_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (HaguichiWindow), 0, (GInstanceInitFunc) haguichi_window_instance_init, NULL };
	GType haguichi_window_type_id;
	haguichi_window_type_id = g_type_register_static (adw_application_window_get_type (), "HaguichiWindow", &g_define_type_info, 0);
	HaguichiWindow_private_offset = g_type_add_instance_private (haguichi_window_type_id, sizeof (HaguichiWindowPrivate));
	return haguichi_window_type_id;
}

GType
haguichi_window_get_type (void)
{
	static volatile gsize haguichi_window_type_id__once = 0;
	if (g_once_init_enter (&haguichi_window_type_id__once)) {
		GType haguichi_window_type_id;
		haguichi_window_type_id = haguichi_window_get_type_once ();
		g_once_init_leave (&haguichi_window_type_id__once, haguichi_window_type_id);
	}
	return haguichi_window_type_id__once;
}

static gssize
_vala_array_length (gpointer array)
{
	gssize length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}

static inline gpointer
_vala_memdup2 (gconstpointer mem,
               gsize byte_size)
{
	gpointer new_mem;
	if (mem && byte_size != 0) {
		new_mem = g_malloc (byte_size);
		memcpy (new_mem, mem, byte_size);
	} else {
		new_mem = NULL;
	}
	return new_mem;
}

